#ifndef _query_add_h_
#define _query_add_h_

#include "types.h"
#include "error.h"
#include "sequence.h"
#include "read.h"
#include "attrt_list.h"
#include "modify.h"


/*
 *	Add request result structure
 */

typedef struct _add_result
{
  QBool was_successful;
  errorList errors;

  char *baseobject;
} add_result, *addResult;

#define NULLAddResult (addResult) NULL
#define add_result_alloc() (addResult) smalloc(sizeof(add_result))

/*
 *	Add request record
 */

typedef struct _add_rec
{
  QCardinal request_id;
  QCardinal sub_request_id;

  int task_id;

  char *baseobject;
  modifyAttr add_attr_list;

  AttributeType rdn_type;
  char *ufn;

  addResult result;
} add_rec, *addRec;

#define NULLAddRec (addRec) NULL
#define add_rec_alloc() (addRec) smalloc(sizeof(add_rec))


/*
 *	Public procedures
 */

errorList do_add();
addResult get_add_result();

void free_add_result(), free_add_rec();

request_state process_add_resolve_result();
request_state process_add_ds_result(), process_add_ds_error();


#endif _query_add_h_

