#ifndef _query_delete_h_
#define _query_delete_h_

#include "types.h"
#include "error.h"
#include "sequence.h"
#include "attrt_list.h"
#include "modify.h"


/*
 *	Delete request result structure
 */

typedef struct _delete_result
{
  QBool was_successful;
  errorList errors;
} delete_result, *deleteResult;

#define NULLDeleteResult (deleteResult) NULL
#define delete_result_alloc() (deleteResult) smalloc(sizeof(delete_result))


/*
 *	Delete request record
 */

typedef struct _delete_rec
{
  QCardinal request_id;
  int task_id;
  
  char *delete_object;

  deleteResult result;
} delete_rec, *deleteRec;

#define NULLDeleteRec (deleteRec) NULL
#define delete_rec_alloc() (deleteRec) smalloc(sizeof(delete_rec))

/*
 *	Public procdures
 */

errorList do_delete();
deleteResult get_delete_result();

void free_delete_result(), free_delete_rec();

request_state process_delete_ds_result(), process_delete_ds_error();

#endif _query_delete_h_
