/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/query_engine/RCS/read.h,v 0.95 91/09/02 11:34:42 emsrdsm Exp Locker: emsrdsm $ */

#ifndef _query_read_h_
#define _query_read_h_

#include "types.h"
#include "error.h"
#include "sequence.h"

typedef struct _photo_data
{
  int width;
  int height;

  unsigned char *bytes;
} *photoData;

#define NULLPhotoData (photoData) NULL


typedef struct _audio_data
{
  int length;
  unsigned char *bytes;
} *audioData;

#define NULLAudioData (audioData) NULL


typedef struct _attr_val_list
{
  stringCell attr_name;
  
  int syntax;

  stringCell val_list;

  union
    {
      photoData photo;
      audioData audio;
    }
  data;

  struct _attr_val_list *next;
} attr_val_list, *attrValList;

#define NULLAVList (attrValList) NULL
#define av_list_alloc() (attrValList) smalloc(sizeof(attr_val_list))


typedef struct _read_results
{
  char *base_object;
  attrValList entry;
  errorList errors;
} read_results, *readResults;

#define NULLReadResults (readResults) NULL
#define read_res_alloc() (readResults) smalloc(sizeof(read_results))


typedef struct _read_rec
{
  QCardinal request_id;

  char *base_object;

  int task_id;

  readResults results;
} read_rec, *readRec;

#define NULLReadRec (readRec) NULL
#define read_rec_alloc() (readRec) smalloc(sizeof(read_rec))


/*
 *	Procs
 */

QE_error_code do_read();

request_state process_read_ds_result(),
	      process_read_ds_error();

readResults get_read_results();

void read_rec_free(), read_result_free();

int photo2xbm(), audio2bytes();

#endif
