#ifndef _query_rename_h_
#define _query_rename_h_

#include "types.h"
#include "error.h"
#include "sequence.h"
#include "read.h"
#include "attrt_list.h"

#include "modify.h"


/*
 *	Data types...
 */

typedef enum
{
  RN_init,
  RN_resolve,
  RN_read,
  RN_delete,
  RN_add,
  RN_modify_rdn,
  RN_complete
} renameStatus;


typedef enum
{
  ResolveFailed,
  ResolveError,
  ReadFailed,
  AddFailed,
  DeleteFailed,
  ModifyRDNFailed,
  RenameSuccessful
} renameRequestStatus;


/*
 *	Rename result structure
 */

typedef struct _rename_result
{
  QBool was_successful;
  errorList errors;
  
  renameRequestStatus status;
  char *updated_object;
} rename_result, *renameResult;

#define NULLRenameResult (renameResult) NULL
#define rename_result_alloc() (renameResult) smalloc(sizeof(rename_result))

/*
 *	Rename request record
 */

typedef struct _rename_rec
{
  QCardinal request_id;
  QCardinal sub_request_id;

  int task_id;
  
  char *baseobject;
  char *new_name;
  char *new_baseobject;

  modifyAttr entry_attrs;

  renameStatus status;
  renameResult result;
} rename_rec, *renameRec;

#define NULLRenameRec (renameRec) NULL
#define rename_rec_alloc() (renameRec) smalloc(sizeof(rename_rec))

/*
 *	Public procs
 */

errorList do_rename();
renameResult get_rename_result();

void free_rename_rec(), free_rename_result();

request_state process_rename_ds_result(), process_rename_ds_error();
request_state process_rename_request_result();

#endif


