/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/query_engine/RCS/request.h,v 0.95 91/09/02 11:34:52 emsrdsm Exp Locker: emsrdsm $ */

#ifndef _query_request_h_
#define _query_request_h_

#include "types.h"
#include "error.h"
#include "ufname.h"
#include "ufsearch.h"
#include "modify.h"
#include "read.h"
#include "delete.h"
#include "add.h"
#include "update.h"
#include "rename.h"

#define MAXREQUESTS 64

/*
 *	Request type identifier
 */
typedef enum
{
  DS_READ,
  DS_SEARCH,
  UFNAME,
  UFSEARCH,
  ENTRY_TEMPLATE,
  MODIFY_ENTRY,
  RENAME_ENTRY,
  MODIFY_RDN,
  DELETE_ENTRY,
  ADD_ENTRY,
  UPDATE_ENTRY
} request_type;

/*
 *	Generic request record
 */
typedef struct _request_rec
{
  request_type type;
  QCardinal request_id;

  request_state status;
  errorList errors;

  QBool is_sub_request;
  QCardinal owner_request_id;

  struct _request_rec *next;
  struct _request_rec *prev;
  
  union
    {
      addRec add_request;
      readRec read_request;
      modifyRec modify_request;
      deleteRec delete_request;
      renameRec rename_request;
      updateRec update_request;
      ufnameRec ufname_request;
      ufsearchRec ufsearch_request;
      makeTemplateRec template_request;
    } req_type_rec;

#define ADD_REC req_type_rec.add_request
#define READ_REC req_type_rec.read_request
#define MODIFY_REC req_type_rec.modify_request
#define DELETE_REC req_type_rec.delete_request
#define RENAME_REC req_type_rec.rename_request
#define UPDATE_REC req_type_rec.update_request
#define UFNAME_REC req_type_rec.ufname_request
#define UFSEARCH_REC req_type_rec.ufsearch_request
#define TEMPLATE_REC req_type_rec.template_request

} request_rec, *requestRec;

#define NULLReqRec (requestRec) NULL
#define request_rec_alloc() (requestRec) smalloc(sizeof(request_rec))


/*
 *	Procedures
 */

QE_error_code _request_invoked();
void _request_complete();

void directory_wait();
void abort_request(), tag_as_sub_request();

requestRec _get_request_of_id();

#endif _query_request_h_
