#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/actions.c,v 0.95 91/09/02 11:35:49 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/actions.c,v 0.95 91/09/02 11:35:49 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  actions.c - Functions to collate and manage actions associated with windows.

*****************************************************************************/

#include <X11/Intrinsic.h>

#include "defs.h"
#include "windows.h"
#include "actions.h"
#include "objects.h"
#include "layout.h"


Cardinal action_number = 0;
objectAction actions[MAXACTIONS];

/*
 *	Externals....
 */

extern Display *dpy;
extern windowObject win_objects[];
extern windowTemplate win_templates[];

void doAbortRequest();

/*
 *	Local procs...
 */
static void do_primitive_sensitivity();



/*
 * - findOutputObject() -
 *
 *
 */
Widget findOutputObject(originator_id, output_template_id, mode, output_id_ptr)
     Cardinal originator_id;
     Cardinal output_template_id;
     outputMode mode;
     Cardinal *output_id_ptr;
{
  Widget output_shell;

  switch (mode)
    {
    case NewWhenKeptLocal:

      *output_id_ptr = find_unkept_child(originator_id, output_template_id);

      if (*output_id_ptr < MAXWINDOWS)
	{
	  output_shell = win_objects[*output_id_ptr]->parent_shell;
	  XRaiseWindow(dpy, XtWindow(output_shell));
	}
      else
	{
	  output_shell = make_object(output_template_id,
				     NULLWidget,
				     &originator_id,
				     output_id_ptr);

	  XtRealizeWidget(output_shell);
	  XtPopup(output_shell, XtGrabNone);
	}

      break;

    case NewWhenKeptGlobal:

      *output_id_ptr = find_unkept_object(output_template_id);

      if (*output_id_ptr < MAXWINDOWS)
	{
	  output_shell = win_objects[*output_id_ptr]->parent_shell;
	  XRaiseWindow(dpy, XtWindow(output_shell));
	}
      else
	{
	  output_shell = make_object(output_template_id,
				     NULLWidget,
				     &originator_id,
				     output_id_ptr);

	  XtRealizeWidget(output_shell);
	  XtPopup(output_shell, XtGrabNone);
	}

      break;

    case NewWhenNone:

      /* ## To do ## */
      break;
      
    case CurrentWin:

      *output_id_ptr = originator_id;
      output_shell = win_objects[*output_id_ptr]->parent_shell;

      XRaiseWindow(dpy, XtWindow(output_shell));

      break;

    case NewAlways:

      output_shell = make_object (output_template_id,
				  NULLWidget,
				  &originator_id,
				  output_id_ptr);

      XtRealizeWidget(output_shell);
      XtPopup(output_shell, XtGrabNone);

      break;
    }


  doPrimitiveSensitivity(*output_id_ptr);


  /*
   *	If there are requests outstanding then abandon these
   */

  doAbortRequest(NULLWidget, *output_id_ptr,0, ActionUndefined, NULLTransList);

  return output_shell;
} /* findOutputObject */

/*
 * - doPrimitiveSensitivity() -
 * 
 *
 */
void doPrimitiveSensitivity(object_id)
     Cardinal object_id;
{
  windowObject this_object = win_objects[object_id];
  WidgetTree curr_widget = this_object->widget_layout->descendants;
  layoutMember curr_member = win_templates[this_object->template_id]->layout;
  char object_state = 0;

  if (isWaiting(object_id) == TRUE)
    object_state = I_DS_WAIT;
  else
    object_state = I_NORMAL;
  
  if (this_object->current_entry == NULLCP ||
      *this_object->current_entry == '\0')
    object_state = object_state | I_NO_ENTRY;

  if (this_object->current_list == NULLEntryList)
    object_state = object_state | I_NO_LIST;

  if (this_object->current_errors == NULLError)
    object_state = object_state | I_NO_ERROR;
  
  do_primitive_sensitivity(curr_member, curr_widget, object_state);
} /* doPrimitiveSensitivity */


static void do_primitive_sensitivity(curr_member, curr_widget, object_state)
     layoutMember curr_member;
     WidgetTree curr_widget;
     char object_state;
{
  char insensitivity;
  Widget prim_widget;

  while (curr_member != NULLLayout)
    {
      switch (curr_member->type)
	{
	case REF_layout:
	  
	  do_primitive_sensitivity
	    (win_templates[curr_member->reference.layout_ref_id]->layout,
	     curr_widget->descendants,
	     object_state);
	  
	  break;

	case REF_primitive:
	  
	  prim_widget = curr_widget->this_widget;
	  insensitivity = curr_member->insensitivity;
	  
	  if ((insensitivity & object_state) != 0)
	    {
	      if (XtIsSensitive(prim_widget) == TRUE) 
		XtSetSensitive(prim_widget, FALSE);
	    }
	  else
	    {
	      if (XtIsSensitive(prim_widget) == FALSE)
		XtSetSensitive(prim_widget, TRUE);
	    }
	  
	  break;
	}

      curr_member = curr_member->next_layout;
      curr_widget = curr_widget->left_siblings;
    }
} /* do_primitive_sensitivity */



