#ifndef _lookup_actions_h_
#define _lookup_actions_h_

#include <X11/Intrinsic.h>

#include "defs.h"
#include "windows.h"

#define MAXACTIONS 1024

typedef int actionID;

#define ActionUndefined -1
#define IsActionUndefined(a) (a == -1)

typedef enum
{
  CurrentWin,
  NewAlways,
  NewWhenNone,
  NewWhenKeptGlobal,
  NewWhenKeptLocal
} outputMode;


typedef enum
{
  AT_One,
  AT_Many,
  AT_RaiseObject,
  AT_CloseObject,
  AT_KeepObject,
  AT_EntrySelect,
  AT_Activate,
  AT_QuitApp,
  AT_AbortRequest,
  AT_Undefined
} actionType;


typedef struct _translation
{
  actionType type;
  outputMode mode;

  XtPointer param;
  String trans_name;
  
  Cardinal template1_id;
  Cardinal template2_id;

  struct _translation *next;
} translation, *translationList;

#define trans_alloc() (translationList) XtMalloc(sizeof(translation))
#define NULLTransList (translationList) NULL


typedef struct _object_action
{
  String action_name;
  translationList to_do;
} object_action, *objectAction;

#define action_alloc() (objectAction) XtMalloc(sizeof(object_action))
#define NULLAction (objectAction) NULL


Widget findOutputObject();
void doPrimitiveSensitivity();

#endif _lookup_actions_h_

