#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/callbacks.c,v 0.95 91/09/02 11:35:54 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header */

/*****************************************************************************

  callbacks.c - 

*****************************************************************************/

#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/Form.h>
#include <X11/Command.h>
#include <X11/Viewport.h>
#include <X11/AsciiText.h>
#include <X11/ListP.h>
#include <X11/List.h>

#include "query.h"

#include "defs.h"
#include "windows.h"
#include "widgets.h"
#include "objects.h"
#include "requests.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"

#include "list_display.h"
#include "read_display.h"
#include "modify_form.h"
#include "search_form.h"
#include "status_bar.h"
#include "error_view.h"

#include "xdutil.h"


/*
 *	Local procs.....
 */
static void doQuitAction();
static void doKeepAction(), doCloseAction(), doActivateAction();

static void doMovetoAction();

/*
 *	Abort can be called externally
 */

void doAbortRequest();


/*
 *	Externals....
 */

extern objectAction actions[];
extern Cardinal action_number; 

extern windowObject win_objects[];

extern Display *dpy;

void exit();



/*
 * - doAction() -
 * Do general work then call primitive specific action.
 *
 */
/* ARGSUSED */
void doAction(this_widget, event, params, num_params)
     Widget this_widget;
     XEvent *event;
     String *params;
     Cardinal num_params;
{
  actionID action_id;
  Cardinal object_id, prim_id;
  translationList trans_list;
  layoutMember this_template;
  Widget prim_toplevel;
  objectAction this_action;

  String param1 = params[0];
  String param2 = params[1];
  String param3 = params[2];


  /* Get object identifier and type of primitive calling action */

  object_id = (Cardinal) strtol(param1, (char **) NULL, 10);
  prim_id = (Cardinal) strtol(param2, (char **) NULL, 10);
  action_id = (actionID) strtol(param3, (char **) NULL, 10);

  switch (prim_id)
    {
    case MOVETO:
    case ENTRY_LIST:
    case LOOKUP:
      
      prim_toplevel = XtParent(this_widget);
      break;

    case READ_OUT:
      
      prim_toplevel = XtParent(XtParent(this_widget));
      break;

    default:

      prim_toplevel = this_widget;

    }

  /* Verify template and action_id */
  this_template = find_prim_member(object_id, prim_id, prim_toplevel);
  
  if (this_template == NULLLayout)
    {
      setStatusMessage(object_id,
		      "Internal problem! Cannot perform required function!\n");
      return;
    }

  if (IsActionUndefined(action_id))
    {
      setStatusMessage(object_id, "Action undefined!\n");
      return;
    }

  if ((this_action = actions[action_id]) == NULLAction)
    {
      setStatusMessage(object_id, "Action undefined!\n");
      return;
    }

  trans_list = this_action->to_do;

  doActionAux(this_widget, object_id, prim_id, action_id, trans_list);
} /* doAction */

void doActionAux(prim_widget, object_id, prim_id, action_id, trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  translationList curr_trans;
  Cardinal output_id, count;
  windowObject this_object;
  XawListReturnStruct *list_entry;
  entryList current_list;

  this_object = win_objects[object_id];

  doPrimitiveSensitivity(object_id);


  for (curr_trans = trans_list;
       curr_trans != NULLTransList;
       curr_trans = curr_trans->next)
    {
      switch (prim_id)
	{
	case ENTRY_LIST:
	case MOVETO:
	case LOOKUP:
	case BUTTON:
	case READ_OUT:

	  switch (curr_trans->type)
	    {
	    case AT_CloseObject:
	      doCloseAction(object_id, action_id, prim_widget);
	      break;
	      

	    case AT_KeepObject:
	      doKeepAction(object_id, action_id, prim_widget);
	      break;
	      

	    case AT_QuitApp:
	      doQuitAction(object_id, action_id, prim_widget);
	      break;
	      

	    case AT_RaiseObject:
	      (void) findOutputObject(object_id,
				      curr_trans->template1_id,
				      curr_trans->mode,
				      &output_id);

	      if (prim_id == ENTRY_LIST)
		{
		  list_entry = XawListShowCurrent(prim_widget);

		  if (list_entry->list_index == XAW_LIST_NONE)
		    break;
		  
		  for (count = 0, current_list = this_object->current_list;
		       count < list_entry->list_index;
		       count++, current_list = current_list->next)
		    ;
		  
		  set_current_entry(output_id, current_list->string_dn);

		  XtFree((char *) list_entry);
		}
	      else if (output_id != object_id)
		set_current_entry(output_id, this_object->current_entry);

	      if (output_id != object_id)
		{
		  set_current_errors(output_id, this_object->current_errors);
		  set_current_list(output_id, this_object->current_list);
		}

	      displayCurrentList(output_id);
		  
	      updateErrorViewer(output_id);

	      displayEntryTemplate(NULLWidget,
				   output_id,
				   prim_id,
				   0,
				   NULLTransList);
	      
	      displayCurrentEntry(NULLWidget,
				  output_id,
				  prim_id,
				  0,
				  NULLTransList);

	      doPrimitiveSensitivity(output_id);

	      break;


	    case AT_Activate:

	      doActivateAction(prim_widget,
			       object_id,
			       prim_id,
			       action_id,
			       curr_trans);
	      
	      doPrimitiveSensitivity(object_id);
	      
	      return;


	    case AT_AbortRequest:

	      doAbortRequest(prim_widget,
			     object_id,
			     prim_id,
			     action_id,
			     curr_trans);
	      
	      doPrimitiveSensitivity(object_id);

	      return;
	    }
	}
    }
} /* doActionAux */


/*
 * - doMovetoAction() -
 *
 */
/* ARGSUSED */
static void doMovetoAction(prim_widget,
			   object_id,
			   prim_id,
			   action_id,
			   trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  Arg args[MAXARGS];
  Cardinal count;
  Cardinal request_id;
  QE_error_code srch_state;
  Widget dialog;
  String ufnval;
  
  dialog = XtNameToWidget(prim_widget, "movetoDialog");

  count = 0;
  XtSetArg(args[count], XtNstring, &ufnval); count++;
  XtGetValues(dialog, args, count);

  srch_state = do_ufn_resolve(NULLEntryList, ufnval, unknown, &request_id);

  XawAsciiSourceFreeString(dialog);

  switch (srch_state)
    {
    case QERR_bad_value_syntax:
      XBell(dpy, 40);
      setStatusMessage(object_id, "The entry name entered is invalid!");

      doActionAux(prim_widget,object_id, prim_id, action_id, trans_list->next);

      return;
      
    case QERR_internal_limit_reached:
      XBell(dpy, 40);
      setStatusMessage(object_id, "Internal limit reached, cannot search!");

      doActionAux(prim_widget,object_id, prim_id, action_id, trans_list->next);

      return;
    }

  setStatusMessage(object_id, "Searching. Please Wait.");

  request_invoked(request_id,
		  UFNAME,
		  prim_widget,
		  object_id,
		  prim_id,
		  action_id,
		  trans_list);
} /* doMovetoAction */

/*
 * - gotMovetoReport() -
 *
 *
 */
void gotMovetoReport(request_id, object_id)
     Cardinal request_id, object_id;
{
  char msg[LINESIZE];

  ufnReport report = get_ufn_report(request_id);

  if (report->type == UFN_MadeMatches)
    {
      if (report->hit_num == 1)
	(void) sprintf(msg,
		       "Matched `%s'. Continuing...",
		       report->just_resolved);
      else
	(void) sprintf(msg,
		       "Made %d matches against `%s'. Continuing...",
		       report->hit_num,
		       report->just_resolved);

      setStatusMessage(object_id, msg);
    }
    
  ufname_report_free(&report);
} /* gotMovetoReport */

/*
 * - gotMovetoResults() -
 *
 *
 */
/* ARGSUSED */
void gotMovetoResults(request_id, object_id, action_id, trans_list)
     Cardinal request_id, object_id;
     actionID action_id;
     translationList trans_list;
{
  ufnResults results;
  Cardinal child_id, child_template_id, err_num;
  actionType action_type;
  outputMode output_mode;
  char status_message[LINESIZE], status_buf[LINESIZE];
  errorList errors;

  /*
   *	Notify the user
   */

  setStatusMessage(object_id, "Results received.");
  XBell(dpy, 40);
  

  results = get_ufn_results(request_id);

  /*
   * Will have to change this if poor matches are to be queried
   */
  _request_complete(request_id);

  /*
   *	Work out the error situation
   */
  
  for (err_num = 0, errors = results->errors;
       errors != NULLError;
       errors = errors->next, err_num++)
    ;

  set_current_errors(object_id, results->errors);

  if (err_num > 0)
    updateErrorViewer(object_id);


  if (results->match_num == 0 || results->match_status != GoodMatches)
    {
      XBell(dpy, 40);

      if (err_num > 0)
	(void) strcpy(status_message, "Match Failed!");
      else
	(void) strcpy(status_message, "Nothing found!");
    }
  else
    for (;
	 trans_list != NULLTransList;
	 trans_list = trans_list->next)
      {
	action_type = trans_list->type;
	
	if (action_type == AT_Activate && results->match_num == 1)
	  {
	    child_template_id = trans_list->template1_id;
	    output_mode = trans_list->mode;

	    (void) findOutputObject(object_id,
				    child_template_id,
				    output_mode,
				    &child_id);

	    (void) strcpy(status_message, "Made 1 good match");

	    set_current_entry(child_id, results->matches->string_dn);

	    displayEntryTemplate(NULLWidget, child_id, 0, 0, NULLTransList);

	    displayCurrentEntry(NULLWidget, child_id, 0, 0, NULLTransList);

	    doPrimitiveSensitivity(child_id);
	  }
	else
	  {
	    if (action_type == AT_Activate && results->match_num > 1)
	      {
		child_template_id = trans_list->template2_id;
		output_mode = trans_list->mode;

		(void) findOutputObject(object_id,
					child_template_id,
					output_mode,
					&child_id);

		(void) sprintf(status_message,
			       "Made %d good matches",
			       results->match_num);

		set_current_list(child_id, results->matches);

		displayCurrentList(child_id);
	  
		doPrimitiveSensitivity(child_id);
	      }
	  }
      }
  
  switch (err_num)
    {
    case 0:
      break;
      
    case 1:

      (void) strcat(status_message, "\n1 Error Occurred During Search");
      break;

    default:
      
      (void) sprintf(status_buf, "\n%d Errors Occurred During Search",err_num);
      (void) strcat(status_message, status_buf);
    }
  
  setStatusMessage(object_id, status_message);
		
  request_complete(request_id);

  ufname_result_free(&results);
} /* gotMovetoResults */

/*
 *
 *
 */
/* ARGSUSED */
static void doQuitAction(object_id, action_id, this_widget)
  Cardinal object_id;
  actionID action_id;
  Widget this_widget;
{
  extern Widget toplevel;

  XtUnmapWidget(toplevel);
  XtDestroyWidget(toplevel);

  exit(0);
} /* doQuitAction */

/*
 *
 *
 */
/* ARGSUSED */
static void doCloseAction(object_id, action_id, this_widget)
  Cardinal object_id;
  actionID action_id;
  Widget this_widget;
{
  delete_win_object(object_id);
} /* doCloseAction */

/*
 *
 *
 */
/* ARGSUSED */
static void doKeepAction(object_id, action_id, this_widget)
  Cardinal object_id;
  actionID action_id;
  Widget this_widget;
{
  windowObject object = win_objects[object_id];

  object->is_kept = TRUE;
  
  setStatusMessage(object_id, "Window kept");
} /* doKeepAction */


/*
 * - doActivatAction() -
 *
 *
 */
/* ARGSUSED */
static void doActivateAction(prim_widget,
			     object_id,
			     prim_id,
			     action_id,
			     trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  Widget *instances;
  layoutMember prim_member;
  Cardinal to_activate_id = (Cardinal) trans_list->param;
  
  switch (to_activate_id)
    {
    case READ_OUT:
      instances = find_prim_instances(object_id, READ_OUT);
      
      if (instances == (Widget *) NULL)
	doActionAux(prim_widget,
		    object_id,
		    prim_id,
		    action_id,
		    trans_list->next);
      else
	{
          if (IsActionUndefined(action_id))
            {
              xluWarning("User action undefined!\n");
	      XtFree((char *) instances);

              return;
            }

          if (lexequ("seealso", trans_list->trans_name) == 0)
            doSeeAlsoAction(prim_widget,
                            object_id,
                            prim_id,
                            action_id,
                            trans_list);
	  
	  XtFree((char *) instances);
        }

      return;

    case LOOKUP:
      instances = find_prim_instances(object_id, LOOKUP);

      if (instances == (Widget *) NULL)
	  doActionAux(prim_widget,
		      object_id,
		      prim_id,
		      action_id,
		      trans_list->next);
      else
	{
	  prim_member = find_prim_member(object_id, LOOKUP, instances[0]);

	  if (IsActionUndefined(prim_member->action_list->prim_action_id))
	    {
	      xluWarning("User action undefined!");
	      XtFree((char *) instances);

	      return;
	    }

	  doLookupAction(instances[0],
			 object_id,
			 prim_id,
			 action_id,
			 trans_list);

	  XtFree((char *) instances);
	}
      
      return;

    case MOVETO:
      instances = find_prim_instances(object_id, MOVETO);
      
      if (instances == (Widget *) NULL)
	  doActionAux(prim_widget,
		      object_id,
		      prim_id,
		      action_id,
		      trans_list->next);
      else
	{
	  prim_member = find_prim_member(object_id, MOVETO, instances[0]);

	  if (IsActionUndefined(prim_member->action_list->prim_action_id))
	    {
	      xluWarning("User action undefined!");
	      XtFree((char *) instances);

	      return;
	    }

	  doMovetoAction(instances[0],
			 object_id,
			 prim_id,
			 action_id,
			 trans_list);

	  XtFree((char *) instances);
	}

      return;
    }
} /* doActivateAction */


/*
 * - doAbortRequest() -
 *
 *
 */
void doAbortRequest(prim_widget,
		    object_id,
		    prim_id,
		    action_id,
		    trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  assocRec this_request;
  extern assocRec request_list;

  for (this_request = request_list;
       this_request != NULLAssocRec;
       this_request = this_request->next)
    /*
     *	Find the ids of request issued from this object
     *  and abort them
     *
     */
    if (this_request->object_id == object_id)
      {
	abort_request(this_request->request_id);
	setStatusMessage(object_id, "Request aborted!");

	request_complete(this_request->request_id);
      }

  doActionAux(prim_widget,
	      object_id,
	      prim_id,
	      action_id,
	      trans_list == NULLTransList ? trans_list:trans_list->next);
}

/*
 * - FreePrimInfo() -
 *
 *
 */
/* ARGSUSED */
void FreePrimInfo(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  primInfo prim_data = (primInfo) closure;

  free((char *) prim_data);
} /* FreePrimInfo */

/*
 * - FreeBackgroundPixmap() -
 *
 *
 */
/* ARGSUSED */
void FreeBackgroundPixmap(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  Arg args[MAXARGS];
  Pixmap pixmap;

  XtSetArg(args[0], XtNbackgroundPixmap, &pixmap);
  XtGetValues(w, args, 1);
  
  if (pixmap == XtUnspecifiedPixmap)
    return;

  XFreePixmap(dpy, pixmap);
} /* FreeBackgroundPixmap */
