#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/RCS/configure.c,v 0.95 91/09/03 13:51:46 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/RCS/configure.c,v 0.95 91/09/03 13:51:46 emsrdsm Exp Locker: emsrdsm $ */

/******************************************************************************

  configure.c - Read screen configure file and build templates

*****************************************************************************/

#include "logger.h"
#include "sequence.h"

#include "layout.h"
#include "configure.h"
#include "actions.h"
#include "xdutil.h"
#include "dn_list.h"
#include "attrt_list.h"

#include "defs.h"

#include "y.tab.h"

#include "tailor.h"

/*
 * Externs...
 */
extern windowTemplate win_templates[];
extern Cardinal template_number;

extern Cardinal start_template_ids[];
extern Cardinal startup_number;

extern objectAction actions[];
extern Cardinal action_number;

#ifndef NO_STATS
extern LLog *log_stat;
#endif

void exit();

/* If testing, config files are read from source directory only */
Boolean testing;

/*
 *  Local procs..
 */

static void add_resources_to_prim();
static actionID add_action_entry();
static void check_tailoring();
static void free_resource_list();

/*
 * 	Globals..
 */

char user_path[STRINGLEN],
     config_directory[STRINGLEN],
     config_file_name[LINESIZE],
     config_file_path[LINESIZE];

FILE *configuration_file;
file_org config_origin;

Cardinal config_line_num;


/*
 *     Local data..
 */

static char err_msg[LINESIZE];


/*
 *	Paths
 */

char bitmap_directory[STRINGLEN];
extern char help_directory[];


/*
 * user_tailor() - Read tailor files.
 *
 */
void user_tailor()
{
  FILE *config_file;
  char *getenv(), *TidyString(), *SkipSpace();

#ifndef NO_STAT
  ll_hdinit(log_stat, "xlookup");
#endif

  config_file_path[0] = help_directory[0] = bitmap_directory[0] = '\0';

  if (*config_file_name == '\0')
    (void) strcpy(config_file_name, "xlurc");

  (void) strcpy(user_path, getenv("HOME"));


  if (testing != TRUE)
    {
      (void) sprintf(config_directory, "%s%s/", isodetcpath, "Xlu");
      
      (void) sprintf(bitmap_directory, "%sbitmaps/", config_directory);
      (void) sprintf(help_directory, "%shelp/", config_directory);
    }
  else
    {
      (void) strcpy(config_directory, "../");

      (void) sprintf(bitmap_directory, "%sbitmaps/", config_directory);
      (void) sprintf(help_directory, "%shelp/", config_directory);

      (void) strcat(config_directory, "config/");
    }


  if (strcmp(config_file_name, "xlurc") == 0)
    (void) sprintf(config_file_path, "%s%s", user_path, "/.xlurc");
  else
    (void) strcpy(config_file_path, config_file_name);


  if ((config_file = fopen(config_file_path, "r")) == 0)
    {
      (void) sprintf(config_file_path,
		     "%s%s",
		     config_directory,
		     config_file_name);
  
      if ((config_file = fopen (config_file_path, "r")) == 0)
	{
	  (void) sprintf(err_msg,
			 "Can't find tailor file %s!",
			 config_file_name);
	  xluFatal(err_msg);
	}
      else
	parse_win_config(config_file, SYSTEM_FILE, config_file_path);
    }
  else
    parse_win_config(config_file, USER_FILE, config_file_path);
} /* user_tailor */


/*
 * parse_win_config() - Parse named window configure file and create templates.
 *
 */
void parse_win_config(config_file, file_origin, file_name)
     FILE *config_file;
     file_org file_origin;
     String file_name;
{
  config_origin = file_origin;
  configuration_file = config_file;

  config_line_num = 1;
  (void) strcpy(config_file_name, file_name);

  (void) yyparse();
  check_tailoring();
} /* parse_win_config */

/*
 * check_tailoring -
 *
 */
static void check_tailoring()
{
  Cardinal count;
  
  /* Check that all referenced template names have defined layouts */
  for (count = 0; count < template_number; count++)
    if (win_templates[count]->layout == NULLLayout)
      {
	(void) sprintf(err_msg,
		       "No layout definition for referenced name `%s'.",
		       win_templates[count]->template_name);

	xluFatal(err_msg);
      }
}

/*
 * add_template_entry() - Create a new template for the named entry.
 *
 */
Cardinal add_template_entry(window_name)
     char *window_name;
{
  windowTemplate curr_template;
  Cardinal template_index;

  /* Check to see the given name hasn't already been added to the list */
  for (template_index = 0; 
       template_index < MAXTEMPLATES
       && template_index < template_number 
       && lexequ(window_name, win_templates[template_index]->template_name);
       template_index++)
    ;

  if (template_index < template_number) return template_index;

  win_templates[template_index] = curr_template = template_alloc();

  win_templates[template_index + 1] = NULLTemplate;

  /* If unparsed only the names of member templates are stored */

  curr_template->parsed = FALSE;
  curr_template->template_name = XtNewString(window_name);
  curr_template->layout = NULLLayout;
  curr_template->origin = config_origin;

  template_number++;

  return template_index;
} /* add_template_entry */

/*
 * put_layout - add given layout tree to table entry for group of given id.
 *
 */
void put_layout(group_id, new_layout)
     Cardinal group_id;
     layoutMember new_layout;
{
  register layoutMember curr_layout;
  orientation orient;
  windowTemplate this_template = win_templates[group_id];

  curr_layout = this_template->layout = new_layout;

  for (orient = curr_layout->orient, curr_layout = curr_layout->next_layout;
       curr_layout != NULLLayout;
       curr_layout = curr_layout->next_layout)
    curr_layout->orient = orient;

} /* put_layout */


/*
 * add_prim_to_layout - add given primitive to given layout tree
 *
 */
layoutMember add_prim_to_layout(primitive_id, resources, layout_list)
     Cardinal primitive_id;
     objectResource resources;
     layoutMember layout_list;
{
  layoutMember prim_member;

  prim_member = layout_alloc();

  prim_member->type = REF_primitive;
  prim_member->reference.primitive_id = primitive_id;
  prim_member->width = 0;
  prim_member->height = 0;
  prim_member->bitmap_file = NULLString;
  prim_member->help_file = NULLString;
  prim_member->label = NULLString;
  prim_member->name = NULLString;
  prim_member->expand = FALSE;
  prim_member->insensitivity = FALSE;
  prim_member->action_list = NULLPrimActionList;

  prim_member->next_layout = layout_list;

  if (resources != NULLObjRes)
    {
      add_resources_to_prim(resources, prim_member);
      free_resource_list(resources);
    }
    
  return prim_member;
} /* add_prim_to_layout */

/*
 * add_resources_to_prim
 *
 */
static void add_resources_to_prim(resource_list, prim_member)
     objectResource resource_list;
     layoutMember prim_member;
{
  String action_name;
  primActionList action_list;

  while (resource_list)
    {
    switch (resource_list->type)
      {
      case OT_action:
	action_name = resource_list->resource.action_name;
	
	action_list = prim_action_alloc();
	action_list->prim_action_id = add_action_entry(action_name);
	
	action_list->next = prim_member->action_list;
	prim_member->action_list = action_list;
	
	break;
	
      case OT_width:
	prim_member->width = resource_list->resource.width;
	break;
	
      case OT_height:
	prim_member->height = resource_list->resource.height;
	break;
	
      case OT_helpfile:
	prim_member->help_file =
	  XtNewString(resource_list->resource.help_file);
	break;
	
      case OT_bitmap:
	prim_member->bitmap_file =
	  XtNewString(resource_list->resource.bitmap_file);
	break;
	
      case OT_label:
	prim_member->label = XtNewString(resource_list->resource.label);
	break;
	
      case OT_name:
	prim_member->name = XtNewString(resource_list->resource.name);
	break;
	
      case OT_expand:
	prim_member->expand = resource_list->resource.expand;
	break;

      case OT_insensitive:
	prim_member->insensitivity = resource_list->resource.insensitive;
	break;
      }
    
    resource_list = resource_list->next;
  }
} /* add_resources_to_prim */


/*
 * - add_resources_to_layout() -
 *
 */
static void add_resources_to_layout(resource_list, this_layout)
     objectResource resource_list;
     layoutMember this_layout;
{
  while (resource_list)
    {
      switch (resource_list->type)
	{
	case OT_bitmap:
	  this_layout->bitmap_file =
	    XtNewString(resource_list->resource.bitmap_file);
	  break;

	case OT_helpfile:
	  this_layout->help_file =
	    XtNewString(resource_list->resource.help_file);
	  break;
	  
	case OT_label:
	  this_layout->label = XtNewString(resource_list->resource.label);
	  break;

	case OT_name:
	  this_layout->name = XtNewString(resource_list->resource.name);
	  break;

	case OT_expand:
	  this_layout->expand = resource_list->resource.expand;
	  break;
	}
      
      resource_list = resource_list->next;
    }
} /* add_resources_to_layout */

/*
 * add_branch_to_layout -
 *
 */
layoutMember add_branch_to_layout(template_id, resources, layout_list)
     Cardinal template_id;
     objectResource resources;
     layoutMember layout_list;
{
  layoutMember branch_head = layout_alloc();

  branch_head->type = REF_layout;
  branch_head->reference.layout_ref_id = template_id;

  branch_head->next_layout = layout_list;

  branch_head->bitmap_file = NULLString;
  branch_head->label = NULLString;
  branch_head->name = NULLString;
  branch_head->expand = FALSE;

  if (resources != NULLObjRes)
    {
      add_resources_to_layout(resources, branch_head);
      free_resource_list(resources);
    }
  
  return branch_head;
} /* add_branch_to_layout */


/*
 * add_to_startup_list -
 *
 */
void add_to_startup_list(template_id)
     Cardinal template_id;
{
  start_template_ids[startup_number] = template_id;
  startup_number++;
}

/*
 * add_action_entry -
 *
 */
static actionID add_action_entry(action_name)
     String action_name;
{
  actionID count;
  objectAction this_action;
  
  if (action_number == MAXACTIONS)
    {
      (void) fprintf
	(stderr,
	 "Maximum number of actions reached! Cannot continue, sorry.\n");

      exit(1);
    }

  for (count = 0;
       count < action_number && 
       lexequ(actions[count]->action_name, action_name);
       count++)
    ;

  if (count == action_number)
    {
      this_action = actions[action_number++] = action_alloc();

      this_action->action_name = XtNewString(action_name);
    }
  else
    {
      this_action = actions[count];

      if (this_action->action_name == NULLString)
	this_action->action_name = XtNewString(action_name);
    }

  this_action->to_do = NULLTransList;

  return count;
} /* add_action_entry */


/*
 * add_action -
 *
 */
void add_action(action_name, trans_list)
     String action_name;
     translationList trans_list;
{
  objectAction this_action;
  actionID action_id;

  action_id = add_action_entry(action_name);
  this_action = actions[action_id];

  this_action->to_do = trans_list;
} /* add_action */


/*
 * - put_resource() -
 *
 */
objectResource put_resource(type, res_value)
     optionType type;
     XtPointer res_value;
{
  Dimension dim;
  objectResource this_resource = resource_alloc();
  stringCell curr_str;
  char char_val;
  this_resource->type = type;

  switch (type)
    {
    case OT_action:
      this_resource->resource.action_name = XtNewString((String) res_value);
      break;

    case OT_insensitive:
      char_val = 0;

      for (curr_str = (stringCell) res_value;
	   curr_str != NULLStrCell;
	   curr_str = curr_str->next)
	{
	  if (lexequ(curr_str->string, "DSWAIT") == 0)
	    char_val = char_val | I_DS_WAIT;

	  if (lexequ(curr_str->string, "NOERROR") == 0)
	    char_val = char_val | I_NO_ERROR;
	  
	  if (lexequ(curr_str->string, "NOENTRY") == 0)
	    char_val = char_val | I_NO_ENTRY;
	  
	  if (lexequ(curr_str->string, "NOLIST") == 0)
	    char_val = char_val | I_NO_LIST;
	  
	  if (lexequ(curr_str->string, "NORMAL") == 0)
	    char_val = char_val | I_NORMAL;
	}

      curr_str = (stringCell) res_value;
      free_string_seq(&curr_str);
      
      this_resource->resource.insensitive = char_val;
      break;
      
    case OT_expand:
      this_resource->resource.expand = TRUE;
      break;
      
    case OT_width:
      dim = (Dimension) strtol((char *) res_value, (char **) NULL, 10);
      this_resource->resource.width = dim;
      break;
      
    case OT_height:
      dim = (Dimension) strtol((char *) res_value, (char **) NULL, 10);
      this_resource->resource.height = dim;
      break;
      
    case OT_bitmap:
      this_resource->resource.bitmap_file = XtNewString((String) res_value);
      break;

    case OT_helpfile:
      this_resource->resource.help_file = XtNewString((String) res_value);
      break;
      
    case OT_label:
      this_resource->resource.label = XtNewString((String) res_value);
      break;

    case OT_name:
      this_resource->resource.name = XtNewString((String) res_value);
      break;
    }

  this_resource->next = NULLObjRes;
  return this_resource;
} /* put_resource */

/*
 * free_resource_list -
 *
 */
static void free_resource_list(resource_list)
     objectResource resource_list;
{
  objectResource next_resource;

  while (resource_list != NULLObjRes)
    {
      next_resource = resource_list->next;

      switch (resource_list->type)
	{
	case OT_action:
	  XtFree((char *) resource_list->resource.action_name);
	  
	  break;
	  
	case OT_bitmap:
	  XtFree((char *) resource_list->resource.bitmap_file);
	  
	  break;

	case OT_helpfile:
	  XtFree((char *) resource_list->resource.help_file);
	  
	  break;
	  
	case OT_label:
	  XtFree((char *) resource_list->resource.label);

	  break;
	  
	case OT_name:
	  XtFree((char *) resource_list->resource.name);
	  
	  break;
      }

      XtFree((char *) resource_list);
      resource_list = next_resource;
    }
}

/*
 * - new_trans() -
 *
 *
 */
translationList new_trans(trans_type,
			  trans_name,
			  output1,
			  output2,
			  output_mode,
			  param)
     actionType trans_type;
     String trans_name, output1, output2;
     outputMode output_mode;
     XtPointer param;
{
  translationList trans = trans_alloc();

  trans->type = trans_type;

  /* Only used for primitive activations */
  if (trans_name != NULLString)
    trans->trans_name = XtNewString(trans_name);
  else
    trans->trans_name = NULLString;

  if (output1 != NULLString && *output1 != '\0')
    trans->template1_id = add_template_entry(output1);
  else
    trans->template1_id = 0;

  if (output2 != NULLString && *output2 != '\0')
    trans->template2_id = add_template_entry(output2);
  else
    trans->template2_id = 0;

  trans->mode = output_mode;
  trans->param = (char *) param;

  trans->next = NULLTransList;

  return trans;
} /* new_trans */


/*
 *
 *	Directory configuration procs
 *
 */

/*
 * - set_entry_class() -
 *
 *
 */
void set_entry_class(type_name,
		     key_oc_name,
		     rdn_type,
		     str_oc_list,
		     str_attr_list)
     String type_name, key_oc_name, rdn_type;
     stringCell str_oc_list, str_attr_list;
{
  extern entryClass entry_class_list;
  entryClass curr_class;
  AttributeType oc_type, attr_type;
  attrTypeList oc_list = NULLAttrTypeList, attr_list = NULLAttrTypeList;
  stringCell curr_str_oc, curr_str_attr;

  
  /*
   *	Do some checking....
   */

  if (isemptystr(type_name))
    return;

  for (curr_class = entry_class_list;
       curr_class != NULLEntryClass;
       curr_class = curr_class->next)
    if (!lexequ(curr_class->name, type_name))
      return;

  if (key_oc_name == NULLString)
    return;

  /*
   *	Create a new structure and add to global list
   */
  
  curr_class = entry_class_alloc();

  curr_class->next = entry_class_list;
  curr_class->name = XtNewString(type_name);

  for (curr_str_oc = str_oc_list;
       curr_str_oc != NULLStrCell;
       curr_str_oc = curr_str_oc->next)
    {
      if ((oc_type = AttrT_new(curr_str_oc->string)) == NULLAttrT)
	{
	  (void) sprintf(err_msg,
		   "Object class `%s' declared before line %d unrecognized!\n",
			 curr_str_oc->string,
			 config_line_num);
	  
	  xluFatal(err_msg);	  
	}
      else
	(void) add_type_to_list(oc_type, &oc_list);
    }

  if ((oc_type = AttrT_new(key_oc_name)) == NULLAttrT)
    {
      (void) sprintf(err_msg,
		    "ObjectClass `%s' declared before line %d unrecognized!\n",
		     key_oc_name,
		     config_line_num);

      xluFatal(err_msg);
    }

  if ((curr_class->rdn_type = AttrT_new(rdn_type)) == NULLAttrT)
    {
      (void) sprintf(err_msg,
		     "Attribute `%s' declared before line %d unrecognized!\n",
		     rdn_type,
		     config_line_num);

      xluFatal(err_msg);
    }

  (void) add_type_to_list(oc_type, &oc_list);

  free_string_seq(&str_oc_list);

  curr_class->oc_list = oc_list;

  for (curr_str_attr = str_attr_list;
       curr_str_attr != NULLStrCell;
       curr_str_attr = curr_str_attr->next)
    {
      if ((attr_type = AttrT_new(curr_str_attr->string)) == NULLAttrT)
	{
	  (void) sprintf(err_msg,
			 "Attribute `%s' declared at line %d unrecognized!\n",
			 curr_str_attr->string,
			 config_line_num);
	  
	  xluFatal(err_msg);
	}
      else
	(void) add_type_to_list(attr_type, &attr_list);
    }

  curr_class->default_attrs = attr_list;

  free_string_seq(&str_attr_list);

  entry_class_list = curr_class;
} /* set_entry_class */

/*
 * - get_class_of_name() -
 * Get the named entry class
 *
 */
entryClass get_class_of_name(name)
     String name;
{
  register entryClass curr_class;

  if (name == NULLCP || *name == '\0')
    return NULLEntryClass;

  for (curr_class = entry_class_list;
       curr_class != NULLEntryClass && lexequ(curr_class->name, name) != 0;
       curr_class = curr_class->next)
    ;

  return curr_class;
} /* get_class_of_name */

/*
 * - set_base_type() -
 *
 *
 */
void set_base_class(class_name)
     String class_name;
{
  extern String base_entry_class;

  base_entry_class = XtNewString(class_name);
} /* set_base_class */


/*
 * - set_attr_oc_rule() -
 *
 *
 */
void set_attr_oc_rule(attr_name, oc_name)
     String attr_name, oc_name;
{
  extern attrOcRule attr_oc_list;
  attrOcRule this_rule;
  AttributeType attr, oc;

  if ((attr = AttrT_new(attr_name)) == NULLAttrT)
    return;

  if ((oc = AttrT_new(oc_name)) == NULLAttrT)
    return;

  this_rule = attr_oc_alloc();

  this_rule->next = attr_oc_list;

  this_rule->attr = attr;
  this_rule->oc = oc;
} /* set_attr_oc_rule */



/*
 * - set_attr_template() -
 *
 *
 */
void set_attr_template(type_name, class_name_list, str_attr_list)
     String type_name;
     stringCell class_name_list, str_attr_list;
{
  extern attrTemplate attr_template_list;
  attrTemplate this_tmpl;
  AttributeType this_attr;

  if ((this_attr = AttrT_new(type_name)) == NULLAttrT)
    {
      (void) sprintf(err_msg,
		     "Attribute `%s' declared at line %d unrecognized!\n",
		     type_name,
		     config_line_num);

      free_string_seq(&class_name_list);
      free_string_seq(&str_attr_list);
      
      xluWarning(err_msg);
    }

  this_tmpl = attr_tmpl_alloc();

  this_tmpl->next = attr_template_list;
  attr_template_list = this_tmpl;

  this_tmpl->defaults = str_attr_list;
  this_tmpl->class_names = class_name_list;

  this_tmpl->type = this_attr;
} /* set_attr_template */


/*
 * - add_display_attr() -
 *
 *
 */
void add_display_attr(attr_name, to_show)
     String attr_name;
     showValue to_show;
{
  extern readAttribute attrs_to_display;
  readAttribute new;
  AttributeType type;


  if (attr_name == NULLString || *attr_name == '\0')
    return;

  if ((type = AttrT_new(attr_name)) == NULLAttrT)
    return;


  new = read_attr_alloc();
  new->next = attrs_to_display;

  new->type = type;
  new->to_show = to_show;

  attrs_to_display = new;
}


/*
 * - add_attribute_name() -
 *
 *
 */
void add_attribute_name(attr_name, user_name)
     String attr_name, user_name;
{
  AttributeType type = AttrT_new(attr_name);
  attributeName new_name;
  extern attributeName attr_name_list;


  if (type == NULLAttrT)
    return;

  if (user_name == NULLString || *user_name == '\0')
    return;

  new_name = attr_name_alloc();
  new_name->next = attr_name_list;

  new_name->type = type;
  new_name->name = XtNewString(user_name);

  attr_name_list = new_name;
} /* add_attribute_name */


/*
 * - add_search_class() -
 *
 *
 */
void add_ufs_search_class(class_name,
			  str_oc_type,
			  str_attr_list,
			  str_oc_list)
     String class_name, str_oc_type;
     stringCell str_attr_list, str_oc_list;
{
  attrTypeList search_attr_list = NULLAttrTypeList,
               base_oc_list = NULLAttrTypeList;
  AttributeType target_oc_type, search_type, base_oc_type;
  stringCell curr_str_type;
  

  if ((target_oc_type = AttrT_new(name2oc(str_oc_type)->oc_ot.ot_stroid))
       == NULLAttrT)
    {
      (void) fprintf (stderr,
		      "\"%s\" - Error at or before line %d \n",
		      config_file_path,
		      config_line_num);

      (void) fprintf(stderr,
		     "Invalid objectclass `%s'. Exiting.\n",
		     str_oc_type);		     
		     
      exit (1);
    }


  for (curr_str_type = str_attr_list;
       curr_str_type != NULLStrCell;
       curr_str_type = curr_str_type->next)
    {
      if ((search_type = AttrT_new(curr_str_type->string)) == NULLAttrT)
	{
	  (void) fprintf (stderr,
			  "\"%s\" - Error at or before line %d \n",
			  config_file_path,
			  config_line_num);
	  
	  (void) fprintf(stderr,
			 "Unrecognized attribute type `%s'. Exiting.\n",
			 curr_str_type->string);		     

	  exit (1);
	}

      add_type_to_list(search_type, &search_attr_list);
    }

  for (curr_str_type = str_oc_list;
       curr_str_type != NULLStrCell;
       curr_str_type = curr_str_type->next)
    {
      if (*curr_str_type->string == '\0')
	{
	  add_type_to_list(NULLAttrT, &base_oc_list);
	  continue;
	}
      
      if ((base_oc_type =
	   AttrT_new(name2oc(curr_str_type->string)->oc_ot.ot_stroid))
	  == NULLAttrT)
	{
	  (void) fprintf (stderr,
			  "\"%s\" - Error at or before line %d \n",
			  config_file_path,
			  config_line_num);
	  
	  (void) fprintf(stderr,
			 "Unrecognized object class `%s'. Exiting.\n",
			 curr_str_type->string);		     

	  exit (1);
	}

      add_type_to_list(base_oc_type, &base_oc_list);
    }
  
  if (add_search_class(class_name,
		       target_oc_type,
		       search_attr_list,
		       base_oc_list)
      == FALSE)
    {
      (void) fprintf (stderr,
		      "\"%s\" - Error at or before line %d \n",
		      config_file_path,
		      config_line_num);
	  
      (void) fprintf (stderr,
		      "Maximum number of searchClasses exceeded. Exiting\n");
      
      exit (1);
    }
} /* add_ufs_search_class */
