#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/error_view.c,v 0.95 91/09/02 11:36:34 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/error_view.c,v 0.95 91/09/02 11:36:34 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  error_view.c -
  
*****************************************************************************/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Form.h>
#include <X11/Command.h>
#include <X11/Viewport.h>
#include <X11/AsciiText.h>

#include "query.h"
#include "quipu/common.h"

#include "defs.h"
#include "windows.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"

#include "error_view.h"


extern windowObject win_objects[];
extern Display *dpy;

static void seeDetailedError();
static void createErrorField();


/*
 * - updateErrorViewer() -
 *
 *
 */
void updateErrorViewer(object_id)
     Cardinal object_id;
{
  WidgetList prim_insts;
  Widget view_form, label, curr_text, prev_button = NULLWidget, curr_button;
  windowObject this_object = win_objects[object_id];
  char error_message[STRINGLEN];
  errorList curr_error;
  Cardinal error_num;
  Arg args[MAXARGS];
  XtCallbackList callbacks;
  errorField curr_field, next_field, prev_field;

  /*
   *	Find instance of errorViewer in this object
   */
  prim_insts = find_prim_instances(object_id, ERROR_VIEW);

  if (prim_insts == (Widget *) NULL)
    return;


  /*
   *	Count number of errors to display
   */

  for (curr_error = this_object->current_errors, error_num = 0;
       curr_error != NULLError;
       curr_error = curr_error->next, error_num++)
    ;


  /*
   *	Display form updates
   */

  view_form = XtNameToWidget(prim_insts[0], "errorViewForm");

  XawFormDoLayout(view_form, FALSE);


  /*
   *   	
   */
  
  curr_button = XtNameToWidget(view_form, "errorButton");
  label = XtNameToWidget(view_form, "errorViewLabel");

  (void) sprintf(error_message, "%d errors", error_num);

  XtSetArg(args[0], XtNlabel, error_message);
  XtSetValues(label, args, 1);

  if (curr_button != NULLWidget)
    {
      XtSetArg(args[0], XtNfromVert, &prev_button);
      
      XtGetValues(curr_button, args, 1);
      
      while (prev_button != label)
	{
	  curr_button = prev_button;
	  XtGetValues(curr_button, args, 1);
	}
       
      XtSetArg(args[0], XtNcallback, &callbacks);
      XtGetValues(curr_button, args, 1);
      

      for (curr_field = (errorField) callbacks[0].closure,
	   curr_error = this_object->current_errors;
	   curr_error != NULLError && curr_field != NULLErrorField;
	   curr_error = curr_error->next, curr_field = curr_field->next)
	{
	  curr_text = curr_field->text;
	  
	  curr_field->error = curr_error;

	  XtSetArg(args[0],
		   XtNstring,
		   get_message_of_code(curr_error->error_type));
	  XtSetValues(curr_text, args, 1);
	}


      /*
       *   Have replaced the error text in as many existing fields as
       *   possible. If don't have enough fields make some more
       */

      if (curr_field == NULLErrorField)
	{
	  for (curr_field = (errorField) callbacks[0].closure;
	       curr_field->next != NULLErrorField;
	       curr_field = curr_field->next)
	    ;


	  /*
	   *	Create fields for each remaining error
	   */

	  while (curr_error != NULLError)
	    {
	      next_field = curr_field->next = error_field_alloc();

	      next_field->next = NULLErrorField;
	      next_field->error = curr_error;

	      createErrorField(next_field, curr_field->text, view_form);
	    }
	}
      else if (curr_field != NULLErrorField &&
	       curr_field != (errorField) callbacks[0].closure)
	/*
	 *   Have displayed all required errors. If have text fields
	 *   remaining from the last set of errors, destroy them.
	 */
	{
	  next_field = curr_field;

	  for (curr_field = (errorField) callbacks[0].closure;
	       curr_field != next_field && curr_field->next != next_field;
	       curr_field = curr_field->next)
	    ;

	  curr_field->next = NULLErrorField;

	  for (curr_field = next_field, next_field = curr_field->next;
	       curr_field != NULLErrorField;
	       curr_field = next_field, next_field = curr_field->next)
	    {
	      curr_field->error->next = NULLError;
	      error_list_free(&curr_field->error);
	      
	      if (curr_field->error->baseobject != NULLCP)
		(void) free(curr_field->error->baseobject);

	      XtSetArg(args[0], XtNfromHoriz, &curr_button);
	      XtGetValues(curr_button, args, 1);

	      XtUnmanageChild(curr_field->text);
	      XtUnmanageChild(curr_button);

	      XtDestroyWidget(curr_field->text);
	      XtDestroyWidget(curr_button);
	      
	      XtFree((XtPointer) curr_field);
	    }
	}
    }
  else
    /*
     *	Need to create a button/text field pair for each error
     */
    {
      for (curr_error = this_object->current_errors,
	   curr_field = prev_field = NULLErrorField;
	   curr_error != NULLError;
	   prev_field = curr_field,
	   curr_field = NULLErrorField,
	   curr_error = curr_error->next)
	{
	  if (prev_field == NULLErrorField)
	    curr_field = error_field_alloc();
	  else
	    curr_field = prev_field->next = error_field_alloc();
	  
	  curr_field->next = NULLErrorField;
	  curr_field->error = curr_error;

	  createErrorField
	    (curr_field,
	     (prev_field == NULLErrorField? label : prev_field->text),
	     view_form);
	}
    }

  XawFormDoLayout(view_form, TRUE);
} /* updateErrorViewer */



/*
 * - seeDetailedError() -
 *
 *
 */
/* ARGSUSED */
static void seeDetailedError(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  int width, height;
  Arg args[MAXARGS];
  Cardinal count;
  errorField this_field = (errorField) closure;

  XtSetArg(args[0], XtNstring, this_field->error->ds_message);
  XtSetValues(this_field->text, args, 1);

  get_text_dims(this_field->error->ds_message,
		this_field->text,
		&height,
		&width);


  count = 0;
  
  XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
  XtSetArg(args[count], XtNheight, (Dimension) height); count++;

  XtSetValues(this_field->text, args, count);
} /* seeDetailedError */


/*
 *
 *
 *
 */
static void createErrorField(this_field, from_vert, parent)
     errorField this_field;
     Widget from_vert, parent;
{
  Cardinal count;
  Arg args[MAXARGS];
  Widget curr_button;
  int width, height;
  char fname[STRINGLEN], err_msg[STRINGLEN], strbuf[STRINGLEN];


  if (this_field->error->baseobject != NULLCP)
    friendlify(this_field->error->baseobject, (String) fname);
  else
    fname[0] = '\0';


  (void) strcpy(err_msg, get_message_of_code(this_field->error->error_type));

  if (fname[0] != '\0')
    {
      (void) sprintf(strbuf, "\n Occured at (\"%s\")", fname);
      (void) strcat(err_msg, strbuf);
    }

  count = 0;
  
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;
  
  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;
  
  XtSetArg(args[count], XtNfromVert, from_vert); count++;
  
  curr_button = XtCreateManagedWidget("errorButton",
				      commandWidgetClass,
				      parent,
				      args,
				      count);


  if (this_field->error->ds_message == NULLCP)
    XtSetSensitive(curr_button, FALSE);

  
  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainRight); count++;
  
  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;
  
  XtSetArg(args[count], XtNfromVert, from_vert); count++;
  XtSetArg(args[count], XtNfromHoriz, curr_button); count++;
  
  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;
  XtSetArg(args[count], XtNeditType, XawtextRead); count++;

  XtSetArg(args[count], XtNresize, XawtextResizeBoth); count++;
  XtSetArg(args[count], XtNstring, (String) err_msg); count++;
  
  this_field->text = XtCreateManagedWidget("errorText",
					   asciiTextWidgetClass,
					   parent,
					   args,
					   count);

  get_text_dims(err_msg, this_field->text, &height, &width);

  count = 0;
  
  XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
  XtSetArg(args[count], XtNheight, (Dimension) height); count++;

  XtSetValues(this_field->text, args, count);

  XtAddCallback(curr_button,
		XtNcallback,
		seeDetailedError,
		(XtPointer) this_field);
} /* createErrorField */

