#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/help_display.c,v 0.95 91/09/02 11:36:38 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/help_display.c,v 0.95 91/09/02 11:36:38 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  help_display.c - Display help in the form of text and/or a bitmap

*****************************************************************************/

#include <X11/Intrinsic.h>
#include <X11/Form.h>
#include <X11/Command.h>
#include <X11/Viewport.h>
#include <X11/AsciiText.h>

#include "query.h"

#include "defs.h"
#include "windows.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"

#include "help_display.h"

/*
 *	Externals...
 */

extern char bitmap_directory[];


/*
 *	Global data
 */

char help_directory[LINESIZE];


/*
 *	Local data
 */

static char file_path[LINESIZE];



/*
 * - setHelp() - 	
 *
 *
 */
void setHelp(help_widget, template)
     Widget help_widget;
     layoutMember template;
{
  Widget text_widget, bitmap_widget;
  String filename;

  Arg args[MAXARGS];
  Cardinal count;

  int width, height;

  PS ps;
  FILE *helpfile;
  static char buffer[LINESIZE];
  String help_text;

  
  text_widget = XtNameToWidget(help_widget, "helpViewForm.helpText");
  bitmap_widget = XtNameToWidget(help_widget, "helpViewForm.helpBitmap");

  filename = template->bitmap_file;
  if (!isemptystr(filename))
    {
      (void) sprintf(file_path, "%s%s", bitmap_directory, filename);
      create_background_from_bitmap_file(bitmap_widget, file_path);
    }

  filename = template->help_file;
  if (!isemptystr(filename))
    {
      if ((ps = ps_alloc(str_open)) == NULLPS)
	return;

      if (str_setup(ps, NULLCP, 0, 0) == NOTOK)
	{
	  ps_free(ps);
	  return;
	}

      (void) sprintf(file_path, "%s%s", help_directory, filename);

      if ((helpfile = fopen(file_path, "r")) == NULL)
	{
	  (void) fprintf(stderr,
			 "Error : Could not open help file `%s'\n",
			 file_path);
	  
	  ps_free(ps);
	  return;
	}

      while (fgets(buffer, LINESIZE - 1, helpfile) != NULL)
	ps_printf(ps, "%s", buffer);


      help_text = ps->ps_base;
      *ps->ps_ptr = '\0';


      count = 0;
      XtSetArg(args[count], XtNstring, help_text); count++;
      XtSetValues(text_widget, args, count);

      get_text_dims(help_text, text_widget, &height, &width);
      

      count = 0;

      XtSetArg(args[count], XtNheight, (Dimension) height); count++;
      XtSetArg(args[count], XtNwidth, (Dimension) width); count++;

      XtSetValues(text_widget, args, count);

      XawTextEnableRedisplay(text_widget);

      ps_free(ps);
    }
} /* setHelp */

