#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/main.c,v 0.95 91/09/02 11:36:55 emsrdsm Exp Locker: emsrdsm $";
#endif

/******************************************************************************
  main.c 
******************************************************************************/

#include "defs.h"
#include "windows.h"
#include "objects.h"
#include "interact.h"
#include "widgets.h"
#include "configure.h"

#include "query.h"
#include <manifest.h>

#ifdef USE_PP
#include "/usr/src/local/PP/pp/h/or.h"
#endif

#include <varargs.h>


/*
 *	Externals..
 */

extern Boolean testing;
extern QBool use_poor_matches;



/*
 *	Local procs...
 */

static void read_args();


/*
 *	Public procs...
 */

void quit();
int advise();


/*
 *	Globals...
 */

Widget toplevel;
XtAppContext app_context;
Display *dpy;



main(argc, argv)
     int argc;
     char *argv[];
{
  extern time_t cache_timeout;
  extern QBool want_photo_as_bytes, want_audio_as_bytes;

  toplevel = XtAppInitialize(&app_context,
			     "Xlookup", 
			     NULL,
			     0,
			     &argc, argv,
			     NULL,
			     NULL,
			     0);

  dpy = XtDisplay(toplevel);


  /*
   *	X Action procedures
   */

  init_actions(app_context);


  /*
   *	Initialize widget stuff
   */

  init_widgets();

  
  /*
   * 	Parse non-DS and non-X arguments
   */

  read_args(argc, argv);


  /*
   *	Initialize ds stuff
   */

  have_iso8859_font();

  want_photo_as_bytes = TRUE;
  want_audio_as_bytes = TRUE;

  use_poor_matches = FALSE;

  init_query_engine(argc, argv);

  user_tailor();


  /*
   * Initialize OR stuff
   */

#ifdef USE_PP

/*   uip_init(argv[0]); */
  or_init();

#endif


  /*
   *	Set cache timeout for 30 minutes. Should be configurable!
   */  

  cache_timeout = 10 * 60;


  /*
   *	Bind
   */

  (void) fprintf(stderr, "Connecting to directory....");

  if (bind_to_ds(argc, argv, SIMPLE_AUTH) == FALSE)
    xluFatal("couldn't connect!");

  (void) fprintf(stderr, "connected\n");

  create_startup_windows();

  user_interact();

  return 0;
}

/*
 * read_args() - parse command line arguments.
 *
 */

static void read_args(argc, argv)
     int argc;
     char *argv[];
{
  char *cp;
  extern Boolean testing;

  extern char config_file_name[];

  if (argc <= 1)
    return;

  argc--;
  argv++;

  while (argc-- > 0 && ((cp = *argv++) != NULLCP))
    if (*cp == '-')
      switch (*++cp)
	{
	case 'l':
	case 'L':
	  
	  if (argc >= 1)
	    {
	      cp = *argv++;
	      
	      if (*cp == '-')
		xluFatal("Invalid command line syntax.");
	      
	      (void) strcpy(config_file_name, cp);
	      argc--;
	    }
	  else
	    xluFatal("Invalid command line syntax.");
	  
	  break;
	  
	case 't':
	  
	  if (lexequ(cp, "test") == 0)
	    testing = TRUE;
	  
	  default:
	  break;
	}
}
