#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/modify_form.c,v 0.95 91/09/02 11:36:57 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/modify_form.c,v 0.95 91/09/02 11:36:57 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  modify_form.c -

*****************************************************************************/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>

#include <X11/Form.h>
#include <X11/Command.h>

#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/MenuButton.h>

#include <X11/Viewport.h>
#include <X11/AsciiText.h>

#include "query.h"
#include "quipu/common.h"

#include "defs.h"

#include "windows.h"
#include "requests.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"
#include "query_user.h"

#include "modify_form.h"
#include "modify_ops.h"
#include "status_bar.h"
#include "error_view.h"

/*
 *     Externs...
 */
extern windowObject win_objects[];

extern Display *dpy;
extern Widget toplevel;

extern char bitmap_directory[];

extern XtTranslations pel_trans_table;

extern entryClass entry_class_list;

/*
 *	Static procs....
 */
static void doUpdateModifyForm();
static void freeModAttrList();
static void setEntryClass(), doNotSetEntryClass(), doSetEntryClass();

static modifyField addAttributeValueField();
static void addMustAttribute(), addMayAttribute();

static void addValueField(), undoAllChanges(), undoChanges(), deleteValue();

static void makeMenuBitmaps();
static Widget makeModifyEdit();
static void makeValueMenu();

static void freeField(), freeOldAttrs();

/*
 *	Global data...
 */
String trans_tab = "<Key>Tab: doChangeModifyFocus()",
       trans_btn1 = "<Btn1Down>: select-start() doSetModifyFocus()",
       trans_ret_nothing = "<Key>Return: doNothing() \n\
                             Ctrl<Key>M:  doNothing() \n\
   			     Ctrl<Key>O:  doNothing() \n\
   			     Ctrl<Key>J:  doNothing()";

XtTranslations tt_tab = (XtTranslations) NULL,
               tb_tab = (XtTranslations) NULL, 
               trn_tab = (XtTranslations) NULL;


#define LONGSTRING 4096

/*
 *	Spacing in modify window
 */

#define attrDistance 28
#define valueDistance 10


void updateModifyForm();

/*
 *	Temporary procs!
 */

void temp_init_mod_attrs();
static void make_mod_attr();



/*
 *	Callback records for modify edit widgets
 */

static void modUpdate(), saveTopAttr();


XtCallbackRec modCallback[] =
{
  {modUpdate, (XtPointer) NULL},
  {(XtCallbackProc) NULL, (XtPointer) NULL},
};

/*
 * saveTopAttr is used to save pointer to first modify attribute.
 * The procedure does nothing!
 *
 */

XtCallbackRec saveCallback[] =
{
  {saveTopAttr, (XtPointer) NULL},
  {(XtCallbackProc) NULL, (XtPointer) NULL},
};


/*
 *	- displayEntryTemplate() -
 *
 *
 */
void displayEntryTemplate(prim_widget,
			  object_id,
			  prim_id,
			  action_id,
			  trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  WidgetList prim_insts;

  prim_insts = find_prim_instances(object_id, MODIFY);

  if (prim_insts != (Widget *) NULL)
    {
      /* ####### Go thru all instances ! ###### */

      doUpdateModifyForm(prim_widget,
			 object_id,
			 prim_id,
			 action_id,
			 trans_list);

      XtFree((char *) prim_insts);

      setStatusMessage(object_id, "Reading entry. Please wait.");
    }
} /* displayEntryTemplate */

/*
 * - doUpdateModifyForm() -
 *
 *
 */
static void doUpdateModifyForm(prim_widget,
			       object_id,
			       prim_id,
			       action_id,
			       trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  QE_error_code read_state;
  QCardinal req_id;
  windowObject this_object = win_objects[object_id];
  String strdn;
  modifyAttr curr_attr;

  strdn = this_object->current_entry;

  /*
   *	Initiate the read
   */
  curr_attr = NULLModifyAttr;
  if (strdn != NULLString)
    read_state = do_make_template(strdn, &req_id, &curr_attr);
  else
    {
      setStatusMessage(object_id, "No entry name given to read!");
      return;
    }
  
  setStatusMessage(object_id, "Reading entry. Please Wait.");

  switch (read_state)
    {
    case QERR_bad_value_syntax:
      setStatusMessage(object_id, "Can't get data! Bad entry name supplied.");
      return;

    case QERR_internal_limit_reached:
      setStatusMessage(object_id, "Can't get data! Internal limit reached.");
      return;
    }

  /* Record request invocation */
  request_invoked(req_id,
                  ENTRY_TEMPLATE,
                  prim_widget,
                  object_id,
                  prim_id,
                  action_id,
                  trans_list == NULLTransList? trans_list : trans_list->next);
} /* doUpdateModifyForm */


/*
 * - updateModifyForm() -
 *
 *
 */
/* ARGSUSED */
void updateModifyForm(prim_widget,
		      class_names,
		      must_in,
		      may_in,
		      must_out,
		      may_out,
		      errors,
		      baseobject)
     Widget prim_widget;
     stringCell class_names;
     modifyAttr must_in, may_in, must_out, may_out;
     errorList errors;
     String baseobject;
{
  Widget form, must_form, may_form,
  	 last_edit, curr_edit, class_button,
  	 entry_label, view, attr_button,
  	 menu_shell, menu_button, class_text,
         modify_name_label, class_menu,
  	 commit_button, delete_button;
  modifyAttr curr_attr, must_in_last, may_in_last, must_out_last, first_attr;

  Arg args[MAXARGS];
  Cardinal count;

  Dimension scroll_height;
  int width, height;

  char strbuf[STRINGLEN];
  modifyField curr_field, last_field, first_field = NULLModifyField;
  entryClass curr_class;


  view = XtNameToWidget(prim_widget, "modifyWindow");
  form = XtNameToWidget(view, "modifyViewForm");

  class_text = XtNameToWidget(prim_widget, "modifyEditClass");
  class_button = XtNameToWidget(prim_widget, "classMenuButton");
  class_menu = XtNameToWidget(class_button, "menu");

  commit_button = XtNameToWidget(prim_widget, "commitModificationsButton");
  delete_button = XtNameToWidget(prim_widget, "deleteEntryButton");


  XtSetSensitive(commit_button, TRUE);
  XtSetSensitive(delete_button, TRUE);

  /*
   *	Print entry classes
   */

  if (class_names != NULLStrCell)
    {
      (void) strcpy(strbuf, class_names->string);
      class_names = class_names->next;

      while (class_names != NULLStrCell)
	{
	  (void) strcat(strbuf, ", ");
	  (void) strcat(strbuf, class_names->string);

	  class_names = class_names->next;
	}
    }


  XtSetArg(args[0], XtNstring, strbuf);
  XtSetValues(class_text, args, 1);

  get_text_dims(strbuf, class_text, &height, &width);
  

  XtSetArg(args[0], XtNwidth, (Dimension) width);
  XtSetArg(args[1], XtNheight, (Dimension) height);
	  
  XtSetValues(class_text, args, 2);

  /*
   *	Create entry class menu
   */

  if (class_menu != NULLWidget)
    {
      XtDestroyWidget(class_menu);

      count = 0;

      XtSetArg(args[count], XtNsensitive, TRUE); count++;
      XtSetArg(args[count], XtNancestorSensitive, TRUE); count++; /* cheat! */
      
      class_menu = XtCreatePopupShell("menu",
				      simpleMenuWidgetClass,
				      class_button,
				      args,
				      count);
      
      for (curr_class = entry_class_list;
	   curr_class != NULLEntryClass;
	   curr_class = curr_class->next)
	{
	  XtSetArg(args[0], XtNlabel, curr_class->name);
	  menu_button = XtCreateManagedWidget(curr_class->name,
					      smeBSBObjectClass,
					      class_menu,
					      args,
					      1);
	  
	  XtAddCallback(menu_button,
			XtNcallback,
			setEntryClass,
			(XtPointer) curr_class);
	}
    }

  /*
   *	Destroy existing fields
   */

  if (form != NULLWidget)
    {
      XtUnmanageChild(form);
      XtDestroyWidget(form);
    }

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  
  form = XtCreateWidget("modifyViewForm",
			formWidgetClass,
			view,
			args,
			count);

  friendlify(baseobject, strbuf);


  /*
   *	Create the must form
   */

  count = 0;
  
  XtSetArg(args[count], XtNresizable, FALSE); count++;
  XtSetArg(args[count], XtNvertDistance, 16); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  modify_name_label = XtCreateManagedWidget("modifyNameLabel",
					    labelWidgetClass,
					    form,
					    args,
					    count);
  

  if (must_in == NULLModifyAttr)
    {
      if (may_in == NULLModifyAttr)
	first_attr = must_out;
      else
	first_attr = may_in;
    }
  else
    first_attr = must_in;

  saveCallback[0].closure = (XtPointer) first_attr;


  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNstring, strbuf); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNeditType, XawtextEdit); count++;
  XtSetArg(args[count], XtNresize, XawtextResizeWidth); count++;

  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;

  XtSetArg(args[count], XtNfromHoriz, modify_name_label); count++;
  XtSetArg(args[count], XtNvertDistance, 16); count++;

  XtSetArg(args[count], XtNcallback, saveCallback); count++;
  
  entry_label = XtCreateManagedWidget("modifyEntryLabel",
				      asciiTextWidgetClass,
				      form,
				      args,
				      count);


  if (isemptystr(strbuf))
    get_text_dims("BLANKSPACEBLANKPSACE", entry_label, &height, &width);
  else
    get_text_dims(strbuf, entry_label, &height, &width);

  
  count = 0;
  
  XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
  XtSetArg(args[count], XtNheight, (Dimension) height); count++;

  XtSetValues(entry_label, args, count);

  XtAddCallback(entry_label,
		XtNdestroyCallback,
		freeOldAttrs,
		(XtPointer) first_attr);
  

  /*
   * 	Translations for entry name dialog
   */

  if (trn_tab == (XtTranslations) NULL)
    trn_tab = XtParseTranslationTable(trans_ret_nothing);
  
  XtOverrideTranslations(entry_label, trn_tab);
  

  /*
   *	Translations for read display
   */

  if (tt_tab == (XtTranslations) NULL)
    tt_tab = XtParseTranslationTable(trans_tab);

  XtOverrideTranslations(entry_label, tt_tab);

  if (tb_tab == (XtTranslations) NULL)
    tb_tab = XtParseTranslationTable(trans_btn1);

  XtOverrideTranslations(entry_label, tb_tab);


  /*
   * The dialog box has an auto-scrollbar, so need to adjust the height
   * of the dialog box to allow for this.
   */

  count = 0;
  XtSetArg(args[count], XtNheight, &scroll_height); count++;
  XtGetValues(entry_label, args, count);

  scroll_height += 4;

  count = 0;
  XtSetArg(args[count], XtNheight, scroll_height); count++;
  XtSetValues(entry_label, args, count);


  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNfromVert, entry_label); count++;

  XtSetArg(args[count], XtNdefaultDistance, 28); count++;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  must_form = XtCreateManagedWidget("mustViewForm",
				    formWidgetClass,
				    form,
				    args,
				    count);


  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNlabel, "Information that MUST be filled in");
  count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  (void) XtCreateManagedWidget("FormLabel",
			       labelWidgetClass,
			       must_form,
			       args,
			       count);
  
  for (curr_attr = must_in,
       curr_edit = last_edit = NULLWidget,
       last_field = curr_field = NULLModifyField;
       curr_attr != NULLModifyAttr;
       curr_attr = curr_attr->next, last_edit = curr_edit)
    {
      last_field = curr_field;
      curr_field = addAttributeValueField(curr_attr, must_form, last_edit);

      if (last_field != NULLModifyField)
	last_field->next = curr_field;

      if (curr_attr == must_in)
	{
	  curr_edit = curr_field->edit;
	  
	  XtSetArg(args[0], XtNdisplayCaret, TRUE);
	  XtSetValues(curr_edit, args, 1);

	  XtSetKeyboardFocus(form, curr_edit);

	  curr_field->is_active = TRUE;
	  first_field = curr_field;
	}
      else
	curr_field->is_active = FALSE;

      while (curr_field->next != NULLModifyField)
	curr_field = curr_field->next;

      curr_edit = curr_field->edit;
    }

  
  /*
   *	Create the may form
   */

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNfromVert, must_form); count++;

  XtSetArg(args[count], XtNdefaultDistance, 28); count++;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  may_form = XtCreateManagedWidget("mayViewForm",
				   formWidgetClass,
				   form,
				   args,
				   count);


  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNlabel, "Information that MAY be filled in");
  count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  (void) XtCreateManagedWidget("FormLabel",
			       labelWidgetClass,
			       may_form,
			       args,
			       count);

  for (curr_attr = may_in,
       curr_edit = NULLWidget,
       last_edit = NULLWidget;
       curr_attr != NULLModifyAttr;
       curr_attr = curr_attr->next, last_edit = curr_edit)
    {
      last_field = curr_field;
      curr_field = addAttributeValueField(curr_attr, may_form, last_edit);

      curr_field->is_active = FALSE;

      if (last_field != NULLModifyField)
	last_field->next = curr_field;

      while (curr_field->next != NULLModifyField)
	curr_field = curr_field->next;

      curr_edit = curr_field->edit;
    }


  /*
   *	Create the attribute menu
   */

  attr_button = XtNameToWidget(prim_widget, "attrMenuButton");

  menu_shell = XtNameToWidget(attr_button, "menu");

  if (menu_shell != NULLWidget)
    {
      XtUnmanageChild(menu_shell);
      XtDestroyWidget(menu_shell);
    }

  count = 0;

  XtSetArg(args[count], XtNsensitive, TRUE); count++;
  XtSetArg(args[count], XtNancestorSensitive, TRUE); count++; /* cheat! */

  menu_shell = XtCreatePopupShell("menu",
				  simpleMenuWidgetClass,
				  attr_button,
				  args,
				  count);

  for (menu_button = NULLWidget, curr_attr = must_out;
       curr_attr != NULLModifyAttr;
       curr_attr = curr_attr->next)
    {
      count = 0;

      XtSetArg(args[count],
	       XtNlabel,
	       getAttributeName(curr_attr->attr_type));
      count++;

      menu_button = XtCreateManagedWidget(curr_attr->attr_name,
					  smeBSBObjectClass,
					  menu_shell,
					  args,
					  count);
      XtAddCallback(menu_button,
		    XtNcallback,
		    addMustAttribute,
		    (XtPointer) curr_attr);
    }

  (void) XtCreateManagedWidget("line",
			       smeLineObjectClass,
			       menu_shell,
			       args,
			       0);

  for (menu_button = NULLWidget, curr_attr = may_out;
       curr_attr != NULLModifyAttr;
       curr_attr = curr_attr->next)
    {
      count = 0;

      XtSetArg(args[count],
	       XtNlabel,
	       getAttributeName(curr_attr->attr_type));
      count++;

      menu_button = XtCreateManagedWidget(curr_attr->attr_name,
					  smeBSBObjectClass,
					  menu_shell,
					  args,
					  count);
      XtAddCallback(menu_button,
		    XtNcallback,
		    addMayAttribute,
		    (XtPointer) curr_attr);
    }

  /*
   *	Make things easier by linking all four lists
   */

  for (must_in_last = must_in;
       must_in_last != NULLModifyAttr && must_in_last->next != NULLModifyAttr;
       must_in_last = must_in_last->next)
    ;

  
  for (may_in_last = may_in;
       may_in_last != NULLModifyAttr && may_in_last->next != NULLModifyAttr;
       may_in_last = may_in_last->next)
	;
  

  for (must_out_last = must_out;
       must_out_last != NULLModifyAttr && must_out_last->next !=NULLModifyAttr;
       must_out_last = must_out_last->next)
    ;
  

  if (must_in_last != NULLModifyAttr)
    must_in_last->next = (may_in ? may_in : (must_out ? must_out : may_out));

  if (may_in_last != NULLModifyAttr)
    may_in_last->next = (must_out ? must_out : may_out);
  
  if (must_out_last != NULLModifyAttr)
    must_out_last->next = may_out;

  
  if (must_in == NULLModifyAttr)
    must_in = (may_in ? may_in : (must_out ? must_out : may_out));
  

  /*
   *	Destroy callbacks to free up attribute list
   */

  XtAddCallback(must_form,
		XtNdestroyCallback,
		freeModAttrList,
		(XtPointer) must_in);

  XtManageChild(form);

  makeMenuBitmaps(first_field, TRUE, TRUE);
} /* updateModifyForm */



/*
 * - addMustAttribute() -
 */
/* ARGSUSED */
static void addMustAttribute(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  Widget form = XtParent(XtParent(XtParent(w))),
         must_form,
         form_label,
         new_edit,
         top_attr_menu,
  	 top_val_menu,
  	 last_edit,
  	 top_edit,
  	 menu_shell;
  Arg args[MAXARGS];
  Cardinal num_children, count;
  modifyField new_field, last_of_top_field, old_top_field, curr_field;
  XtCallbackList callbacks;

  
  must_form = XtNameToWidget(form, "modifyWindow.modifyViewForm.mustViewForm");
  top_attr_menu = XtNameToWidget(must_form, "typeButton");
  top_edit = XtNameToWidget(must_form, "modifyEdit");
  form_label = XtNameToWidget(must_form, "FormLabel");

  XawFormDoLayout(must_form, FALSE);


  /*
   *	Get the top most edit field and corresponding attribute menu
   */

  if (top_edit != NULLWidget)
    {
      if (XtIsManaged(top_edit) == FALSE)
	{
	  XtSetArg(args[0], XtNcallback, &callbacks);
	  XtGetValues(top_edit, args, 1);

	  curr_field = (modifyField) callbacks[0].closure;

	  for (curr_field = curr_field->first; ;curr_field = curr_field->next)
	    if (curr_field->edit!= NULLWidget && XtIsManaged(curr_field->edit))
	      break;

	  top_edit = curr_field->edit;
	}


      last_edit = top_edit;
      
      XtSetArg(args[0], XtNfromVert, &top_edit);
      
      while (top_edit != form_label)
	{
	  last_edit = top_edit;
	  XtGetValues(last_edit, args, 1);
	}
      
      top_edit = last_edit;
      
      XtSetArg(args[0], XtNfromHoriz, &top_attr_menu);
      XtGetValues(top_edit, args, 1);
      
      XtSetArg(args[0], XtNfromHoriz, &top_val_menu);
      XtGetValues(top_attr_menu, args, 1);
    }

      
  /*
   *	Add the new field
   */

  new_field = addAttributeValueField((modifyAttr) closure,
				     must_form,
				     NULLWidget);

  new_field->is_active = FALSE;  

  for (last_of_top_field = new_field;
       last_of_top_field->next != NULLModifyField;
       last_of_top_field = last_of_top_field->next)
    ;
  

  if (top_edit != NULLWidget)
    {
      new_edit = last_of_top_field->edit;
      
      XtSetArg(args[0], XtNfromVert, new_edit);
      
      XtSetValues(top_edit, args, 1);
      XtSetValues(top_attr_menu, args, 1);
      XtSetValues(top_val_menu, args, 1);

      XtSetArg(args[0], XtNcallback, &callbacks);
      XtGetValues(top_edit, args, 1);
      
      old_top_field = (modifyField) callbacks[0].closure;
      last_of_top_field->next = old_top_field->first;
    }      
      

  makeMenuBitmaps(new_field, TRUE, FALSE);


  XawFormDoLayout(must_form, TRUE);


  /*
   *	Remove this entry from the menu. If this is the last entry
   *	remove the menu shell and desensitize the button
   */

  menu_shell = XtParent(w);

  count = 0;
  XtSetArg(args[count], XtNnumChildren, &num_children); count++;
  XtGetValues(menu_shell, args, count);

  if (num_children == 2) /* There is an smeLine also! */
    XtDestroyWidget(menu_shell);
  else
    XtDestroyWidget(w);
}  /* addAttribute */


/*
 * - addMayAttribute() -
 */
/* ARGSUSED */
static void addMayAttribute(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  Widget form = XtParent(XtParent(XtParent(w))),
         may_form,
  	 must_form,
         form_label,
         new_edit,
         top_val_menu,
  	 top_attr_menu,
  	 last_edit,
  	 top_edit,
  	 must_edit,
  	 menu_shell;
  Arg args[MAXARGS];
  Cardinal num_children, count;
  modifyField new_field, last_of_top_field,old_top_field,must_field,curr_field;
  XtCallbackList callbacks;
  

  may_form = XtNameToWidget(form, "modifyWindow.modifyViewForm.mayViewForm");
  must_form = XtNameToWidget(XtParent(may_form), "mustViewForm");

  top_attr_menu = XtNameToWidget(may_form, "typeButton");
  form_label = XtNameToWidget(may_form, "FormLabel");

  top_edit = XtNameToWidget(may_form, "modifyEdit");
  must_edit = XtNameToWidget(must_form, "modifyEdit");

  XawFormDoLayout(may_form, FALSE);


  /*
   *	Get the top most edit field and corresponding attribute menu
   */

  if (top_edit != NULLWidget)
    {
      if (XtIsManaged(top_edit) == FALSE)
	{
	  XtSetArg(args[0], XtNcallback, &callbacks);
	  XtGetValues(top_edit, args, 1);

	  curr_field = (modifyField) callbacks[0].closure;

	  for (curr_field = curr_field->first; ;curr_field = curr_field->next)
	    if (curr_field->edit!= NULLWidget && XtIsManaged(curr_field->edit))
	      break;

	  top_edit = curr_field->edit;
	}

      last_edit = top_edit;
      
      XtSetArg(args[0], XtNfromVert, &top_edit);
      
      while (top_edit != form_label)
	{
	  last_edit = top_edit;
	  XtGetValues(last_edit, args, 1);
	}
      
      top_edit = last_edit;
      
      XtSetArg(args[0], XtNfromHoriz, &top_val_menu);
      XtGetValues(top_edit, args, 1);
      
      XtSetArg(args[0], XtNfromHoriz, &top_attr_menu);
      XtGetValues(top_val_menu, args, 1);
    }
    

  /*
   *	Add the new field
   */

  new_field = addAttributeValueField((modifyAttr) closure,
				     may_form,
				     NULLWidget);
  
  new_field->is_active = FALSE;

  for (last_of_top_field = new_field;
       last_of_top_field->next != NULLModifyField;
       last_of_top_field = last_of_top_field->next)
    ;

  new_edit = last_of_top_field->edit;


  if (top_edit != NULLWidget)
    {
      XtSetArg(args[0], XtNfromVert, new_edit);
      
      XtSetValues(top_edit, args, 1);
      XtSetValues(top_val_menu, args, 1);
      XtSetValues(top_attr_menu, args, 1);
      
      XtSetArg(args[0], XtNcallback, &callbacks);
      XtGetValues(top_edit, args, 1);
      
      old_top_field = (modifyField) callbacks[0].closure;
      last_of_top_field->next = old_top_field->first;
    } 
  else
    old_top_field = NULLModifyField;


  if (must_edit != NULLWidget)
    {
      XtSetArg(args[0], XtNcallback, &callbacks);
      XtGetValues(must_edit, args, 1);
      
      for (must_field = (modifyField) callbacks[0].closure;
	   must_field->next != NULLModifyField &&
	   must_field->next != old_top_field->first;
	   must_field = must_field->next)
	;
  
      must_field->next = new_field;
    }


  makeMenuBitmaps(new_field, TRUE, FALSE);

  XawFormDoLayout(may_form, TRUE);


  /*
   *	Remove this entry from the menu. If this is the last entry
   *	remove the menu shell and desensitize the button
   */

  menu_shell = XtParent(w);

  count = 0;
  XtSetArg(args[count], XtNnumChildren, &num_children); count++;
  XtGetValues(menu_shell, args, count);

  if (num_children == 1)
    XtDestroyWidget(menu_shell);
  else
    XtDestroyWidget(w);
} /* addMayAttribute */


/*
 * - addAttributeValueField() -
 *
 */
static modifyField addAttributeValueField(this_attr, parent_form, last_edit)
     modifyAttr this_attr;
     Widget parent_form, last_edit;
{
  Cardinal count;
  Arg args[MAXARGS];
  Widget curr_edit = NULLWidget, form_label, curr_label,
         attr_menu, val_menu, val_button, menu_entry;

  int vert_distance = attrDistance;
  int width, height;

  modifyValue curr_val;
  modifyField this_field, first_field = NULLModifyField;

  String strval;


  /*
   *	Translations for read display
   */

  form_label = XtNameToWidget(parent_form, "FormLabel");

  count = 0;
  
  XtSetArg(args[count],
	   XtNfromVert,
	   last_edit == NULLWidget? form_label : last_edit); count++;
  
  XtSetArg(args[count],
	   XtNlabel,
	   getAttributeName(this_attr->attr_type)); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;
  
  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;
  
  XtSetArg(args[count], XtNvertDistance, vert_distance); count++;
  
  curr_label = XtCreateManagedWidget("typeButton",
				     menuButtonWidgetClass,
				     parent_form,
				     args,
				     count);
  
  XtOverrideTranslations(curr_label, pel_trans_table);

  count = 0;

  XtSetArg(args[count], XtNsensitive, TRUE); count++;
  XtSetArg(args[count], XtNancestorSensitive, TRUE); count++; /* cheat! */

  attr_menu = XtCreatePopupShell("menu",
				 simpleMenuWidgetClass,
				 curr_label,
				 args,
				 count);


  if (this_attr->values != NULLModifyValue)
    {
      for (curr_val = this_attr->values;
	   curr_val != NULLModifyValue;
	   curr_val = curr_val->next)
	{
	  if (this_attr->attr_type->oa_syntax >= AV_WRITE_FILE)
	    strval = "";
	  else
	    strval = curr_val->value;

	  /*
	   *	Create the per value menu
	   */
	  
	  makeValueMenu(parent_form,
			last_edit == NULLWidget? form_label : last_edit,
			curr_label,
			vert_distance,
			&val_button,
			&val_menu);
	  
	  
	  /*
	   *	Construct data that's needed to keep track of widget
	   *	whereabouts
	   */
	  
	  if (first_field == NULLModifyField)
	    first_field = this_field = mod_field_alloc();
	  else
	    {
	      this_field->next = mod_field_alloc();
	      this_field = this_field->next;
	    }
	  
	  this_field->this_value = curr_val;
	  this_field->this_attr = this_attr;
	  
	  this_field->next = NULLModifyField;

	  this_field->first = first_field;
	  
	  
	  /*
	   *	Set the callback to point at this value
	   */

	  modCallback[0].closure = (XtPointer) this_field;


	  /*
	   *	Make the edit field 
	   */

	  
	  this_field->edit = curr_edit = last_edit = 
	    makeModifyEdit(parent_form,
			   (last_edit == NULLWidget? form_label : last_edit),
			   val_button,
			   vert_distance,
			   this_field->this_attr->attr_type,
			   strval);

	  XtAddCallback(curr_edit,
			XtNdestroyCallback,
			freeField,
			(XtPointer) this_field);
	  
	  vert_distance = valueDistance;
	  
	  
	  /*
	   *	Add entries to menu
	   */

	  menu_entry = XtCreateManagedWidget("undoChanges",
					     smeBSBObjectClass,
					     val_menu,
					     args,
					     0);

	  XtAddCallback(menu_entry,
			XtNcallback,
			undoChanges,
			(XtPointer) this_field);


	  menu_entry = XtCreateManagedWidget("deleteValue",
					     smeBSBObjectClass,
					     val_menu,
					     args,
					     0);

	  if (this_attr->attr_type->oa_syntax >= AV_WRITE_FILE)
	    XtSetSensitive(menu_entry, FALSE);
	  else
	    XtAddCallback(menu_entry,
			  XtNcallback,
			  deleteValue,
			  (XtPointer) this_field);
	}
    }
  else
    {
      /*
       *	Create the per value menu
       */
      
      makeValueMenu(parent_form,
		    last_edit == NULLWidget? form_label : last_edit,
		    curr_label,
		    vert_distance,
		    &val_button,
		    &val_menu);
      
      /*
       * 	Construct a new value structure
       */

      curr_val = this_attr->values = modify_value_alloc();
      
      curr_val->next = NULLModifyValue;
      curr_val->value = curr_val->new_value = NULLString;
      
      curr_val->status = unchanged;


      /*
       *	Construct data that's needed to keep track of widget
       *	whereabouts
       */

      first_field = mod_field_alloc();
      
      first_field->this_value = curr_val;
      first_field->this_attr = this_attr;

      first_field->next = NULLModifyField;
      first_field->first = first_field;


      /*
       *	Set the callback to point at this value
       */

      modCallback[0].closure = (XtPointer) first_field;
      
      /*
       *	Make the edit field 
       */

      first_field->edit = curr_edit = last_edit = 
	makeModifyEdit(parent_form,
		       (last_edit == NULLWidget? form_label : last_edit),
		       val_button,
		       vert_distance,
		       first_field->this_attr->attr_type,
		       NULLString);
      
      XtAddCallback(curr_edit,
		    XtNdestroyCallback,
		    freeField,
		    (XtPointer) first_field);

      /*
       *	Hmmmm.
       */

      get_text_dims("BLANKSPACE", curr_edit, &height, &width);

      count = 0;
      
      XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
      XtSetArg(args[count], XtNheight, (Dimension) height); count++;

      XtSetValues(curr_edit, args, count);


      /*
       *	Add entries to menu
       */
	  
      menu_entry = XtCreateManagedWidget("undoChanges",
					 smeBSBObjectClass,
					 val_menu,
					 args,
					 0);
      
      XtAddCallback(menu_entry,
		    XtNcallback,
		    undoChanges,
		    (XtPointer) first_field);
      
      menu_entry = XtCreateManagedWidget("deleteValue",
					 smeBSBObjectClass,
					 val_menu,
					 args,
					 0);
      
      if (this_attr->attr_type->oa_syntax >= AV_WRITE_FILE)
	XtSetSensitive(menu_entry, FALSE);
      else
	XtAddCallback(menu_entry,
		      XtNcallback,
		      deleteValue,
		      (XtPointer) first_field);
    }

  /*
   *	Create menu entries for attr label
   */

  menu_entry = XtCreateManagedWidget("addNewVal",
				     smeBSBObjectClass,
				     attr_menu,
				     args,
				     0);

  if (this_attr->attr_type->oa_syntax >= AV_WRITE_FILE)
    XtSetSensitive(menu_entry, FALSE);
  else
    XtAddCallback(menu_entry,
		  XtNcallback,
		  addValueField,
		  (XtPointer) first_field);
  
  
  menu_entry = XtCreateManagedWidget("undoAllChanges",
				     smeBSBObjectClass,
				     attr_menu,
				     args,
				     0);

  XtAddCallback(menu_entry,
		XtNcallback,
		undoAllChanges,
		(XtPointer) first_field);


  return first_field;
} /* addAttributeValueField */


/*
 *	Procs to handle updating of modify edit fields
 *
 */
/* ARGSUSED */
static void modUpdate(edit, closure, calldata)
     Widget edit;
     XtPointer closure, calldata;
{
  modifyField this_field = (modifyField) closure;
  modifyValue mod_val = this_field->this_value;
  modifyAttr mod_attr = this_field->this_attr;

  mod_attr->to_modify = TRUE;

  if (mod_val->value == NULLString)
    mod_val->status = new;
  else
    mod_val->status = updated;
} /* modUpdate */


/*
 * - addValueField() -
 *
 *
 */
/* ARGSUSED */
static void addValueField(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  modifyField first_field = (modifyField) closure, prev_field, 
              next_field, next_managed_field, new_field;
  modifyAttr this_attr;
  modifyValue this_value;
  Widget curr_edit, prev_edit, next_edit,
         this_attr_button, this_val_button,
         next_attr_button, next_val_button,
  	 val_menu, menu_entry,
         parent_form;

  Arg args[MAXARGS];
  char strbuf[LONGSTRING];


  for (prev_field = first_field;
       prev_field != NULLModifyField && XtIsManaged(prev_field->edit) == FALSE;
       prev_field = prev_field->next)
    ;

  if (prev_field != NULLModifyField)
    prev_edit = prev_field->edit;
  else
    return;

  next_field = prev_field->next;

  for (next_managed_field = next_field;
       next_managed_field != NULLModifyField &&
       XtIsManaged(next_managed_field->edit) == FALSE;
       next_managed_field = next_managed_field->next)
    ;

  if (next_managed_field != NULLModifyField)
    next_edit = next_managed_field->edit;
  else
    next_edit = NULLWidget;

  parent_form = XtParent(prev_edit);
  XawFormDoLayout(parent_form, FALSE);

  
  new_field = mod_field_alloc();

  this_attr = new_field->this_attr = first_field->this_attr;
  new_field->this_value = this_value = modify_value_alloc();

  prev_field->next = new_field;
  new_field->next = next_field;

  new_field->first = first_field;

  this_value->next = this_attr->values->next;
  this_attr->values->next = this_value;

  this_value->value = this_value->new_value = NULLString;
  this_value->status = unchanged;


  XtSetArg(args[0], XtNfromHoriz, &this_val_button);
  XtGetValues(prev_edit, args, 1);

  XtSetArg(args[0], XtNfromHoriz, &this_attr_button);
  XtGetValues(this_val_button, args, 1);

  
  makeValueMenu(parent_form,
		prev_edit,
		this_attr_button,
		valueDistance,
		&this_val_button,
		&val_menu);

  modCallback[0].closure = (XtPointer) new_field;

  curr_edit = new_field->edit = makeModifyEdit(parent_form,
					       prev_edit,
					       this_val_button,
					       valueDistance,
					       new_field->this_attr->attr_type,
					       "");
  XtAddCallback(curr_edit,
		XtNdestroyCallback,
		freeField,
		(XtPointer) new_field);

  /*
   *    Add entries to menu
   */
  
  menu_entry = XtCreateManagedWidget("undoChanges",
				     smeBSBObjectClass,
				     val_menu,
				     args,
				     0);
  
  XtAddCallback(menu_entry,
		XtNcallback,
		undoChanges,
		(XtPointer) new_field);
  
  
  menu_entry = XtCreateManagedWidget("deleteValue",
				     smeBSBObjectClass,
				     val_menu,
				     args,
				     0);
  
  XtAddCallback(menu_entry,
		XtNcallback,
		deleteValue,
		(XtPointer) new_field);

  /*
   *	Relayout next row of widgets
   */
  
  if (next_managed_field != NULLModifyField &&
      XtParent(next_edit) == XtParent(curr_edit))
    {
      XtSetArg(args[0], XtNfromHoriz, &next_val_button);
      XtGetValues(next_edit, args, 1);

      if (next_managed_field->first != first_field)
	/*
	 *   The next field is part of the next attribute
	 */
	{
	  XtSetArg(args[0], XtNfromHoriz, &next_attr_button);
	  XtGetValues(next_val_button, args, 1);
	}
      else
	next_attr_button = NULLWidget;

      XtSetArg(args[0], XtNfromVert, curr_edit);

      XtSetValues(next_edit, args, 1);
      XtSetValues(next_val_button, args, 1);

      if (next_attr_button != NULLWidget)
	XtSetValues(next_attr_button, args, 1);
    }


  (void) strcpy(strbuf, bitmap_directory);
  (void) strcat(strbuf, "menu16");

  create_background_from_bitmap_file(this_val_button, strbuf);

  XawFormDoLayout(parent_form, TRUE);
} /* addValueField */


/*
 * - undoAllChanges() -
 *
 *
 */
/* ARGSUSED */
static void undoAllChanges(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  modifyField curr_field, first_field = (modifyField) closure;

  for (curr_field = first_field;
       curr_field != NULLModifyField && curr_field->first == first_field;
       curr_field = curr_field->next)
    undoChanges(w, (XtPointer) curr_field, (XtPointer) NULL);
} /* undoAllChanges */


/*
 * - undoChanges() -
 *
 *
 */
/* ARGSUSED */
static void undoChanges(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  Widget this_edit, prev_edit, next_edit,
         next_attr_button, this_attr_button,
         next_val_button, this_val_button,
         parent_form;
  XtCallbackList callbacks;
  Cardinal count;
  Arg args[MAXARGS];

  modifyField this_field, first_field, next_field, prev_field, tmp_field;
  modifyAttr this_attr;
  modifyValue this_value, curr_value;

  char buffer[LINESIZE];


  this_field = (modifyField) closure;

  this_edit = this_field->edit;
  this_attr = this_field->this_attr;
  this_value = this_field->this_value;

  parent_form = XtParent(this_edit);

  XawFormDoLayout(parent_form, FALSE);

  if (XtIsManaged(this_edit) == FALSE)
    /*
     *	Need to re-manage the edit field
     */
    {
      first_field = this_field->first;

      for (next_field = this_field->next;
	   next_field != NULLModifyField &&
	   XtIsManaged(next_field->edit) == FALSE;
	   next_field = next_field->next)
	;


      XtSetArg(args[0], XtNfromHoriz, &this_val_button);
      XtGetValues(this_edit, args, 1);
      
      XtSetArg(args[0], XtNfromHoriz, &this_attr_button);
      XtGetValues(this_val_button, args, 1);
      
	  
      if (next_field != NULLModifyField)
	{
	  next_edit = next_field->edit;
	  
	  XtSetArg(args[0], XtNfromHoriz, &next_val_button);
	  XtGetValues(next_edit, args, 1);
	  
	  XtSetArg(args[0], XtNfromHoriz, &next_attr_button);
	  XtGetValues(next_val_button, args, 1);
	  
	  
	  XtSetArg(args[0], XtNfromVert, &prev_edit);
	  XtGetValues(next_edit, args, 1);
	}
      else
	{
	  for (tmp_field = this_field->first;
	       tmp_field != NULLModifyField && tmp_field != this_field;
	       tmp_field = tmp_field->next)
	    if (XtIsManaged(tmp_field->edit) == TRUE)
	      prev_field = tmp_field;

	  prev_edit = prev_field->edit;
	}

      if (prev_edit != NULLWidget && 
	  lexequ(XtName(prev_edit), "FormLabel") != 0)
	{
	  XtSetArg(args[0], XtNcallback, &callbacks);
	  XtGetValues(prev_edit, args, 1);
	  
	  prev_field = (modifyField) callbacks[0].closure;
	}
      else
	prev_field = NULLModifyField;

      count = 0;
      XtSetArg(args[count], XtNfromVert, prev_edit); count++;

      if (prev_field == NULLModifyField || prev_field->first != first_field)
	/*
	 *  The previous field is from a different attribute
	 */
	{
	  XtSetArg(args[count], XtNvertDistance, attrDistance); count++;
	  XtSetValues(this_attr_button, args, count);
	}
      else
	{
	  XtSetArg(args[count], XtNvertDistance, valueDistance); count++;
	}
      
      XtSetValues(this_edit, args, count);
      XtSetValues(this_val_button, args, count);

      XtManageChild(this_val_button);
      XtManageChild(this_edit);


      /*
       *   Need to reorganize relative positions of next row of widgets
       */

      if (next_field != NULLModifyField)
	{
	  count = 0;
	  XtSetArg(args[count], XtNfromVert, this_edit); count++;

	  if (next_field->first != first_field)
	    /*
	     *	The next field forms the first field of a different
	     *	attribute
	     */
	    {
	      XtSetArg(args[count], XtNvertDistance, attrDistance); count++;
	      XtSetValues(next_attr_button, args, count);
	    }
	  else
	    {
	      XtSetArg(args[count], XtNvertDistance, valueDistance); count++;
	    }

	  XtSetValues(next_val_button, args, count);
	  XtSetValues(next_edit, args, count);
	}

    }


  /*
   *	Update strings and flags
   */

  this_value->status = unchanged;

  if (this_value->new_value != NULLString)
    {
      (void) free(this_value->new_value);
      this_value->new_value = NULLString;
    }

  if (this_value->value == NULLString)
    XtSetArg(args[0], XtNstring,"");
  else
    {
      if (this_attr->attr_type->oa_syntax == AttrT_new("2.5.4.34")->oa_syntax)
	{
	  friendlify(this_value->value, buffer);
	  XtSetArg(args[0], XtNstring, buffer);
	}
      else
	XtSetArg(args[0], XtNstring, this_value->value);
    }

  XtSetValues(this_edit, args, 1);

  for (curr_value = this_attr->values;
       curr_value != NULLModifyValue && curr_value->status == unchanged;
       curr_value = curr_value->next)
    ;

  if (curr_value == NULLModifyValue)
    this_attr->to_modify = FALSE;

  XawFormDoLayout(parent_form, TRUE);
} /* undoChanges */


/*
 *
 *
 *
 */
/* ARGSUSED */
static void deleteValue(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  Arg args[MAXARGS];
  Cardinal count;
  modifyField first_field, this_field, next_field;
  modifyAttr this_attr;
  modifyValue this_value;
  Widget next_attr_menu,
  	 next_val_menu,
         this_val_menu,
         prev_edit,
         parent_form;
  int vert_distance;
  
  /*
   *	Retrieve data for this value field, the first and next
   */

  this_field = (modifyField) closure;
  first_field = this_field->first;

  for (next_field = this_field->next;
       next_field != NULLModifyField && XtIsManaged(next_field->edit) == FALSE;
       next_field = next_field->next)
    ;

  this_attr = this_field->this_attr;
  this_value = this_field->this_value;


  /*
   *	Stop form from doing relayouts
   */

  parent_form = XtParent(this_field->edit);
  XawFormDoLayout(parent_form, FALSE);

  
  /*
   *	Check if the widget needs deleting
   */
  
  while (XtIsManaged(first_field->edit) == FALSE)
    first_field = first_field->next;

  if (first_field == this_field &&
      (next_field == NULLModifyField || next_field->this_attr != this_attr))
    {
      XtSetArg(args[0], XtNstring, "");
      XtSetValues(this_field->edit, args, 1);
    }
  else
    /*
     *	Need to destroy the widget
     */
    {
      if (next_field != NULLModifyField)
	{
	  count = 0;
	  XtSetArg(args[count], XtNvertDistance, &vert_distance); count++;
	  XtSetArg(args[count], XtNfromVert, &prev_edit); count++;
	  
	  XtGetValues(this_field->edit, args, count);
	
	  XtSetArg(args[0], XtNfromHoriz, &next_val_menu);
	  XtGetValues(next_field->edit, args, 1);
      
	  XtSetArg(args[0], XtNfromHoriz, &next_attr_menu);
	  XtGetValues(next_val_menu, args, 1);
	      
	  count = 0;
	  XtSetArg(args[count], XtNfromVert, prev_edit); count++;

	  if (next_field->this_attr != this_attr)
	    {
	      XtSetArg(args[count], XtNvertDistance, attrDistance); count++;
	      XtSetValues(next_attr_menu, args, count);
	    }
	  else
	    {
	      XtSetArg(args[count], XtNvertDistance, vert_distance); count++;
	    }

	  XtSetValues(next_val_menu, args, count);
	  XtSetValues(next_field->edit, args, count);
	}
      
      XtSetArg(args[0], XtNfromHoriz, &this_val_menu);
      XtGetValues(this_field->edit, args, 1);
      
      XtUnmanageChild(this_field->edit);
      XtUnmanageChild(this_val_menu);
    }


  this_attr->to_modify = TRUE;
  this_value->status = deleted;

  if (this_value->new_value != NULLString)
    {
      XtFree((char *) this_value->new_value);
      this_value->new_value = NULLString;
    }

  XawFormDoLayout(parent_form, TRUE);
} /* deleteValue */


/*
 *	Miscellaneous procs
 *
 *
 */
/* ARGSUSED */
static void freeModAttrList(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  modifyAttr attr_list = (modifyAttr) closure;

  free_mod_attr_list(&attr_list);
} /* freeModAttrList */



/*
 *	Procs for edit field focus
 *
 *
 */
/* ARGSUSED */
void doSetModifyFocus(focus_on, event, params, num_params)
     Widget focus_on;
     XEvent *event;
     String *params;
     Cardinal num_params;
{
  Widget must_form, may_form, top_form, name, top_edit, curr_edit;
  modifyField top_field, curr_field;
  Cardinal count;
  Arg args[MAXARGS];
  XtCallbackList callbacks;

  if (lexequ(XtName(focus_on), "modifyEntryLabel") == 0)
    {
      top_form = XtParent(focus_on);
      name = focus_on;
    }
  else
    {
      top_form = XtParent(XtParent(focus_on));
      name = XtNameToWidget(top_form, "modifyEntryLabel");
    }

  must_form = XtNameToWidget(top_form, "mustViewForm");
  may_form = XtNameToWidget(top_form, "mayViewForm");

  if ((top_edit = XtNameToWidget(must_form, "modifyEdit")) == NULLWidget)
    top_edit = XtNameToWidget(may_form, "modifyEdit");

  XtSetArg(args[0], XtNfromVert, &top_edit);
  
  curr_edit = top_edit;
  
  while (lexequ(XtName(top_edit), "FormLabel") != 0)
    {
      curr_edit = top_edit;
      XtGetValues(top_edit, args, 1);
    }
  
  count = 0;
  XtSetArg(args[count], XtNcallback, &callbacks); count++;
  XtGetValues(curr_edit, args, count);
  
  top_field = (modifyField) callbacks[0].closure;
  top_edit = top_field->edit;

  XtSetArg(args[0], XtNdisplayCaret, FALSE);

  for (curr_field = top_field;
       curr_field != NULLModifyField;
       curr_field = curr_field->next)
    if (curr_field->edit != NULLWidget)
      XtSetValues(curr_field->edit, args, 1);

  name = XtNameToWidget(top_form, "modifyEntryLabel");
  XtSetValues(name, args, 1);

  XtSetArg(args[0], XtNdisplayCaret, TRUE);
  XtSetValues(focus_on, args, 1);
  
  XtSetKeyboardFocus(top_form, focus_on);
} /* doSetModifyFocus */


/*
 * - doChangeModifyFocus() -
 *
 *
 */
/* ARGSUSED */
void doChangeModifyFocus(focussed, event, params, num_params)
     Widget focussed;
     XEvent *event;
     String *params;
     Cardinal num_params;
{
  Widget must_form, may_form, top_form,
         next, name, top_edit, curr_edit, vscroll;
  modifyField top_field, curr_field;

  Arg args[MAXARGS];
  XtCallbackList callbacks;

  String scrollback = "Backward",
         fullscroll = "FullLength";
  XEvent scroll_event;


  if (lexequ(XtName(focussed), "modifyEntryLabel") == 0)
    {
      top_form = XtParent(focussed);
      name = focussed;
    }
  else
    {
      top_form = XtParent(XtParent(focussed));
      name = XtNameToWidget(top_form, "modifyEntryLabel");

      XtSetArg(args[0], XtNcallback, &callbacks);
      XtGetValues(focussed, args, 1);

      curr_field = (modifyField) callbacks[0].closure;
      curr_field->is_active = FALSE;
    }

  
  must_form = XtNameToWidget(top_form, "mustViewForm");
  may_form = XtNameToWidget(top_form, "mayViewForm");

  if ((top_edit = XtNameToWidget(must_form, "modifyEdit")) == NULLWidget)
    top_edit = XtNameToWidget(may_form, "modifyEdit");

  XtSetArg(args[0], XtNfromVert, &top_edit);
  
  curr_edit = top_edit;
  
  while (lexequ(XtName(top_edit), "FormLabel") != 0)
    {
      curr_edit = top_edit;
      XtGetValues(top_edit, args, 1);
    }
  
  XtSetArg(args[0], XtNcallback, &callbacks);
  XtGetValues(curr_edit, args, 1);
  
  top_field = (modifyField) callbacks[0].closure;
  top_edit = top_field->edit;


  if (name != focussed)
    {
      for (curr_field = top_field;
	   curr_field != NULLModifyField;
	   curr_field = curr_field->next)
	if (curr_field->edit == focussed)
	  {
	    curr_field = curr_field->next;
	    
	    while (curr_field != NULLModifyField &&
		   curr_field->edit == NULLWidget)
	      curr_field = curr_field->next;
	    
	    if (curr_field == NULLModifyField)
	      next = name;
	    else
	      next = curr_field->edit;
	    
	    break;
	  }
    }
  else
    {
      for (curr_field = top_field;
	   curr_field->edit == NULLWidget && curr_field != NULLModifyField;
	   curr_field = curr_field->next)
	;

      next = curr_field->edit;
    }

  if (curr_field != NULLModifyField)
    curr_field->is_active = TRUE;

  XtSetArg(args[0], XtNdisplayCaret, TRUE);
  XtSetValues(next, args, 1);

  XtSetKeyboardFocus(top_form, next);
  
  XtSetArg(args[0], XtNdisplayCaret, FALSE);
  XtSetValues(focussed, args, 1);

  
  vscroll = XtNameToWidget(XtParent(top_form), "vertical");

  if (next == name)
    /*
     *	If focus has trensferred to name edit, then scroll to top
     */
    {
      scroll_event.type = ClientMessage;
      scroll_event.xclient.serial = 0;
      scroll_event.xclient.send_event = TRUE;
      scroll_event.xclient.display = XtDisplay(vscroll);
      scroll_event.xclient.window = XtWindow(vscroll);
      scroll_event.xclient.message_type = XA_CARDINAL;
      scroll_event.xclient.format = 32;

      XtCallActionProc(vscroll, "StartScroll", &scroll_event, &scrollback, 1);
      XtCallActionProc(vscroll, "NotifyScroll", &scroll_event, &fullscroll, 1);
      XtCallActionProc(vscroll, "NotifyScroll", &scroll_event, &fullscroll, 1);
      XtCallActionProc(vscroll, "EndScroll", &scroll_event, (String *)NULL, 0);
    }
}

/*
 * - makeMenuBitmaps() -
 *
 *
 */
static void makeMenuBitmaps(first, do_all_of_type, do_all)
     modifyField first;
     Boolean do_all_of_type, do_all;
{
  char bitmap_file_name[LINESIZE];

  Arg args[MAXARGS];
  Widget menu, edit;

  modifyField curr_field = first;

  if (curr_field == NULLModifyField)
    return;

  (void) strcpy(bitmap_file_name, bitmap_directory);
  (void) strcat(bitmap_file_name, "menu16");


  XtSetArg(args[0], XtNfromHoriz, &menu);

  do 
    {
      do
	{
	  edit = curr_field->edit;
	  XtGetValues(edit, args, 1);
	  
	  create_background_from_bitmap_file(menu, bitmap_file_name);
	  
	  curr_field = curr_field->next;
	}
      while (curr_field != NULLModifyField &&
	     curr_field->first == first &&
	     do_all_of_type == TRUE);
    }
  while (curr_field != NULLModifyField &&
	 do_all == TRUE);
} /* makeMenuBitmaps */


static Widget makeModifyEdit(parent,from_vert,from_horiz,distance,type,value)
     Widget parent, from_vert, from_horiz;
     int distance;
     AttributeType type;
     String value;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget edit;
  int width, height;

  count = 0;

  XtSetArg(args[count], XtNfromVert, from_vert); count++;
  XtSetArg(args[count], XtNfromHoriz, from_horiz); count++;
  
  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNresize, XawtextResizeBoth); count++;
  
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;
  
  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;
  
  if (type->oa_syntax != str2syntax("dn") ||
      value == NULLString ||
      *value == '\0')
    {
      XtSetArg(args[count], XtNstring, value); count++;
    }
  else
    {
      char ufname[LINESIZE];

      friendlify(value, ufname);
      XtSetArg(args[count], XtNstring, ufname); count++;
    }

  XtSetArg(args[count], XtNeditType, XawtextEdit); count++;
  
  XtSetArg(args[count], XtNcallback, modCallback); count++;
  XtSetArg(args[count], XtNvertDistance, distance); count++;
  
  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;

  edit = XtCreateManagedWidget("modifyEdit",
			       asciiTextWidgetClass,
			       parent,
			       args,
			       count);

  /*
   *	Translations for edit
   */

  if (tt_tab == (XtTranslations) NULL)
    tt_tab = XtParseTranslationTable(trans_tab);

  if (tb_tab == (XtTranslations) NULL)
    tb_tab = XtParseTranslationTable(trans_btn1);

  /*
   *	New lines not allowed in certain attributes
   */
  
  if (type->oa_syntax == str2syntax("dn") ||
      type->oa_syntax == str2syntax("acl"))
    {
      if (trn_tab == (XtTranslations) NULL)
	trn_tab = XtParseTranslationTable(trans_ret_nothing);

      XtOverrideTranslations(edit, trn_tab);
    }

  XtOverrideTranslations(edit, tt_tab);
  XtOverrideTranslations(edit, tb_tab);


  /*
   *	Put some default dimensions in
   */

  if (value == NULLString || *value == '\0')
    get_text_dims("BLANKSPACE", edit, &height, &width);
  else
    get_text_dims(value, edit, &height, &width);


  count = 0;
  
  XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
  XtSetArg(args[count], XtNheight, (Dimension) height); count++;
  
  XtSetValues(edit, args, count);

  return edit;
} /* makeModifyEdit */



static void makeValueMenu(parent,
			  from_vert,
			  from_horiz,
			  distance,
			  button_ptr,
			  menu_ptr)
     Widget parent, from_vert, from_horiz;
     int distance;
     Widget *button_ptr, *menu_ptr;
{
  Cardinal count;
  Arg args[MAXARGS];
  Widget button;
  
  count = 0;

  XtSetArg(args[count], XtNfromVert, from_vert); count++;
  XtSetArg(args[count], XtNfromHoriz, from_horiz); count++;
  
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;
  
  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNvertDistance, distance); count++;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  *button_ptr = button = XtCreateManagedWidget("valMenuButton",
					       menuButtonWidgetClass,
					       parent,
					       args,
					       count);

  count = 0;

  XtSetArg(args[count], XtNsensitive, TRUE); count++;
  XtSetArg(args[count], XtNancestorSensitive, TRUE); count++;
  
  *menu_ptr = XtCreatePopupShell("menu",
				 simpleMenuWidgetClass,
				 button,
				 args,
				 count);
} /* makeValueMenu */


/*
 * - saveTopAttr() -
 * 
 *
 */
/* ARGSUSED */
static void saveTopAttr(edit, closure, calldata)
     Widget edit;
     XtPointer closure, calldata;
{
  ;
}


/*
 *
 *
 *
 */
/* ARGSUSED */
static void setEntryClass(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  Cardinal object_id;

  object_id = get_object_id(w);

  postQueryMessage(object_id,
		   "Changing entry class will clear the entry displayed in this window.\nAre you sure you want to do this?",
		   TRUE,
		   (XtCallbackProc) doSetEntryClass,
		   (XtCallbackProc) doNotSetEntryClass,
		   (XtPointer) w);
} /* setEntryClass */


/*
 * - doSetEntryClass() -
 * The user has Ok'ed the change in entry class setting.
 *
 */
/* ARGSUSED */
static void doSetEntryClass(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  Cardinal object_id;
  WidgetList modify_prims;
  Widget modify, name_edit, class_menu_item, commit_button, delete_button;

  Arg args[MAXARGS];
  XtCallbackList callbacks;

  stringCell class_name_list = NULLStrCell;
  entryClass to_class;
  modifyAttr must_in, may_in, must_out, may_out;
  

  deleteQueryMessage(w);

  class_menu_item = (Widget) closure;
  object_id = get_object_id(class_menu_item);

  XtSetArg(args[0], XtNcallback, &callbacks);
  XtGetValues(class_menu_item, args, 1);

  to_class = (entryClass) callbacks[0].closure;


  setStatusMessage(object_id, "Changing entry class");

  modify_prims = find_prim_instances(object_id, MODIFY);

  if (modify_prims == (Widget *) NULL)
    return;

  modify = modify_prims[0];
  
  XtFree((char *) modify_prims);

  name_edit = XtNameToWidget(modify,
			     "modifyWindow.modifyViewForm.modifyEntryLabel");

  commit_button = XtNameToWidget(modify, "commitModificationsButton");
  delete_button = XtNameToWidget(modify, "deleteEntryButton");


  XtSetArg(args[0], XtNstring, "");
  XtSetValues(name_edit, args, 1);

  add_string_to_seq(to_class->name, &class_name_list);

  makeClassTemplate(to_class, &must_in, &must_out, &may_in, &may_out);

  updateModifyForm(modify,
		   class_name_list,
		   must_in,
		   may_in,
		   must_out,
		   may_out,
		   NULLError,
		   NULLString);

  XtSetSensitive(commit_button, FALSE);
  XtSetSensitive(delete_button, FALSE);
}

/*
 * - doNotSetEntryClass() -
 * The user has Cancel'ed the change in entry class.
 *
 */
/* ARGSUSED */
static void doNotSetEntryClass(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  Cardinal object_id = (Cardinal) closure;

  deleteQueryMessage(w);

  object_id = get_object_id((Widget) closure);

  setStatusMessage(object_id, "Entry class unchanged");
}


/*
 * destroy procedures
 *
 *
 */

/*
 * - freeOldAttrs() -
 * Free up list of old attributes
 *
 */
/* ARGSUSED */
static void freeOldAttrs(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  modifyAttr list = (modifyAttr) closure;
  
  free_mod_attr_list(&list);
} /* freeOldAttrs */


/*
 * - freeField() -
 * Free up old field records.
 *
 */
/* ARGSUSED */
static void freeField(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  modifyField list = (modifyField) closure;

  if (list == NULLModifyField)
    return;

  XtFree((char *) list);
} /* freeField */
