#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/modify_ops.c,v 0.95 91/09/02 11:37:03 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/modify_ops.c,v 0.95 91/09/02 11:37:03 emsrdsm Exp Locker: emsrdsm $ */


/*****************************************************************************

  modify_ops.c -

*****************************************************************************/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>

#include <X11/Form.h>
#include <X11/Command.h>

#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/MenuButton.h>

#include <X11/Viewport.h>
#include <X11/AsciiText.h>

#include "query.h"
#include "quipu/common.h"

#include "defs.h"

#include "windows.h"
#include "requests.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"

#include "modify_form.h"
#include "status_bar.h"
#include "error_view.h"

/*
 *	Externs....
 */

extern windowObject win_objects[];
extern Display *dpy;
extern Widget toplevel;

extern void updateModifyForm();

/*
 *	Static procs...
 */
static void updateModifyData();
static void addAttrToList();
static void putDefaultValues();

/*
 *	Global data
 */

entryClass entry_class_list = NULLEntryClass;
attrOcRule attr_oc_list = NULLAttrOcRule;
attrTemplate attr_template_list = NULLAttrTemplate;
String base_entry_class = NULLString;


/*
 *     Procedures to submit any modifications made
 *
 *
 */

/*
 * - doSubmitModifyAction() -
 *
 */
/* ARGSUSED */
void doSubmitModifyAction(prim_widget,
			  object_id,
			  prim_id,
			  action_id,
			  trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  windowObject this_object = win_objects[object_id];
  QCardinal request_id;

  WidgetList prim_insts;
  Widget name_edit, top_edit, curr_edit;
  Arg args[MAXARGS];
  XtCallbackList callbacks;

  String strdn, strval, new_name;
  char old_name[LINESIZE];

  modifyField top_field, curr_field;
  modifyAttr attr_list;
  modifyValue curr_val;

  errorList errors;


  /*
   *	Get the modify primitive
   */

  prim_insts = find_prim_instances(object_id, MODIFY);

  if (prim_insts == (Widget *) NULL)
    {
      setStatusMessage(object_id, "No modify information to submit!");
      return;
    }

  /*
   *	Get the top field, which has a pointer to the head of the
   *	modifyAttr list buried in it.
   */

  top_edit = XtNameToWidget(prim_insts[0],
			"modifyWindow.modifyViewForm.mustViewForm.modifyEdit");

  name_edit = XtNameToWidget(prim_insts[0],
			     "modifyWindow.modifyViewForm.modifyEntryLabel");

  XtFree((char *) prim_insts);

  XtSetArg(args[0], XtNfromVert, &top_edit);

  while (lexequ(XtName(top_edit), "FormLabel") != 0)
    {
      curr_edit = top_edit;
      XtGetValues(curr_edit, args, 1);
    }

  top_edit = curr_edit;

  XtSetArg(args[0], XtNcallback, &callbacks);
  XtGetValues(top_edit, args, 1);

  top_field = (modifyField) callbacks[0].closure;


  /*
   *	Get the the attribute list (does not correlate
   *	to attribute of first edit field).
   */
  
  XtGetValues(name_edit, args, 1);
  
  attr_list = (modifyAttr) callbacks[0].closure;
  

  /*
   *	Put the modified strings into the list of values
   */
  
  XtSetArg(args[0], XtNstring, &strval);

  for (curr_field = top_field;
       curr_field != NULLModifyField;
       curr_field = curr_field->next)
    if (curr_field->this_value->status != unchanged)
      {
	curr_val = curr_field->this_value;

	/*
	 *	Get the string value contained in the edit field,
	 *	if it's different put it in the list as a new value
	 *
	 */

	if (curr_val->status != deleted)
	  {
	    char *end;

	    XtGetValues(curr_field->edit, args, 1);

	    while (isspace(*strval))
	      strval++;

	    for (end = strval;
		 *end != '\0';
		 end++)
	      ;

	    while (isspace(*--end))
	      *end = '\0';
	  }
	else
	  strval = NULLString;

	switch (curr_val->status)
	  {
	  case updated:

	    if (strval == NULLString || *strval == '\0')
	      curr_val->status = deleted;
	    else
	      {
		if (strcmp(curr_val->value, strval) != 0)
		  curr_val->new_value = XtNewString(strval);
		else
		  curr_val->status = unchanged;
	      }
	    
	    break;


	  case new:

	    if (strval == NULLString || *strval != '\0')
	      curr_val->new_value = XtNewString(strval);
	    else
	      curr_field->this_value->status = unchanged;

	    break;


	  case deleted:

	    if (curr_val->value == NULLString || *curr_val->value == '\0')
	      {
		curr_val->status = unchanged;

		if (curr_val->new_value != NULLString)
		  {
		    XtFree(curr_val->new_value);
		    curr_val->new_value = NULLString;
		  }
	      }

	    break;
	  }

	if (curr_field->edit != NULLWidget)
	  XawAsciiSourceFreeString(curr_field->edit);
      }

  /*
   *	Get the new name
   */

  XtSetArg(args[0], XtNstring, &new_name);
  
  XtGetValues(name_edit, args, 1);

  friendlify(this_object->current_entry, old_name);

  if (strcmp(new_name, old_name) == 0)
    /*
     *	This is a bit too simple!
     */
    new_name = NULLString;


  /*
   *	Do the modification
   */
  
  strdn = this_object->current_entry;

  if (strdn != NULLString)
    errors = do_update(&request_id, strdn, new_name, attr_list);
  else
    {
      XawAsciiSourceFreeString(name_edit);

      XBell(dpy, 40);

      setStatusMessage(object_id, "No current entry to modify!");

      doActionAux(prim_widget,
		  object_id,
		  prim_id,
		  action_id,
		  trans_list? trans_list->next : NULLTransList);
      
      return;
    }


  XawAsciiSourceFreeString(name_edit);

  if (errors != NULLError)
    {
      errorList curr_error;

      XBell(dpy, 40);

      for (curr_error = errors;
	   curr_error != NULLError;
	   curr_error = curr_error->next)
	if (curr_error->error_type != QERR_no_mods_supplied &&
	    curr_error->error_type != QERR_no_name_changes)
	  break;

      if (curr_error != NULLError)
	{
	  if (curr_error->ds_message != NULLCP)
	    setStatusMessage(object_id, curr_error->ds_message);
	  else
	    setStatusMessage(object_id,
			     get_message_of_code(curr_error->error_type));

	  set_current_errors(object_id, errors);
	}
      else
	{
	  setStatusMessage(object_id, "No modifications to make!");
	  
	  error_list_free(&errors);

	  set_current_errors(object_id, NULLError);
	}
      
      doActionAux(prim_widget,
		  object_id,
		  prim_id,
		  action_id,
		  trans_list? trans_list->next : NULLTransList);
      
      return;
    }


  /*
   *	Record request invocation
   */

  request_invoked(request_id,
		  MODIFY_ENTRY,
		  prim_widget,
		  object_id,
		  prim_id,
		  action_id,
		  trans_list);

  XBell(dpy, 40);
      
  setStatusMessage(object_id, "Submitting modifications. Please wait.");
} /* doSubmitModifyAction */


/*
 * - gotSubmitModifyResult() -
 *
 *
 */
/* ARGSUSED */
void gotSubmitModifyResult(request_id, this_object_id, action_id, trans_list)
     Cardinal request_id;
     Cardinal this_object_id;
     actionID action_id;
     translationList trans_list;
{
  updateResult result;

  WidgetList prim_insts;
  Widget top_edit, curr_edit, name_edit;
  Arg args[MAXARGS];
  XtCallbackList callbacks;

  int err_num;
  char err_msg[LINESIZE], entry_name[LINESIZE];
  errorList curr_error;

  XBell(dpy, 40);

  setStatusMessage(this_object_id, "Modification result received");

  result = get_update_result(request_id);

  if (result->was_successful == TRUE)
    /*
     *	The modifications were performed successfully. Notify the user
     *  and update modification data.
     */
    {
      setStatusMessage(this_object_id, "Modifications successfully submitted");

      prim_insts = find_prim_instances(this_object_id, MODIFY);
      curr_edit = XtNameToWidget(prim_insts[0],
			"modifyWindow.modifyViewForm.mustViewForm.modifyEdit");

      
      XtFree((char *) prim_insts);

      top_edit = NULLWidget;

      XtSetArg(args[0], XtNfromVert, &curr_edit);
      
      while (lexequ(XtName(curr_edit), "FormLabel") != 0)
	{
	  top_edit = curr_edit;
	  XtGetValues(top_edit, args, 1);
	}

      XtSetArg(args[0], XtNcallback, &callbacks);
      XtGetValues(top_edit, args, 1);

      updateModifyData((modifyField) callbacks[0].closure);

      if (result->updated_object != NULLString)
	{
	  set_current_entry(this_object_id, result->updated_object);

	  friendlify(result->updated_object, entry_name);
	  
	  name_edit = XtNameToWidget(prim_insts[0],
			     "modifyWindow.modifyViewForm.modifyEntryLabel");

	  XtSetArg(args[0], XtNstring, entry_name);
	  XtSetValues(name_edit, args, 1);
	}
    }
  else
    {
      QBool no_mods = TRUE;

      for (curr_error = result->errors, err_num = 0;
	   curr_error != NULLError;
	   curr_error = curr_error->next, err_num++)
	if (curr_error->error_type != QERR_no_mods_supplied &&
	    curr_error->error_type != QERR_no_name_changes)
	  no_mods = FALSE;
	else
	  err_num--;


      if (no_mods == TRUE)
	setStatusMessage(this_object_id,
			 get_message_of_code(QERR_no_mods_supplied));
      else if (result->modify_attempted == TRUE &&
	       result->modify_succeeded == FALSE)
	{
	  if (err_num == 1)
	    {
	      for (curr_error = result->errors;
		   curr_error != NULLError &&
		   (curr_error->error_type == QERR_no_mods_supplied ||
		    curr_error->error_type == QERR_no_name_changes);
		   curr_error = curr_error->next)
		;
	      
	      if (curr_error != NULLError)
		setStatusMessage(this_object_id,
				 get_message_of_code(curr_error->error_type));
	      else
		setStatusMessage(this_object_id,
				 get_message_of_code(QERR_internal));
	    }
	  else
	    {
	      (void) sprintf(err_msg,
			     "Modifications failed, with %d errors!",
			     err_num);

	      setStatusMessage(this_object_id, err_msg);
	    }
	}
      else if (result->rename_attempted == TRUE &&
	       result->rename_succeeded == FALSE)
	{
	  if (err_num == 1)
	    {
	      for (curr_error = result->errors;
		   curr_error != NULLError &&
		   (curr_error->error_type == QERR_no_mods_supplied ||
		    curr_error->error_type == QERR_no_name_changes);
		   curr_error = curr_error->next)
		;
	      
	      if (curr_error != NULLError)
		{
		  (void) sprintf(err_msg,
				 "Rename operation failed becuase;\n%s",
				 get_message_of_code(curr_error->error_type));

		  setStatusMessage(this_object_id, err_msg);
		}
	      else
		setStatusMessage(this_object_id,
				 get_message_of_code(QERR_internal));
	    }
	  else
	    (void) sprintf(err_msg,
			   "Rename operation failed with %d errors",
			   err_num);

	  setStatusMessage(this_object_id, err_msg);
	}
      else if (result->rename_succeeded == FALSE ||
	       result->modify_succeeded == FALSE)
	{
	  if (err_num == 1)
	    {
	      for (curr_error = result->errors;
		   curr_error != NULLError &&
		   (curr_error->error_type == QERR_no_mods_supplied ||
		    curr_error->error_type == QERR_no_name_changes);
		   curr_error = curr_error->next)
		;
	      
	      if (curr_error != NULLError)
		{
		  (void) sprintf(err_msg,
				 "Update operation failed because;\n%s",
				 get_message_of_code(curr_error->error_type));

		  setStatusMessage(this_object_id, err_msg);
		}
	      else
		setStatusMessage(this_object_id,
				 get_message_of_code(QERR_internal));
	    }
	  else
	    (void) sprintf(err_msg,
			   "Update operation failed with %d errors",
			   err_num);

	  setStatusMessage(this_object_id, err_msg);
	}
    }

  set_current_errors(this_object_id, result->errors);
  result->errors = NULLError;

  request_complete(request_id);
  
  free_update_result(&result);
} /* gotSubmitModifyResult */




/*
 * - updateModifyData() -
 *
 *
 */
static void updateModifyData(field_list)
     modifyField field_list;
{
  modifyField curr_field, prev_field, tmp_field;
  modifyAttr curr_attr;
  modifyValue curr_value, prev_value;
  Widget this_edit, this_val_button;
  Arg args[MAXARGS];
  int width, height;
  String str;

  curr_field = field_list;
  prev_field = NULLModifyField;

  while (curr_field != NULLModifyField)
    if (curr_field->this_value->status != unchanged)
      {
	curr_attr = curr_field->this_attr;
	curr_attr->to_modify = FALSE;

	curr_value = curr_field->this_value;

	switch (curr_value->status)
	  {
	  case deleted:

	    if (curr_value->value != NULLString)
	      (void) free(curr_value->value);
	    
	    if (curr_value->new_value != NULLString)
	      (void) free(curr_value->new_value);

	    if (XtIsManaged(curr_field->edit) == FALSE)
	      /*
	       *	This value has been deleted and has no 
	       *	edit widget associated with it, so delete its'
	       *	field record and modify_value record
	       *
	       */
	      {
		if (curr_attr->values == curr_value)
		  curr_attr->values = curr_value->next;
		else
		  {
		    for (prev_value = curr_attr->values;
			 prev_value->next != curr_value;
			 prev_value = prev_value->next)
		      ;

		    prev_value->next = curr_value->next;
		  }

		this_edit = curr_field->edit;

		XtSetArg(args[0], XtNfromHoriz, &this_val_button);
		XtGetValues(this_edit, args, 1);

		(void) free((char *) curr_value);
		
		if (curr_field->first == curr_field)
		  for (tmp_field = curr_field->next;
		       tmp_field != NULLModifyField &&
		       tmp_field->first != curr_field;
		       tmp_field = tmp_field->next)
		    tmp_field->first = curr_field->next;
		
		if (prev_field != NULLModifyField)
		  prev_field->next = curr_field->next;
		
		curr_field = curr_field->next;
		
		XtDestroyWidget(this_edit);
		XtDestroyWidget(this_val_button);
	      }
	    else
	      {
		curr_value->status = unchanged;

		prev_field = curr_field;
		curr_field = curr_field->next;
	      }

	    break;


	  case updated:
	  case new:

	    if (curr_attr->attr_type->oa_syntax < AV_WRITE_FILE)
	      {
		if (curr_value->value != NULLString)
		  (void) free(curr_value->value);
		
		str = curr_value->value = curr_value->new_value;
	      }
	    else
	      {
		(void) free(curr_value->new_value);
		str = "";
	      }
	    
	    curr_value->new_value = NULLString;
	    curr_value->status = unchanged;

	    if (curr_field->edit!= NULLWidget && XtIsManaged(curr_field->edit))
	      {
		if (curr_attr->attr_type->oa_syntax == str2syntax("dn") &&
		    str != NULLString && *str != '\0')
		  {
		    char fname[LINESIZE];
		    
		    friendlify(str, fname);
		    str = fname;
		  }
		
		XtSetArg(args[0], XtNstring, str);
		XtSetValues(curr_field->edit, args, 1);


		if (str != NULLString && *str != '\0')
		  get_text_dims(str, curr_field->edit, &height, &width);
		else
		  get_text_dims("BLANKSPACE", curr_field->edit,&height,&width);

		XtSetArg(args[0], XtNwidth, (Dimension) width);
		XtSetArg(args[1], XtNheight, (Dimension) height);

		XtSetValues(curr_field->edit, args, 2);
	      }

	    prev_field = curr_field;
	    curr_field = curr_field->next;

	    break;


	  default:

	    prev_field = curr_field;
	    curr_field = curr_field->next;
	  }
      }
    else
      {
	prev_field = curr_field;
	curr_field = curr_field->next;
      }
} /* updateModifyData */



/*
 * - gotEntryTemplateResult() -
 *
 *
 */
/* ARGSUSED */
void gotEntryTemplateResult(request_id, this_object_id, action_id, trans_list)
     Cardinal request_id;
     Cardinal this_object_id;
     actionID action_id;
     translationList trans_list;
{
  makeTemplateResult result;
  WidgetList prim_insts;
  modifyAttr must_in, may_in, must_out, may_out, last_attr, curr_attr;
  modifyValue curr_oc;
  entryClass curr_class = entry_class_list;
  attrTypeList curr_attr_type;
  stringCell class_name_list = NULLStrCell;
  char err_msg[LINESIZE], entry[LINESIZE];

  /*
   *	Notify the user
   */

  XBell(dpy, 40);
  setStatusMessage(this_object_id, "Read result recieved.");


  /*
   *	Didn't request any attributes so find out the entryClass
   *	of this entry and sort the user requested attributes out
   */

  result = get_make_template_result(request_id);

  if (result->errors != NULLError)
    {
      friendlify(result->errors->baseobject, entry);
      (void) sprintf(err_msg,
		     "Couldn't read `%.24s' because;\n%s",
		     entry,
		     get_message_of_code(result->errors->error_type));

      set_current_errors(this_object_id, result->errors);
      result->errors = NULLError;
		     
      setStatusMessage(this_object_id, err_msg);
    }
  else
    {
      must_out = result->must_exc;
      may_out = result->may_exc;
      
      must_in = may_in = NULLModifyAttr;
      
      for (curr_oc = result->object_class->values;
	   curr_oc != NULLModifyValue;
	   curr_oc = curr_oc->next)
	for (curr_class = entry_class_list;
	     curr_class != NULLEntryClass;
	     curr_class = curr_class->next)
	  if (name2oc(curr_oc->value) ==
	      name2oc(curr_class->oc_list->type->oa_ot.ot_stroid))
	    {
	      add_string_to_seq(curr_class->name, &class_name_list);
	      
	      for (curr_attr_type = curr_class->default_attrs;
		   curr_attr_type != NULLAttrTypeList;
		   curr_attr_type = curr_attr_type->next)
		{
		  for (curr_attr = must_out, last_attr = NULLModifyAttr;
		       curr_attr != NULLModifyAttr;
		       last_attr = curr_attr, curr_attr = curr_attr->next)
		    if (curr_attr->attr_type == curr_attr_type->type)
		      {
			if (last_attr == NULLModifyAttr)
			  {
			    must_out = curr_attr->next;
			    
			    curr_attr->next = must_in;
			    must_in = curr_attr;
			    
			    curr_attr = must_out;
			  }
			else
			  {
			    last_attr->next = curr_attr->next;
			    
			    curr_attr->next = must_in;
			    must_in = curr_attr;
			    
			    curr_attr = last_attr->next == NULLModifyAttr ?
			      last_attr :
				last_attr->next;
			  }
		      }
		  
		  
		  for (curr_attr = may_out, last_attr = NULLModifyAttr;
		       curr_attr != NULLModifyAttr;
		       last_attr = curr_attr, curr_attr = curr_attr->next)
		    if (curr_attr->attr_type == curr_attr_type->type)
		      {
			if (last_attr == NULLModifyAttr)
			  {
			    may_out = curr_attr->next;
			    
			    curr_attr->next = may_in;
			    may_in = curr_attr;
			    
			    curr_attr = may_out;
			  }
			else
			  {
			    last_attr->next = curr_attr->next;
			    
			    curr_attr->next = may_in;
			    may_in = curr_attr;
			    
			    curr_attr = last_attr->next == NULLModifyAttr ?
			      last_attr :
				last_attr->next;
			  }
		      }
		}
	    }
      
      result->may_request = NULLModifyAttr;
      result->must_request = NULLModifyAttr;
      
      result->may_exc = NULLModifyAttr;
      result->must_exc = NULLModifyAttr;

      prim_insts = find_prim_instances(this_object_id, MODIFY);
      
      if (prim_insts != (Widget *) NULL)
	{
	  updateModifyForm(prim_insts[0],
			   class_name_list,
			   must_in,
			   may_in,
			   must_out,
			   may_out,
			   result->errors,
			   result->base_object);
	  
	  XtFree((char *) prim_insts);
	  setStatusMessage(this_object_id, "");
	  
	  set_current_errors(this_object_id, NULLError);
	}
    }

  request_complete(request_id);

  free_make_template_result(&result);
  free_string_seq(&class_name_list);
} /* gotEntryTemplateResult */

/*
 * - doDeleteEntryAction() -
 *
 *
 */
void doDeleteEntryAction(prim_widget, object_id, prim_id, action_id,trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  windowObject this_object = win_objects[object_id];
  QCardinal request_id;
  WidgetList prim_insts;
  char *delete_entry;
  errorList errors;

  /*
   *    Get the modify primitive
   */
  prim_insts = find_prim_instances(object_id, MODIFY);

  if (prim_insts == (Widget *) NULL)
    {
      setStatusMessage(object_id, "Cannot delete if modify form not present!");
      return;
    }

  XtFree((char *) prim_insts);



  if ((delete_entry = this_object->current_entry) == NULLString ||
      *delete_entry == '\0')
    {
      XBell(dpy, 40);

      setStatusMessage(object_id, "No current entry to delete!");
      
      doActionAux(prim_widget,
                  object_id,
                  prim_id,
                  action_id,
                  trans_list? trans_list->next : NULLTransList);

      return;
    }

  if ((errors = do_delete(&request_id, delete_entry)) != NULLError)
    {
      XBell(dpy, 40);

      setStatusMessage(object_id, get_message_of_code(errors->error_type));

      set_current_errors(object_id, errors);

      doActionAux(prim_widget,
                  object_id,
                  prim_id,
                  action_id,
                  trans_list? trans_list->next : NULLTransList);
      
      return;
    }

  /*
   *    Record request invocation
   */

  request_invoked(request_id,
                  DELETE_ENTRY,
                  prim_widget,
                  object_id,
                  prim_id,
                  action_id,
                  trans_list);

  XBell(dpy, 40);

  setStatusMessage(object_id, "Deleting entry. Please wait.");
} /* doDeleteEntryAction */

/*
 * - gotDeleteEntryResult() -
 *
 *
 */
/* ARGSUSED */
void gotDeleteEntryResult(request_id, this_object_id, action_id, trans_list)
     Cardinal request_id;
     Cardinal this_object_id;
     actionID action_id;
     translationList trans_list;
{
  deleteResult result;
  WidgetList prim_insts;
  Widget name_edit;
  Arg args[MAXARGS];
  char err_msg[LINESIZE];
  
  XBell(dpy, 40);

  setStatusMessage(this_object_id, "Delete entry result received");

  result = get_delete_result(request_id);

  if (result->was_successful == TRUE)
    /*
     *  The addition were performed successfully. Notify the user
     *  and update entry data.
     */
    {
      setStatusMessage(this_object_id, "Entry deleted successfully");

      prim_insts = find_prim_instances(this_object_id, MODIFY);
      name_edit = XtNameToWidget(prim_insts[0],
			 "modifyWindow.modifyViewForm.modifyEntryLabel");

      XtSetArg(args[0], XtNstring, "");
      XtSetValues(name_edit, args, 1);

      set_current_entry(this_object_id, NULLString);
    }
  else
    {
      (void) sprintf(err_msg,
		     "Delete operation failed because;\n%s",
		     get_message_of_code(result->errors->error_type));

      setStatusMessage(this_object_id, err_msg);
    }

  set_current_errors(this_object_id, result->errors);
  result->errors = NULLError;

  request_complete(request_id);
  
  free_delete_result(&result);
} /* gotDeleteEntryResult */


/*
 * - doAddEntryAction() -
 *
 *
 */
void doAddEntryAction(prim_widget, object_id, prim_id, action_id, trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  windowObject this_object = win_objects[object_id];
  QCardinal request_id;

  WidgetList prim_insts;
  Widget name_edit, top_edit, curr_edit, class_field;
  Arg args[MAXARGS];
  XtCallbackList callbacks;

  String strval, new_name, class_name, str;
  modifyField top_field, curr_field;
  modifyAttr attr_list;
  modifyValue curr_val;
  char old_name[LINESIZE];
  entryClass this_class;
  AttributeType rdn_type;

  errorList errors;


  /*
   *	Get the modify primitive
   */
  prim_insts = find_prim_instances(object_id, MODIFY);

  if (prim_insts == (Widget *) NULL)
    {
      setStatusMessage(object_id, "No add information to submit!");
      return;
    }


  /*
   *	Get the class name, then derive the attribute type of the RDN
   *	from it.
   *
   */

  class_field = XtNameToWidget(prim_insts[0], "modifyEditClass");

  XtSetArg(args[0], XtNstring, &class_name);
  XtGetValues(class_field, args, 1);

  
  if ((str = index(class_name, ',')) != NULLString)
    *str = '\0';

  this_class = get_class_of_name(class_name);
  
  rdn_type = this_class->rdn_type;

  XawAsciiSourceFreeString(class_field);


  /*
   *	Get the top field, which has a pointer to the head of the
   *	modifyAttr list buried in it.
   *
   */

  top_edit = XtNameToWidget(prim_insts[0],
			"modifyWindow.modifyViewForm.mustViewForm.modifyEdit");
  
  name_edit = XtNameToWidget(prim_insts[0],
			     "modifyWindow.modifyViewForm.modifyEntryLabel");

  XtFree((char *) prim_insts);

  XtSetArg(args[0], XtNfromVert, &top_edit);

  while (lexequ(XtName(top_edit), "FormLabel") != 0)
    {
      curr_edit = top_edit;
      XtGetValues(curr_edit, args, 1);
    }

  top_edit = curr_edit;

  XtSetArg(args[0], XtNcallback, &callbacks);
  XtGetValues(top_edit, args, 1);

  top_field = (modifyField) callbacks[0].closure;


  /*
   *	Get the the attribute list (does not correlate
   *	to attribute of first edit field).
   */
  
  XtGetValues(name_edit, args, 1);
  
  attr_list = (modifyAttr) callbacks[0].closure;
  

  /*
   *	Put the modified strings into the list of values
   */
  
  XtSetArg(args[0], XtNstring, &strval);

  for (curr_field = top_field;
       curr_field != NULLModifyField;
       curr_field = curr_field->next)
    if (curr_field->this_value->status != unchanged)
      {
	curr_val = curr_field->this_value;

	/*
	 *	Get the string value contained in the edit field,
	 *	if it's different put it in the list as a new value
	 *
	 */

	if (curr_val->status != deleted)
	  {
	    char *end;

	    XtGetValues(curr_field->edit, args, 1);

	    while (isspace(*strval))
	      strval++;

	    for (end = strval;
		 *end != '\0';
		 end++)
	      ;

	    while (isspace(*--end))
	      *end = '\0';
	  }
	else
	  strval = NULLString;

	switch (curr_val->status)
	  {
	  case updated:

	    if (strval == NULLString || *strval == '\0')
	      curr_val->status = deleted;
	    else
	      {
		if (strcmp(curr_val->value, strval) != 0)
		  curr_val->new_value = XtNewString(strval);
		else
		  curr_val->status = unchanged;
	      }
	    
	    break;


	  case new:

	    if (strval == NULLString || *strval != '\0')
	      curr_val->new_value = XtNewString(strval);
	    else
	      curr_field->this_value->status = unchanged;

	    break;


	  case deleted:

	    if (curr_val->value == NULLString || *curr_val->value == '\0')
	      {
		curr_val->status = unchanged;

		if (curr_val->new_value != NULLString)
		  {
		    XtFree(curr_val->new_value);
		    curr_val->new_value = NULLString;
		  }
	      }

	    break;
	  }

	if (curr_field->edit != NULLWidget)
	  XawAsciiSourceFreeString(curr_field->edit);
      }

  /*
   *	Get the new name
   */

  XtSetArg(args[0], XtNstring, &new_name);
  XtGetValues(name_edit, args, 1);

  friendlify(this_object->current_entry, old_name);

  if (lexequ(new_name, old_name) == 0)
    /*
     *	This is a bit too simple!
     */
    new_name = NULLString;

  XawAsciiSourceFreeString(name_edit);

  
  /*
   *	Do the addition
   */
  
  if (new_name != NULLString && *new_name != '\0')
    errors = do_add(&request_id, NULLString, new_name, rdn_type, attr_list);
  else
    {
      XBell(dpy, 40);

      setStatusMessage(object_id,
		       "Can't add an entry unless a name is supplied!");

      doActionAux(prim_widget,
		  object_id,
		  prim_id,
		  action_id,
		  trans_list? trans_list->next : NULLTransList);
      
      return;
    }


  if (errors != NULLError)
    {
      errorList curr_error = errors;

      XBell(dpy, 40);

      if (curr_error->ds_message != NULLString)
	setStatusMessage(object_id, curr_error->ds_message);
      else
	setStatusMessage(object_id,
			 get_message_of_code(curr_error->error_type));
      
      set_current_errors(object_id, errors);
      
      doActionAux(prim_widget,
		  object_id,
		  prim_id,
		  action_id,
		  trans_list? trans_list->next : NULLTransList);
      
      return;
    }


  /*
   *	Record request invocation
   */

  request_invoked(request_id,
		  ADD_ENTRY,
		  prim_widget,
		  object_id,
		  prim_id,
		  action_id,
		  trans_list);

  XBell(dpy, 40);
      
  setStatusMessage(object_id, "Submitting new entry. Please wait.");
} /* doAddEntryAction */


/*
 * - gotAddEntryResult() -
 *
 *
 */
/* ARGSUSED */
void gotAddEntryResult(request_id, this_object_id, action_id, trans_list)
     Cardinal request_id;
     Cardinal this_object_id;
     actionID action_id;
     translationList trans_list;
{
  addResult result;
  WidgetList prim_insts;
  Widget top_edit, curr_edit, name_edit;
  Arg args[MAXARGS];
  XtCallbackList callbacks;
  char err_msg[LINESIZE], entry_name[LINESIZE];

  XBell(dpy, 40);

  setStatusMessage(this_object_id, "Add entry result received");

  result = get_add_result(request_id);

  if (result->was_successful == TRUE)
    /*
     *	The addition were performed successfully. Notify the user
     *  and update entry data.
     */
    {
      setStatusMessage(this_object_id, "Entry added successfully");

      prim_insts = find_prim_instances(this_object_id, MODIFY);
      curr_edit = XtNameToWidget(prim_insts[0],
			"modifyWindow.modifyViewForm.mustViewForm.modifyEdit");

      top_edit = NULLWidget;

      XtSetArg(args[0], XtNfromVert, &curr_edit);
      
      while (lexequ(XtName(curr_edit), "FormLabel") != 0)
	{
	  top_edit = curr_edit;
	  XtGetValues(top_edit, args, 1);
	}

      XtSetArg(args[0], XtNcallback, &callbacks);
      XtGetValues(top_edit, args, 1);

      updateModifyData((modifyField) callbacks[0].closure);

      if (result->baseobject != NULLString)
	{
	  set_current_entry(this_object_id, result->baseobject);

	  friendlify(result->baseobject, entry_name);
	  
	  name_edit = XtNameToWidget(prim_insts[0],
			     "modifyWindow.modifyViewForm.modifyEntryLabel");

	  XtSetArg(args[0], XtNstring, entry_name);
	  XtSetValues(name_edit, args, 1);
	}

      XtFree((char *) prim_insts);
    }
  else
    {
      (void) sprintf(err_msg,
		     "Add operation failed because;\n%s",
		     get_message_of_code(result->errors->error_type));

      setStatusMessage(this_object_id, err_msg);
    }

  XtFree((char *) prim_insts);

  set_current_errors(this_object_id, result->errors);
  result->errors = NULLError;

  request_complete(request_id);
  
  free_add_result(&result);
} /* gotAddEntryResult */


/*
 * - makeClassTemplate() -
 * Make a template from the object classes specified by defined entry class
 *
 */
void makeClassTemplate(class, must_in_ptr, must_out_ptr,may_in_ptr,may_out_ptr)
     entryClass class;
     modifyAttr *must_in_ptr, *must_out_ptr, *may_in_ptr, *may_out_ptr;
{
  modifyAttr new_attr;
  modifyValue value;
  attrTypeList curr_oc = class->oc_list, curr_attr_type, add_oc;
  AttributeType oclass_type;
  objectclass *ocp;
  register table_seq optr;
  
  char *oc2name();
  objectclass *str2oc();

  *must_out_ptr = *must_in_ptr = *may_out_ptr = *may_in_ptr = NULLModifyAttr;
  
  oclass_type = AttrT_new("2.5.4.0");
  
  while (curr_oc != NULLAttrTypeList)
    {
      ocp = name2oc(curr_oc->type->oa_ot.ot_stroid);

      for (optr = ocp->oc_must; optr != NULLTABLE_SEQ; optr = optr->ts_next)
	{
	  for (curr_attr_type = class->default_attrs;
	       curr_attr_type != NULLAttrTypeList;
	       curr_attr_type = curr_attr_type->next)
	    if (curr_attr_type->type == optr->ts_oa)
	      break;


	  if (curr_attr_type == NULLAttrTypeList)
	    {
	      addAttrToList(must_out_ptr, optr->ts_oa);
	      new_attr = *must_out_ptr;
	    }
	  else
	    {
	      addAttrToList(must_in_ptr, optr->ts_oa);
	      new_attr = *must_in_ptr;
	    }
	      

	  if (optr->ts_oa == oclass_type)
	    {
	      for (add_oc = class->oc_list, value = NULLModifyValue;
		   add_oc != NULLAttrTypeList;
		   add_oc = add_oc->next)
		{
		  if (value == NULLModifyValue)
		    value = new_attr->values;
		  else
		    value = value->next = modify_value_alloc();
		  
		  value->new_value = NULLString;
		  value->status = unchanged;
		  
		  value->value = 
		    copy_string
		      (oc2name(str2oc(add_oc->type->oa_ot.ot_name), OIDPART));
		  
		  value->next = NULLModifyValue;
		}
	    }
	  else
	    putDefaultValues(class->name, optr->ts_oa, &new_attr->values);
	}
    
      for (optr = ocp->oc_may; optr != NULLTABLE_SEQ; optr = optr->ts_next)
	{
	  for (curr_attr_type = class->default_attrs;
	       curr_attr_type != NULLAttrTypeList;
	       curr_attr_type = curr_attr_type->next)
	    if (curr_attr_type->type == optr->ts_oa)
	      break;

	  if (curr_attr_type == NULLAttrTypeList)
	    {
	      addAttrToList(may_out_ptr, optr->ts_oa);
	      new_attr = *may_out_ptr;
	    }
	  else
	    {
	      addAttrToList(may_in_ptr, optr->ts_oa);
	      new_attr = *may_in_ptr;
	    }

	  putDefaultValues(class->name, optr->ts_oa, &new_attr->values);
	}

      curr_oc = curr_oc->next;
    }
} /* makeClassTemplate */

/*
 * - addAttrToList() -
 *
 *
 */
static void addAttrToList(list_ptr, type)
     modifyAttr *list_ptr;
     AttributeType type;
{
  modifyAttr new_attr;
  modifyValue value;

  new_attr = modify_attr_alloc();
  new_attr->next = *list_ptr;
  
  *list_ptr = new_attr;
  
  new_attr->attr_name = copy_string(attr2name(type, OIDPART));
  new_attr->attr_type = type;

  new_attr->to_modify = FALSE;
  
  value = new_attr->values = modify_value_alloc();
  
  value->status = unchanged;
  value->value = value->new_value = NULLString;
  
  value->next = NULLModifyValue;
} /* addAttrToList */


/*
 * - putDefaultValues() -
 *
 *
 */
static void putDefaultValues(class_name, type, values_ptr)
     String class_name;
     AttributeType type;
     modifyValue *values_ptr;
{
  attrTemplate curr_template;
  modifyValue new_value;
  stringCell curr_str_val;
  
  for (curr_template = attr_template_list;
       curr_template != NULLAttrTemplate;
       curr_template = curr_template->next)
    if (is_string_in_seq(class_name, curr_template->class_names) == TRUE &&
	type == curr_template->type)
      {
	new_value = NULLModifyValue;

	for (curr_str_val = curr_template->defaults;
	     curr_str_val != NULLStrCell;
	     curr_str_val = curr_str_val->next)
	  {
	    if (new_value == NULLModifyValue)
	      new_value = *values_ptr;
	    else
	      new_value = new_value->next = modify_value_alloc();

	    new_value->status = unchanged;
	    new_value->new_value = NULLString;
	    
	    new_value->value = XtNewString(curr_str_val->string);
	    new_value->next = NULLModifyValue;
	  }

	return;
      }
} /* putDefaultValues */


/*
 * 	Interface to modification operations in XtCallback form
 *
 *
 */
/* ARGSUSED */
void submitModificationsCallback(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  QCardinal object_id = get_object_id(w);

  doSubmitModifyAction((Widget) closure,
		       object_id,
		       MODIFY,
		       ActionUndefined,
		       NULLTransList);

  doPrimitiveSensitivity(object_id);
}

/* ARGSUSED */
void addEntryCallback(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  QCardinal object_id = get_object_id(w);

  doAddEntryAction((Widget) closure,
		   object_id,
		   MODIFY,
		   ActionUndefined,
		   NULLTransList);

  doPrimitiveSensitivity(object_id);
}

/* ARGSUSED */
void deleteEntryCallback(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  QCardinal object_id = get_object_id(w);

  doDeleteEntryAction((Widget) closure,
		      object_id,
		      MODIFY,
		      ActionUndefined,
		      NULLTransList);

  doPrimitiveSensitivity(object_id);
}
