#ifndef _Xdir_objects_h_
#define _Xdir_objects_h_

#include <stdio.h>

#include "defs.h"
#include "windows.h"
#include "layout.h"
#include "actions.h"

#include "query.h"

#define MAXWINDOWS 64
#define MAXSTARTS 64

typedef struct widget_tree
{
  Widget this_widget;

  reference_type type;

  struct widget_tree *descendants;
  struct widget_tree *left_siblings;
} *WidgetTree;

#define NULLWidgetTree (WidgetTree) NULL
#define WidgetTree_alloc() (WidgetTree) XtMalloc(sizeof(struct widget_tree))

typedef struct child_object
{
  Cardinal child_object_id;

  struct child_object *left_siblings;
} child_list, *childList;
  
#define NULLChildList (childList) NULL
#define child_list_alloc() (childList) XtMalloc(sizeof(child_list))

typedef struct
{
  Cardinal template_id;

  Boolean is_child;
  Cardinal parent_object_id;

  Boolean is_kept;

  Widget parent_shell;
  WidgetTree widget_layout;

  childList children;
  Cardinal num_children;

  String current_entry;
  entryList current_list;
  entryList current_save_list;
  errorList current_errors;
} window_object, *windowObject;

#define NULLWinObject (windowObject) NULL
#define object_alloc() (windowObject) XtMalloc(sizeof(window_object))


Widget make_object();
void create_startup_windows();

void free_child_list(), free_widget_tree(), delete_win_object();

Cardinal find_unkept_child(), find_unkept_object();

Cardinal get_object_id();

void set_current_entry(),
     set_current_list(),
     set_current_save_list(),
     set_current_errors();

Boolean isWaiting();

#endif _Xdir_objects_h_



