#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/search_form.c,v 0.95 91/09/02 11:37:31 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/search_form.c,v 0.95 91/09/02 11:37:31 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  search_form.c

*****************************************************************************/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Form.h>
#include <X11/Command.h>
#include <X11/Viewport.h>
#include <X11/AsciiText.h>

#include "query.h"
#include "quipu/common.h"

#include "defs.h"
#include "windows.h"
#include "widgets.h"
#include "objects.h"
#include "layout.h"
#include "actions.h"
#include "callbacks.h"

#include "requests.h"
#include "configure.h"
#include "y.tab.h"

#include "xdutil.h"
#include "search_form.h"

#include "error_view.h"
#include "status_bar.h"
#include "read_display.h"
#include "list_display.h"

#include "tick"


/*
 *     Externs...
 */

extern Display *dpy;
extern windowObject win_objects[];

extern objectAction actions[];
extern Cardinal action_number;

extern targetClass target_classes[];
extern QCardinal target_class_num;


/*
 *	Global data
 */

String default_target = NULLString;


/*
 *	Local procs..
 */

static void clearTicks();


/*
 * - doChangeFocus() -
 *
 *
 */
/* ARGSUSED */
void doChangeFocus(focused, event, params, num_params)
     Widget focused;
     XEvent *event;
     String *params;
     Cardinal num_params;
{
  Widget search_form, focus_on, top, bottom, previous = NULLWidget;
  Cardinal count;
  Arg args[MAXARGS];

  search_form = XtParent(focused);

  bottom = XtNameToWidget(search_form, "lastTypeDialog");
  top = XtNameToWidget(search_form, "firstTypeDialog");

  count = 0;
  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;
  XtSetValues(focused, args, count);

  if (bottom == focused)
    {
      focus_on = XtNameToWidget(search_form, "firstTypeDialog");
    }
  else
    {
      previous = bottom;

      while (previous != focused && previous != top)
	{
	  focus_on = previous;

	  count = 0;
	  XtSetArg(args[count], XtNfromVert, &previous); count++;
	  XtGetValues(previous, args, count);
	}
    }

  XtSetKeyboardFocus(search_form, focus_on);

  count = 0;
  XtSetArg(args[count], XtNdisplayCaret, TRUE); count++;
  XtSetValues(focus_on, args, count);
} /* doChangeFocus */


/*
 * - doSetFocus() -
 *
 *
 */
/* ARGSUSED */
void doSetFocus(focus_on, event, params, num_params)
     Widget focus_on;
     XEvent *event;
     String *params;
     Cardinal num_params;
{
  Widget search_form, top, bottom, previous = NULLWidget;
  Cardinal count;
  Arg args[MAXARGS];

  search_form = XtParent(focus_on);

  bottom = XtNameToWidget(search_form, "lastTypeDialog");
  top = XtNameToWidget(search_form, "firstTypeDialog");

  previous = bottom;

  count = 0;
  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;
  XtSetValues(previous, args, count);

  while (previous != top)
    {
      count = 0;
      XtSetArg(args[count], XtNfromVert, &previous); count++;
      XtGetValues(previous, args, count);

      count = 0;
      XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;
      XtSetValues(previous, args, count);
    }

  count = 0;
  XtSetArg(args[count], XtNdisplayCaret, TRUE); count++;
  XtSetValues(focus_on, args, count);
  
  XtSetKeyboardFocus(search_form, focus_on);
} /* doSetFocus */


/*
 * - searchForType() -
 * Set dialogs appropriate to given search type.
 *
 */
void searchForType(menu_entry, prim_data)
     Widget menu_entry;
     primInfo prim_data;
{
  targetClass this_class;
  stringCell context_class;
  Widget type_menu,
         last_label,
         last_dialog,
         first_dialog,
         search_label,
         search_form,
         tick_box;
  Widget destroylist[64];
  Dimension form_width,
            label_width,
            label_border_width,
            dialog_border_width,
            tick_border_width;
  int default_distance, dialog_width;
  Arg args[MAXARGS];
  Cardinal count, destroycount, dialognum;
  Cardinal type_index;
  String type_label;
  char translations[STRINGLEN], trans_params[STRINGLEN];
  char *trans_tab = "<Key>Tab: doChangeFocus()",
       *trans_ret = "<Key>Return: doAction(",
       *trans_btn1 = "<Btn1Down>: select-start() doSetFocus()";
  XtTranslations trans_table;
  

  search_form = XtParent(XtParent(XtParent(menu_entry)));
  
  count = 0;
  XtSetArg(args[count], XtNlabel, &type_label); count++;
  XtGetValues(menu_entry, args, count);


  for (type_index = 0, this_class = target_classes[type_index];
       type_index < target_class_num &&
       lexequ(this_class->target_label, type_label) != 0;
       type_index++, this_class = target_classes[type_index])
    ;

  if (type_index == target_class_num)
    return;

  search_label = XtNameToWidget(search_form, "searchTypeLabel");
  type_menu = XtNameToWidget(search_form, "typeButton");

  if (type_menu == NULLWidget)
    return;


  (void) strcpy(translations, trans_tab);
  (void) strcat(translations, "\n");
  (void) strcat(translations, trans_ret);
  
  (void) sprintf(trans_params,
		 "%d,%d,%d)\n",
		 prim_data->object_id,
		 LOOKUP,
		 prim_data->action_id);

  (void) strcat(translations, trans_params);
  (void) strcat(translations, trans_btn1);

  trans_table = XtParseTranslationTable(translations);


  /*
   * Get parent form data
   */

  count = 0;

  XtSetArg(args[count], XtNwidth, &form_width); count++;
  XtSetArg(args[count], XtNdefaultDistance, &default_distance); count++;

  XtGetValues(search_form, args, count);
  
  XtSetArg(args[0], XtNresizable, FALSE);
  XtSetValues(search_form, args, 1);


  /*
   * Freeze updates to form
   */

  XawFormDoLayout(search_form, FALSE);

  count = 0;
  XtSetArg(args[count], XtNlabel, this_class->target_label); count++;
  XtSetValues(search_label, args, count);

  first_dialog = XtNameToWidget(search_form, "firstTypeDialog");
  last_dialog = XtNameToWidget(search_form, "lastTypeDialog");

  /*
   * Get all dialogs
   */

  XtSetArg(args[0], XtNfromVert, &last_dialog);

  destroycount = 0;
  
  if (first_dialog != NULLWidget)
    destroylist[destroycount++] = first_dialog;

  if (last_dialog != NULLWidget)
    {
      do
	{
	  destroylist[destroycount++] = last_dialog;
	  XtGetValues(last_dialog, args, 1);
	}
      while (last_dialog != first_dialog && first_dialog != NULLWidget);

      /*
       * Get all labels and tick boxes
       */

      for (count = 1, dialognum = destroycount; count < dialognum; count++)
	{
	  XtSetArg(args[0], XtNfromHoriz, &tick_box);
      
	  XtGetValues(destroylist[count], args, 1);
	  destroylist[destroycount++] = tick_box;

	  XtSetArg(args[0], XtNfromHoriz, &last_label);

	  XtGetValues(tick_box, args, 1);
	  destroylist[destroycount++] = last_label;
	}
    }

  if (first_dialog != NULLWidget)
    {
      XtSetArg(args[0], XtNfromHoriz, &last_label);
      XtGetValues(destroylist[0], args, 1);
      
      destroylist[destroycount++] = last_label;
    }
      
  XtUnmanageChildren(destroylist, destroycount);
  
  for (count = 0; count < destroycount; count++)
    XtDestroyWidget(destroylist[count]);


  XFlush (dpy);
  
  /* Create label for target type */
  count = 0;

  XtSetArg(args[count], XtNlabel, this_class->target_label); count++;
  XtSetArg(args[count], XtNfromVert, type_menu); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNvertDistance, 20); count++;

  last_label = XtCreateManagedWidget("firstTypeLabel",
				     labelWidgetClass,
				     search_form,
				     args,
				     count);

  count = 0;

  XtSetArg(args[count], XtNfromVert, type_menu); count++;
  XtSetArg(args[count], XtNfromHoriz, last_label); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainRight); count++;

  XtSetArg(args[count], XtNeditType, XawtextEdit); count++;
  XtSetArg(args[count], XtNvertDistance, 20); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNborderWidth, 3); count++;

  first_dialog = last_dialog = XtCreateManagedWidget("firstTypeDialog",
						     asciiTextWidgetClass,
						     search_form,
						     args,
						     count);

  XtOverrideTranslations(first_dialog, trans_table);


  /* Expand dialog to take up available space */

  XtSetArg(args[0], XtNwidth, &label_width);
  XtSetArg(args[1], XtNborderWidth, &label_border_width);
  XtGetValues(last_label, args, 2);
  
  label_border_width *= 2;
      
  XtSetArg(args[0], XtNborderWidth, &dialog_border_width);
  XtGetValues(last_dialog, args, 1);
  
  dialog_border_width *= 2;
  
  if ((dialog_width = form_width -
       (default_distance * 3) -
       label_width -
       label_border_width -
       dialog_border_width) < 12)
    dialog_width = 12;
  

  XtSetArg(args[0], XtNwidth, (Dimension) dialog_width);
  XtSetValues(last_dialog, args, 1);
  
  
  for (context_class = this_class->context_classes;
       context_class != NULLStrCell && context_class->next != NULLStrCell;
       context_class = context_class->next)
    {
      type_label = context_class->string;

      count = 0;
      XtSetArg(args[count], XtNlabel, type_label); count++;
      XtSetArg(args[count], XtNfromVert, last_dialog); count++;
      
      XtSetArg(args[count], XtNtop, XtChainTop); count++;
      XtSetArg(args[count], XtNbottom, XtChainTop); count++;
      
      XtSetArg(args[count], XtNleft, XtChainLeft); count++;
      XtSetArg(args[count], XtNright, XtChainLeft); count++;
      
      last_label = XtCreateManagedWidget("typeLabel",
					 labelWidgetClass,
					 search_form,
					 args,
					 count);
      
      count = 0;

      XtSetArg(args[count], XtNfromVert, last_dialog); count++;
      XtSetArg(args[count], XtNfromHoriz, last_label); count++;
      
      XtSetArg(args[count], XtNtop, XtChainTop); count++;
      XtSetArg(args[count], XtNbottom, XtChainTop); count++;
      
      XtSetArg(args[count], XtNleft, XtChainLeft); count++;
      XtSetArg(args[count], XtNright, XtChainLeft); count++;

      XtSetArg(args[count], XtNresizable, FALSE); count++;
      XtSetArg(args[count], XtNlabel, ""); count++;

      XtSetArg(args[count], XtNheight, tick_height); count++;
      XtSetArg(args[count], XtNwidth, tick_width); count++;

      tick_box = XtCreateManagedWidget("tick",
				       labelWidgetClass,
				       search_form,
				       args,
				       count);

      count = 0;

      XtSetArg(args[count], XtNfromVert, last_dialog); count++;
      XtSetArg(args[count], XtNfromHoriz, tick_box); count++;
      
      XtSetArg(args[count], XtNtop, XtChainTop); count++;
      XtSetArg(args[count], XtNbottom, XtChainTop); count++;
      
      XtSetArg(args[count], XtNleft, XtChainLeft); count++;
      XtSetArg(args[count], XtNright, XtChainRight); count++;
      
      XtSetArg(args[count], XtNeditType, XawtextEdit); count++;
      XtSetArg(args[count], XtNresizable, TRUE); count++;

      XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;

      last_dialog = XtCreateManagedWidget("typeDialog",
					  asciiTextWidgetClass,
					  search_form,
					  args,
					  count);
      
      XtOverrideTranslations(last_dialog, trans_table);

      
      /* Expand dialog to take up available space */


      XtSetArg(args[0], XtNwidth, &label_width);
      XtSetArg(args[1], XtNborderWidth, &label_border_width);

      XtGetValues(last_label, args, 2);
      
      label_border_width *= 2;

      
      tick_border_width = 1;
      XtSetArg(args[0], XtNborderWidth, tick_border_width);
      XtSetValues(tick_box, args, 1);

      tick_border_width *= 2;

      
      XtSetArg(args[0], XtNborderWidth, &dialog_border_width);
      XtGetValues(last_dialog, args, 1);

      dialog_border_width *= 2;

      if ((dialog_width = form_width -
	                  (default_distance * 4) -
	                  label_width -
	                  label_border_width -
	   		  tick_width -
	                  tick_border_width -
	                  dialog_border_width) < 12)
	dialog_width = 12;
      

      XtSetArg(args[0], XtNwidth, (Dimension) dialog_width);
      XtSetValues(last_dialog, args, 1);
    }


  if (context_class != NULLStrCell)
    {
      type_label = context_class->string;
      
      count = 0;
      XtSetArg(args[count], XtNlabel, type_label); count++;
      XtSetArg(args[count], XtNfromVert, last_dialog); count++;
      
      XtSetArg(args[count], XtNtop, XtChainTop); count++;
      XtSetArg(args[count], XtNbottom, XtChainTop); count++;
      
      XtSetArg(args[count], XtNleft, XtChainLeft); count++;
      XtSetArg(args[count], XtNright, XtChainLeft); count++;
      
      last_label = XtCreateManagedWidget("lastTypeLabel",
					 labelWidgetClass,
					 search_form,
					 args,
					 count);
      
      count = 0;

      XtSetArg(args[count], XtNfromVert, last_dialog); count++;
      XtSetArg(args[count], XtNfromHoriz, last_label); count++;
      
      XtSetArg(args[count], XtNtop, XtChainTop); count++;
      XtSetArg(args[count], XtNbottom, XtChainTop); count++;
      
      XtSetArg(args[count], XtNleft, XtChainLeft); count++;
      XtSetArg(args[count], XtNright, XtChainLeft); count++;

      XtSetArg(args[count], XtNresizable, FALSE); count++;
      XtSetArg(args[count], XtNlabel, ""); count++;

      XtSetArg(args[count], XtNheight, tick_height); count++;
      XtSetArg(args[count], XtNwidth, tick_width); count++;

      tick_box = XtCreateManagedWidget("tick",
				       labelWidgetClass,
				       search_form,
				       args,
				       count);

      count = 0;

      XtSetArg(args[count], XtNfromVert, last_dialog); count++;
      XtSetArg(args[count], XtNfromHoriz, tick_box); count++;
      
      XtSetArg(args[count], XtNtop, XtChainTop); count++;
      XtSetArg(args[count], XtNbottom, XtChainTop); count++;
      
      XtSetArg(args[count], XtNleft, XtChainLeft); count++;
      XtSetArg(args[count], XtNright, XtChainRight); count++;
      
      XtSetArg(args[count], XtNeditType, XawtextEdit); count++;
      XtSetArg(args[count], XtNresizable, TRUE); count++;

      XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;

      last_dialog = XtCreateManagedWidget("lastTypeDialog",
					  asciiTextWidgetClass,
					  search_form,
					  args,
					  count);

      XtOverrideTranslations(last_dialog, trans_table);


      /* Expand dialog to take up available space */

      XtSetArg(args[0], XtNwidth, &label_width);
      XtSetArg(args[1], XtNborderWidth, &label_border_width);
      XtGetValues(last_label, args, 2);

      label_border_width *= 2;
      
      tick_border_width = 1;
      XtSetArg(args[0], XtNborderWidth, tick_border_width);
      XtSetValues(tick_box, args, 1);

      tick_border_width *= 2;


      XtSetArg(args[0], XtNborderWidth, &dialog_border_width);
      XtGetValues(last_dialog, args, 1);

      dialog_border_width *= 2;

      if ((dialog_width = form_width -
	                  (default_distance * 4) -
	                  label_width -
	                  label_border_width -
	   		  tick_border_width -
	                  tick_width -
	                  dialog_border_width) < 12)
	dialog_width = 12;
      
      XtSetArg(args[0], XtNwidth, (Dimension) dialog_width);
      XtSetValues(last_dialog, args, 1);
    }

  XawFormDoLayout(search_form, TRUE);

  XtSetArg(args[0], XtNresizable, TRUE);
  XtSetValues(search_form, args, 1);

  XtSetKeyboardFocus(search_form, first_dialog);
} /* searchForType */


/*
 * - changeUfsType() -
 *
 *
 */
/* ARGSUSED */
void changeUfsType(this_widget, closure, calldata)
     Widget this_widget;
     XtPointer closure, calldata;
{
  primInfo prim_data = (primInfo) closure;

  searchForType(this_widget, prim_data);
} /* changeUfsType */


/*
 * - doLookupAction() -
 *
 *
 */
/* ARGSUSED */
void doLookupAction(prim_widget, object_id, prim_id, action_id, trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  Widget target_label,
         target_dialog,
	 search_label,
	 search_dialog,
	 search_form,
         tick_box;
  Widget *instances;
  Arg args[MAXARGS];
  Cardinal count;
  searchData target_data = NULLSearchData,
             context_data = NULLSearchData,
             new_data;
  QCardinal request_id;
  String label, value;
  errorList errors;

  extern char *TidyString();


  instances = find_prim_instances(object_id, LOOKUP);
  
  if (instances == (Widget *) NULL)
    {
      doActionAux(prim_widget,
		  object_id,
		  prim_id,
		  action_id,
		  trans_list->next);
      return;
    }

  clearTicks(object_id);

  search_form = instances[0];

  target_label = XtNameToWidget(search_form, "firstTypeLabel");
  target_dialog = XtNameToWidget(search_form, "firstTypeDialog");

  if (target_label == NULLWidget)
    {
      /* Error Message */
      return;
    }

  count = 0;
  XtSetArg(args[count], XtNlabel, &label); count++;
  XtGetValues(target_label, args, count);

  count = 0;
  XtSetArg(args[count], XtNstring, &value); count++;
  XtGetValues(target_dialog, args, count);

  value = TidyString(value);

  if (value == NULLString || *value == '\0')
    {
      setStatusMessage(object_id,
		       " You must enter a value for the target type!");

      XBell(dpy, 40);

      doActionAux(prim_widget,object_id, prim_id, action_id, trans_list->next);

      return;
    }
  
  for (count = 0; count < target_class_num; count++)
    if (lexequ(target_classes[count]->target_label, label) == 0)
      break;


  target_data = search_data_alloc();

  target_data->type_label = target_classes[count]->target_label;
  target_data->values = NULLStrCell;

  add_string_to_seq(value, &target_data->values);

  
  XawAsciiSourceFreeString(target_dialog);
  XawAsciiSourceFreeString(target_label);


  target_data->next = NULLSearchData;

  /* Now do context types */
  search_label = XtNameToWidget(search_form, "lastTypeLabel");
  search_dialog = XtNameToWidget(search_form, "lastTypeDialog");

  while (search_label != target_label &&
	 search_dialog != target_dialog &&
	 search_dialog != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNlabel, &label); count++;
      XtGetValues(search_label, args, count);

      count = 0;
      XtSetArg(args[count], XtNstring, &value); count++;
      XtGetValues(search_dialog, args, count);
      
      value = TidyString(value);


      if (value != NULLString && *value != '\0')
	{
	  new_data = search_data_alloc();
	  new_data->next = context_data;
	  
	  context_data = new_data;
	  context_data->type_label = get_srch_class_of_name(label)->label;
	  
	  context_data->values = NULLStrCell;
	  add_string_to_seq(value, &context_data->values);

	  XawAsciiSourceFreeString(search_dialog);
	  XawAsciiSourceFreeString(search_label);
	}
	  

      XtSetArg(args[0], XtNfromVert, &search_dialog);
      XtGetValues(search_label, args, 1);
      
      XtSetArg(args[0], XtNfromHoriz, &tick_box);
      XtGetValues(search_dialog, args, 1);

      XtSetArg(args[0], XtNfromHoriz, &search_label);
      XtGetValues(tick_box, args, 1);
    }


  errors = do_ufsearch(target_data, context_data, &request_id);

  if (errors != NULLError)
    switch (errors->error_type)
      {
      case QERR_bad_value_syntax:
	XBell(dpy, 40);
	setStatusMessage(object_id, "The search data entered is invalid!");
	
	doActionAux(prim_widget,
		    object_id,
		    prim_id,
		    action_id,
		    trans_list->next);

	return;
	
      case QERR_internal_limit_reached:
	XBell(dpy, 40);
	setStatusMessage(object_id, "Internal limit reached, cannot search!");
	
	doActionAux(prim_widget,
		    object_id,
		    prim_id,
		    action_id,
		    trans_list->next);
	
	return;
	
      case QERR_invalid_search_class:
	XBell(dpy, 40);
	setStatusMessage(object_id,"Not enough search informations supplied!");
	
	doActionAux(prim_widget,
		    object_id,
		    prim_id,
		    action_id,
		    trans_list->next);
	
	return;
      }


  setStatusMessage(object_id, "Searching. Please Wait.");

  request_invoked(request_id,
		  UFSEARCH,
		  prim_widget,
                  object_id,
                  prim_id,
                  action_id,
                  trans_list);
} /* doLookupAction */


/*
 * - gotLookupReport() -
 *
 *
 */
void gotLookupReport(request_id, object_id)
     QCardinal request_id;
     Cardinal object_id;
{
  ufsearchReport report;

  Arg args[MAXARGS];

  Widget tick_box, label, dialog;
  WidgetList instances;
  
  String label_str;

  Pixmap tick_pixmap, old_pixmap;
  Screen *screen;


  report = get_ufsearch_report(request_id);

  if (report->type == UFS_NewAttempt)
    return;


  if ((instances = find_prim_instances(object_id, LOOKUP)) == (Widget *) NULL)
    return;

  if ((dialog = XtNameToWidget(instances[0], "lastTypeDialog")) == NULLWidget)
    return;

  label = XtNameToWidget(instances[0], "lastTypeLabel");

  screen = XtScreen(label);

  XtFree((char *) instances);

  
  XtSetArg(args[0], XtNfromHoriz, &tick_box);
  XtGetValues(dialog, args, 1);


  while (lexequ(XtName(dialog), "firstTypeDialog") != 0)
    {
      XtSetArg(args[0], XtNlabel, &label_str);
      XtGetValues(label, args, 1);

      if (is_string_in_seq(label_str, report->matched_list) == TRUE)
	{
	  XtSetArg(args[0], XtNbackgroundPixmap, &old_pixmap);
	  XtGetValues(tick_box, args, 1);

	  if (old_pixmap == XtUnspecifiedPixmap)
	    {
	      tick_pixmap = XCreatePixmapFromBitmapData
		(dpy,
		 XtWindow(tick_box),
		 tick_bits,
		 tick_width,
		 tick_height,
		 BlackPixelOfScreen(screen),
		 WhitePixelOfScreen(screen),
		 DefaultDepthOfScreen(screen));

	      XtSetArg(args[0], XtNbackgroundPixmap, tick_pixmap);
	      XtSetValues(tick_box, args, 1);

	      XtAddCallback(tick_box,
			    XtNdestroyCallback,
			    FreeBackgroundPixmap,
			    (XtPointer) tick_pixmap);
	    }
	}

      XtSetArg(args[0], XtNfromVert, &dialog);
      XtGetValues(dialog, args, 1);

      XtSetArg(args[0], XtNfromHoriz, &tick_box);
      XtGetValues(dialog, args, 1);

      XtSetArg(args[0], XtNfromHoriz, &label);
      XtGetValues(tick_box, args, 1);
    }

  ufsearch_report_free(&report);
} /* gotLookupReport */


/*
 * - gotLookupResults() -
 *
 *
 */
/* ARGSUSED */
void gotLookupResults(request_id, object_id, action_id, trans_list)
     QCardinal request_id;
     Cardinal object_id;
     actionID action_id;
     translationList trans_list;
{
  ufsearchResult result;
  Cardinal match_num;
  errorList curr_error;
  entryList matches;
  Cardinal child_id, child_template_id, err_num;
  outputMode output_mode;
  char status_message[LINESIZE], status_buf[LINESIZE];


  setStatusMessage(object_id, "Results received");

  result = get_ufsearch_result(request_id);

  for (match_num = 0, matches = result->hits; 
       matches != NULLEntryList;
       match_num++, matches = matches->next)
    ;

  for (curr_error = result->errors, err_num = 0;
       curr_error != NULLError;
       curr_error = curr_error->next, err_num++)
    ;

  XBell(dpy, 40);

  if (match_num == 0)
    {
      if (err_num <= 1)
	(void) sprintf(status_message,
		       "Nothing found using given search values");
      else
	(void) strcpy(status_message,
		      "Search failed!");
    }
  else
    {
      clearTicks(object_id);

      if (match_num == 1)
	{
	  child_template_id = trans_list->template1_id;
	  output_mode = trans_list->mode;
	  
	  (void) findOutputObject(object_id,
				  child_template_id,
				  output_mode,
				  &child_id);
	  
	  (void) strcpy(status_message, "Made 1 good match");
	  
	  set_current_entry(child_id, result->hits->string_dn);
	  displayCurrentEntry(NULLWidget, child_id, 0, 0, NULLTransList);
	  
	  doPrimitiveSensitivity(child_id);
	}
      else if (match_num > 1)
	{
	  child_template_id = trans_list->template2_id;
	  output_mode = trans_list->mode;
	  
	  (void) findOutputObject(object_id,
				  child_template_id,
				  output_mode,
				  &child_id);
	  
	  (void) sprintf(status_message,
			 "Made %d good matches",
			 match_num);
	  
	  set_current_list(child_id, result->hits);

	  displayCurrentList(child_id);
	  
	  doPrimitiveSensitivity(child_id);
	}
    }
      
  set_current_errors(object_id, result->errors);

  switch (err_num)
    {
    case 0:
    case 1:

      break;

    default:

      (void) sprintf(status_buf,
		     "\n%d Errors Occurred During Search",
		     err_num);
      (void) strcat(status_message, status_buf);
    }

  updateErrorViewer(object_id);

  setStatusMessage(object_id, status_message);
	    
  request_complete(request_id);

  ufsearch_result_free(&result);
} /* gotLookupResults */



/*
 * - clearTicks() -
 * Clear the ticks indicating matches made
 *
 */
static void clearTicks(object_id)
     Cardinal object_id;
{
  Arg args[MAXARGS];

  Widget tick_box, dialog;
  WidgetList instances;

  Pixmap old_pixmap;


  if ((instances = find_prim_instances(object_id, LOOKUP)) == (Widget *) NULL)
    return;

  dialog = XtNameToWidget(instances[0], "lastTypeDialog");

  XtFree((char *) instances);

  
  if (dialog == NULLWidget)
    return;
  
  while (lexequ(XtName(dialog), "firstTypeDialog") != 0)
    {
      XtSetArg(args[0], XtNfromHoriz, &tick_box);
      XtGetValues(dialog, args, 1);

      XtSetArg(args[0], XtNbackgroundPixmap, &old_pixmap);
      XtGetValues(tick_box, args, 1);

      XtSetArg(args[0], XtNbackgroundPixmap, XtUnspecifiedPixmap);
      XtSetValues(tick_box, args, 1);

      if (old_pixmap != XtUnspecifiedPixmap)
	{
	  XFreePixmap(dpy, old_pixmap);
	  XtRemoveAllCallbacks(tick_box, XtNdestroyCallback);
	}

      XtSetArg(args[0], XtNfromVert, &dialog);
      XtGetValues(dialog, args, 1);
    }
} /* clearTicks */

