#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/widgets.c,v 0.95 91/09/02 11:37:40 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/widgets.c,v 0.95 91/09/02 11:37:40 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  widgets.c - Widget creation functions.

*****************************************************************************/

#include "defs.h"
#include "windows.h"
#include "widgets.h"
#include "callbacks.h"
#include "configure.h"
#include "layout.h"
#include "actions.h"
#include "xutil.h"
#include "dn_list.h"
#include "sequence.h"
#include "y.tab.h"

#include "search_form.h"
#include "modify_form.h"

#include "modify_ops.h"

#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Xutil.h>
#include <X11/Shell.h>
 
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>


/*
 *	Externs...
 */

extern Display *dpy;

extern objectAction actions[];

extern targetClass target_classes[];
extern QCardinal target_class_num;


/*
 *	Static data and procs..
 */

static void doNothing();

static Screen *screen;

static XtActionsRec action_table[] =
{
  {"doAction", (XtActionProc) doAction},
  {"doNothing", (XtActionProc) doNothing},
  {"doChangeFocus", (XtActionProc) doChangeFocus},
  {"doSetFocus", (XtActionProc) doSetFocus},
  {"doSetModifyFocus", (XtActionProc) doSetModifyFocus},
  {"doChangeModifyFocus", (XtActionProc) doChangeModifyFocus}
};

String btn_action_start = "<Btn1Down>: set() doAction(",
       btn_action_end = ") unset()";

/*
 * 	Global data
 */

XtTranslations pel_trans_table, bp_trans_table;


/* ARGSUSED */
void dummyClbck(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  ;
}

/* ARGSUSED */
static void doNothing(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal num_params;
{
  ;
}

/*
 * - init_actions() -
 * Add all actions and create regularly used translation tables (never
 * freed).
 *
 */
void init_actions(app_context)
     XtAppContext app_context;
{
  String ptr_enter_leave = "<EnterWindow>: set()\n<LeaveWindow>: unset()",
         btn_press = "<Btn1Down>: notify()";

  XtAppAddActions(app_context, action_table, XtNumber(action_table));

  pel_trans_table = XtParseTranslationTable(ptr_enter_leave);
  bp_trans_table = XtParseTranslationTable(btn_press);
} /* init_actions */

/*
 * - init_widgets() -
 *
 *
 */
void init_widgets()
{
  extern Widget toplevel;

  screen = XtScreen(toplevel);
} /* init_widgets */

/*
 * - makeButton() -
 * Make button primitve.
 *
 */
Widget makeButton(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Widget this_widget;
  Arg args[MAXARGS];
  Cardinal count;
  char trans_params[STRINGLEN], translations[STRINGLEN];
  XtTranslations trans_table;
  Cursor hand_cursor = XCreateFontCursor(dpy, XC_hand2);
  int  width, height;
  actionID act_id;
  primActionList action_list = template->action_list;
  String name = template->name;

  count = 0;
  if (template->bitmap_file != NULLString)
    {
      if (get_dims_of_bitmap_file(template->bitmap_file, &width, &height)
	  == TRUE)
	{
	  XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
	  XtSetArg(args[count], XtNheight, (Dimension) height); count++;
	  XtSetArg(args[count], XtNlabel, ""); count++;
	}
    }
  else
    {
      if (template->height != 0)
	{
	  XtSetArg(args[count], XtNheight, template->height); count++;
	}
      
      if (template->width != 0)
	{
	  XtSetArg(args[count], XtNwidth, template->width); count++;
	}

      if (template->label != NULLString)
	{
	  XtSetArg(args[count], XtNlabel, template->label); count++;
	}
    }

  XtSetArg(args[count], XtNresizable, FALSE); count++;
  XtSetArg(args[count], XtNcursor, hand_cursor); count++;

  this_widget = XtCreateManagedWidget((name == NULLString? "button" : name),
				      commandWidgetClass,
				      parent,
				      args,
				      count);

  if (template->bitmap_file != NULLString)
    XtAddCallback(this_widget,
		  XtNdestroyCallback,
		  FreeBackgroundPixmap,
		  (XtPointer) NULL);

  if (action_list != NULLPrimActionList)
    {
      act_id = action_list->prim_action_id;

      (void) sprintf(trans_params, "%d, %d, %d", object_id, BUTTON, act_id);
      
      (void) strcpy(translations, btn_action_start);
      (void) strcat(translations, trans_params);
      (void) strcat(translations, btn_action_end);

      (void) strcat(translations, "\n"); 
    }
  
  XtUninstallTranslations(this_widget);

  trans_table = XtParseTranslationTable(translations);

  XtAugmentTranslations(this_widget, trans_table);
  XtAugmentTranslations(this_widget, pel_trans_table);

  return this_widget;
} /* makeButton */

/*
 * - makeMoveto() -
 * Make `move to' part. Comprises a single asciiTextWidget.
 *
 */
Widget makeMoveto(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget, label, dialog;
  Dimension height;
  Cursor question_cur = XCreateFontCursor(dpy, XC_question_arrow);
  char *trans_start = "<Key>Return: doAction(";
  char *trans_end = ")";
  char trans_params[STRINGLEN], translations[STRINGLEN];
  XtTranslations trans_table;
  actionID act_id;
  primActionList action_list = template->action_list;

  count = 0;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetArg(args[count], XtNcursor, question_cur); count++;

  this_widget = XtCreateManagedWidget("moveto",
				      formWidgetClass,
				      parent,
				      args,
				      count);

  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  label = XtCreateManagedWidget("movetoLabel",
				labelWidgetClass,
				this_widget,
				args,
				count);

  count = 0;
  XtSetArg(args[count], XtNfromHoriz, label); count++;

  XtSetArg(args[count], XtNeditType, XawtextEdit); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainRight); count++;  

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNscrollHorizontal, XawtextScrollWhenNeeded); count++;

  dialog = XtCreateManagedWidget("movetoDialog",
				 asciiTextWidgetClass,
				 this_widget,
				 args,
				 count);

  XtSetKeyboardFocus(this_widget, dialog);

  /* The dialog box has an auto-scrollbar, so need to adjust the height
     of the dialog box to allow for this. */

  count = 0;
  XtSetArg(args[count], XtNheight, &height); count++;
  XtGetValues(dialog, args, count);

  height += 4;

  count = 0;
  XtSetArg(args[count], XtNheight, height); count++;
  XtSetValues(dialog, args, count);

  /* Set action */
  if (action_list != NULLPrimActionList)
    {
      /* ##### Binding and loop! ##### */
      act_id = action_list->prim_action_id;

      (void) sprintf(trans_params, "%d, %d, %d", object_id, MOVETO, act_id);
      
      (void) strcpy(translations, trans_start);
      (void) strcat(translations, trans_params);
      (void) strcat(translations, trans_end);
    }

  trans_table = XtParseTranslationTable(translations);

  XtOverrideTranslations(dialog, trans_table);

  return this_widget;
} /* makeMoveto */

/*
 *
 *
 */
/* ARGSUSED */
Widget makeStatusLabel(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget;

  count = 0;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetArg(args[count], XtNresize, FALSE); count++;
  XtSetArg(args[count], XtNlabel, ""); count++;

  this_widget = XtCreateManagedWidget("statusBar",
				      labelWidgetClass,
				      parent,
				      args,
				      count);

  return this_widget;
} /* makeStatusLabel */

/*
 *
 *
 */
/* ARGSUSED */
Widget makeTitleBar(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget;
  String name = template->name;
  int width, height;

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;

  if (template->bitmap_file != NULLString)
    {
      if (get_dims_of_bitmap_file(template->bitmap_file,&width,&height) ==TRUE)
	{
	  XtSetArg(args[count], XtNwidth, width); count++;
	  XtSetArg(args[count], XtNheight, height); count++;
	  XtSetArg(args[count], XtNlabel, ""); count++;
	}
    }
  else
    {
      if (template->height != 0)
	{
	  XtSetArg(args[count], XtNheight, template->height); count++;
	}
      
      if (template->width != 0)
	{
	  XtSetArg(args[count], XtNwidth, template->width); count++;
	}

      if (template->label != NULLString)
	{
	  XtSetArg(args[count], XtNlabel, template->label); count++;
	}
    }

  XtSetArg(args[count], XtNresize, FALSE); count++;

  XtSetArg(args[count], XtNborderWidth, 0); count++;

  this_widget = XtCreateManagedWidget((name == NULLString? "titleBar" : name),
				      labelWidgetClass,
				      parent,
				      args,
				      count);
  if (template->bitmap_file != NULLString)
    XtAddCallback(this_widget,
		  XtNdestroyCallback,
		  FreeBackgroundPixmap,
		  (XtPointer) NULL);

  return this_widget;
} /* makeTitleBar */

/*
 * makeReadDisplay -
 *
 */
/* ARGSUSED */
Widget makeReadDisplay(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget;
  Widget types, values, form, hscroll, vscroll, name, select_button;

  count = 0;

  XtSetArg(args[count], XtNresize, TRUE); count++;
  XtSetArg(args[count], XtNresizable, FALSE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetArg(args[count], XtNallowHoriz, TRUE); count++;
  XtSetArg(args[count], XtNallowVert, TRUE); count++;

  XtSetArg(args[count], XtNuseRight, TRUE); count++;
  XtSetArg(args[count], XtNuseBottom, TRUE); count++;

  XtSetArg(args[count], XtNforceBars, TRUE); count++;

  this_widget = XtCreateManagedWidget("readDisplay",
				      viewportWidgetClass,
				      parent,
				      args,
				      count);

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNresize, TRUE); count++;
 
  XtSetArg(args[count], XtNdefaultDistance, 8); count++;

  form = XtCreateManagedWidget("readForm",
			       formWidgetClass,
			       this_widget,
			       args,
			       count);

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNlabel, ""); count++;
  
  name = XtCreateManagedWidget("entryName",
			       labelWidgetClass,
			       form,
			       args,
			       count);


  count = 0;
  
  XtSetArg(args[count], XtNfromVert, name); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  select_button = XtCreateManagedWidget("selectForMUA",
					commandWidgetClass,
					form,
					args,
					count);

  XtUninstallTranslations(select_button);
  
  XtAugmentTranslations(select_button, bp_trans_table);
  XtAugmentTranslations(select_button, pel_trans_table);


  count = 0;

  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNeditType, XawtextRead); count++;
  XtSetArg(args[count], XtNstring, ""); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNresize, XawtextResizeBoth); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;
  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;

  XtSetArg(args[count], XtNfromVert, select_button); count++;

  types = XtCreateManagedWidget("readTypes",
                                asciiTextWidgetClass,
				form,
				args,
				count);

  count = 0;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNeditType, XawtextRead); count++;
  XtSetArg(args[count], XtNstring, ""); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNresize, XawtextResizeBoth); count++;

  XtSetArg(args[count], XtNfromHoriz, types); count++;
  XtSetArg(args[count], XtNfromVert, select_button); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;
  XtSetArg(args[count], XtNhorizDistance, 8); count++;

  values = XtCreateManagedWidget("readValues",
				 asciiTextWidgetClass,
				 form,
				 args,
				 count);

  count = 0;

  XtSetArg(args[count], XtNlabel, " "); count++;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNfromHoriz, values); count++;
  XtSetArg(args[count], XtNfromVert, name); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNvertDistance, 12); count++;
  XtSetArg(args[count], XtNhorizDistance, 8); count++;

  (void) XtCreateManagedWidget("photo",
			       labelWidgetClass,
			       form,
			       args,
			       count);

  /* Set dimensions of scrollbars */
  vscroll = XtNameToWidget(this_widget, "vertical");
  if (vscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNwidth, (Dimension) 9); count++;
      XtSetValues(vscroll, args, count);
    }

  hscroll = XtNameToWidget(this_widget, "horizontal");
  if (hscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNheight, (Dimension) 9); count++;
      XtSetValues(hscroll, args, count);
    }

  return this_widget;
} /* makeReadDisplay */

/*
 * - makeSearchGroup() -
 *
 */
/* ARGSUSED */
Widget makeSearchGroup(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count, cindex;
  Widget this_widget, menu_button, menu_shell, menuitem, topmenuitem;

  primInfo prim_data;
  primActionList action_list = template->action_list;

  extern String default_target;

  /* Create parent form */
  count = 0;

  XtSetArg(args[count], XtNdefaultDistance, 16); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  this_widget = XtCreateManagedWidget ("searchGroup",
				       formWidgetClass,
				       parent,
				       args,
				       count);

  /* Create type menu button */
  count = 0;

  XtSetArg(args[count], XtNlabel, "Search for..."); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  menu_button = XtCreateManagedWidget ("typeButton",
				       menuButtonWidgetClass,
				       this_widget,
				       args,
				       count);

  XtOverrideTranslations(menu_button, pel_trans_table);
 
 /* Create menu shell */
  count = 0;
  menu_shell = XtCreatePopupShell ("menu",
				   simpleMenuWidgetClass,
				   menu_button,
				   args,
				   0); 

  /* Keep data for changes in search type */
  prim_data = prim_info_alloc();
  prim_data->object_id = object_id;
  prim_data->action_id = action_list->prim_action_id;
  prim_data->primitive_id = LOOKUP;

  /* Create menu buttons */

  topmenuitem = NULLWidget;

  for (cindex = 0; cindex < target_class_num; cindex++)
    {
      /* Create menu item corresponding to a search type */
      count = 0;
      XtSetArg(args[count], XtNlabel, target_classes[cindex]->target_label);
      menuitem = XtCreateManagedWidget(target_classes[cindex]->target_label,
				       smeBSBObjectClass,
				       menu_shell,
				       args,
				       count);

      if (topmenuitem == NULLWidget)
	topmenuitem = menuitem;
      
      XtAddCallback(menuitem,
		    XtNcallback,
		    changeUfsType,
		    (XtPointer) prim_data);
    }

  XtAddCallback(menu_shell,
		XtNdestroyCallback,
		FreePrimInfo,
		(XtPointer) prim_data);


  /* Create label containing name of current search attribute */
  count = 0;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNlabel, "Person"); count++;
  XtSetArg(args[count], XtNfromHoriz, menu_button); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  (void) XtCreateManagedWidget ("searchTypeLabel",
				labelWidgetClass,
				this_widget,
				args,
				count);

  /* Create the search dialogs */

  searchForType(topmenuitem, prim_data);

  count = 0;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetValues(this_widget, args, count);

  XawFormDoLayout(this_widget, TRUE);

  return this_widget;
} /* makeSearchGroup */

/*
 * - makeListDisplay() -
 *
 */
/* ARGSUSED */
Widget makeListDisplay(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget, form, vscroll, hscroll;
  char *def_read = "<Btn1Down>: doAction(",
       *btn_enter = "<MouseMoved>: Set()",
       *ptr_leave = "<LeaveWindow>: Unset()";
  char *trans_end = ")";
  char trans_params[STRINGLEN], translations[STRINGLEN];
  XtTranslations trans_table;
  actionID act_id;
  primActionList action_list = template->action_list;
  String null_list[1];

  null_list[0] = NULLString;
  
  count = 0;

  XtSetArg(args[count], XtNresize, TRUE); count++;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetArg(args[count], XtNallowHoriz, TRUE); count++;
  XtSetArg(args[count], XtNallowVert, TRUE); count++;

  XtSetArg(args[count], XtNuseRight, TRUE); count++;
  XtSetArg(args[count], XtNuseBottom, TRUE); count++;

  XtSetArg(args[count], XtNforceBars, TRUE); count++;

  this_widget = XtCreateManagedWidget("listDisplay",
				      viewportWidgetClass,
				      parent,
				      args,
				      count);
  count = 0;

  XtSetArg(args[count], XtNlist, null_list); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNrowSpacing, 4); count++;

  XtSetArg(args[count], XtNinternalHeight, 4); count++;
  XtSetArg(args[count], XtNinternalWidth, 6); count++;
   
  XtSetArg(args[count], XtNdefaultColumns, 1); count++;
  XtSetArg(args[count], XtNforceColumns, TRUE); count++;

  form = XtCreateManagedWidget("listForm",
			       listWidgetClass,
			       this_widget,
			       args,
			       count);

  if (action_list != NULLPrimActionList)
    {
      act_id = action_list->prim_action_id;

      (void) sprintf(trans_params, "%d,%d,%d", object_id, ENTRY_LIST, act_id);
      
      (void) strcpy(translations, def_read);
      (void) strcat(translations, trans_params);
      (void) strcat(translations, trans_end);
    }

  (void) strcat(translations, "\n");
  (void) strcat(translations, btn_enter);
  (void) strcat(translations, "\n");
  (void) strcat(translations, ptr_leave);

  trans_table = XtParseTranslationTable(translations);
  XtUninstallTranslations(form);
  XtAugmentTranslations(form, trans_table);

  /*
   * Set dimensions of scrollbars
   */

  vscroll = XtNameToWidget(this_widget, "vertical");

  if (vscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNwidth, 9); count++;
      XtSetValues(vscroll, args, count);
    }

  hscroll = XtNameToWidget(this_widget, "horizontal");

  if (hscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNheight, 9); count++;
      XtSetValues(hscroll, args, count);
    }

  return this_widget;
} /* makeListDisplay */

/*
 * makeHelpDisplay -
 *
 */
/* ARGSUSED */
Widget makeHelpDisplay(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget, form, help_text, vscroll, hscroll;

  count = 0;

  XtSetArg(args[count], XtNresize, TRUE); count++;
  XtSetArg(args[count], XtNresizable, FALSE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetArg(args[count], XtNallowHoriz, TRUE); count++;
  XtSetArg(args[count], XtNallowVert, TRUE); count++;

  XtSetArg(args[count], XtNforceBars, TRUE); count++;
  XtSetArg(args[count], XtNuseRight, TRUE); count++;

  XtSetArg(args[count], XtNuseBottom, TRUE); count++;

  this_widget = XtCreateManagedWidget("helpDisplay",
				      viewportWidgetClass,
				      parent,
				      args,
				      count);


  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNresize, TRUE); count++;

  form = XtCreateManagedWidget("helpViewForm",
			       formWidgetClass,
			       this_widget,
			       args,
			       count);
  

  count = 0;

  XtSetArg(args[count], XtNstring, ""); count++;
  XtSetArg(args[count], XtNeditType, XawtextRead); count++;

  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNresize, XawtextResizeBoth); count++;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNbottom, XtChainTop); count++;
  XtSetArg(args[count], XtNtop, XtChainTop); count++;

  XtSetArg(args[count], XtNright, XtChainLeft); count++;
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;

  help_text = XtCreateManagedWidget("helpText",
				    asciiTextWidgetClass,
				    form,
				    args,
				    count);

  XawTextDisableRedisplay(help_text);

  
  count = 0;
  
  XtSetArg(args[count], XtNfromHoriz, help_text); count++;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNlabel, ""); count++;
  
  XtSetArg(args[count], XtNright, XtChainLeft); count++;
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;

  XtSetArg(args[count], XtNbottom, XtChainTop); count++;
  XtSetArg(args[count], XtNtop, XtChainTop); count++;

  (void) XtCreateManagedWidget("helpBitmap",
			       labelWidgetClass,
			       form,
			       args,
			       count);
  
  
  /*
   * Set dimensions of scrollbars
   */

  vscroll = XtNameToWidget(this_widget, "vertical");

  if (vscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNwidth, 8); count++;

      XtSetValues(vscroll, args, count);
    }

  hscroll = XtNameToWidget(this_widget, "horizontal");

  if (hscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNheight, 8); count++;

      XtSetValues(hscroll, args, count);
    }

  return this_widget;
} /* makeHelpDisplay */


/* 
 * makeModifyWindow -
 *
 */
/* ARGSUSED */
Widget makeModifyWindow(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget, modify_form,
         hscroll, vscroll,
         entry_classes, must_form,
         modify_view, attr_but,
         class_but, modify_name_label, name_edit,
         commit_button, add_button, delete_button;
  int height, width, default_distance = 14;

  Cursor hand_cursor = XCreateFontCursor(dpy, XC_hand2);
  extern void submitModificationsCallbacks(),
              addEntryCallback(),
              deleteEntryCallback();


  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNdefaultDistance, default_distance); count++;

  this_widget = XtCreateManagedWidget("modifyForm",
				      formWidgetClass,
				      parent,
				      args,
				      count);


  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNcursor, hand_cursor); count++;

  commit_button = XtCreateManagedWidget("commitModificationsButton",
					commandWidgetClass,
					this_widget,
					args,
					count);

  XtUninstallTranslations(commit_button);

  XtAugmentTranslations(commit_button, bp_trans_table);
  XtAugmentTranslations(commit_button, pel_trans_table);

  XtAddCallback(commit_button,
		XtNcallback,
		submitModificationsCallback,
		(XtPointer) this_widget);


  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromHoriz, commit_button); count++;
  XtSetArg(args[count], XtNcursor, hand_cursor); count++;

  add_button = XtCreateManagedWidget("addEntryButton",
				     commandWidgetClass,
				     this_widget,
				     args,
				     count);

  XtOverrideTranslations(add_button, pel_trans_table);

  XtAddCallback(add_button,
		XtNcallback,
		addEntryCallback,
		(XtPointer) this_widget);


  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromHoriz, add_button); count++;
  XtSetArg(args[count], XtNcursor, hand_cursor); count++;

  delete_button = XtCreateManagedWidget("deleteEntryButton",
					commandWidgetClass,
					this_widget,
					args,
					count);

  XtOverrideTranslations(delete_button, pel_trans_table);

  XtAddCallback(delete_button,
		XtNcallback,
		deleteEntryCallback,
		(XtPointer) this_widget);


  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromVert, delete_button); count++;

  XtSetArg(args[count], XtNcursor, hand_cursor); count++;

  attr_but = XtCreateManagedWidget("attrMenuButton",
				   menuButtonWidgetClass,
				   this_widget,
				   args,
				   count);


  XtOverrideTranslations(attr_but, pel_trans_table);


  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromHoriz, attr_but); count++;
  XtSetArg(args[count], XtNfromVert, delete_button); count++;

  XtSetArg(args[count], XtNcursor, hand_cursor); count++;

  class_but = XtCreateManagedWidget("classMenuButton",
				    menuButtonWidgetClass,
				    this_widget,
				    args,
				    count);
  
  XtOverrideTranslations(class_but, pel_trans_table);


  count = 0;

  XtSetArg(args[count], XtNsensitive, TRUE); count++;
  XtSetArg(args[count], XtNancestorSensitive, TRUE); count++; /* cheat! */

  (void) XtCreatePopupShell("menu",
			    simpleMenuWidgetClass,
			    class_but,
			    args,
			    count);

  count = 0;
  
  XtSetArg(args[count], XtNstring, ""); count++;
  XtSetArg(args[count], XtNeditType, XawtextRead); count++;
  
  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;

  XtSetArg(args[count], XtNfromHoriz, class_but); count++;
  XtSetArg(args[count], XtNfromVert, delete_button); count++;
  
  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNresize, XawtextResizeBoth); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  entry_classes = XtCreateManagedWidget("modifyEditClass",
					asciiTextWidgetClass,
					this_widget,
					args,
					count);
  
  count = 0;

  XtSetArg(args[count], XtNfromVert, entry_classes); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainRight); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainBottom); count++;

  XtSetArg(args[count], XtNallowHoriz, TRUE); count++;
  XtSetArg(args[count], XtNallowVert, TRUE); count++;

  XtSetArg(args[count], XtNuseRight, TRUE); count++;
  XtSetArg(args[count], XtNuseBottom, TRUE); count++;

  XtSetArg(args[count], XtNforceBars, TRUE); count++;

  if (template->height != 0)
    {
      height = template->height - (default_distance * 3);

      XtSetArg(args[count], XtNheight, (Dimension) height); count++;
    }

  if (template->width != 0)
    {
      width = template->width - (default_distance * 2);

      XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
    }

  modify_view = XtCreateManagedWidget("modifyWindow",
				      viewportWidgetClass,
				      this_widget,
				      args,
				      count);

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;

  modify_form = XtCreateManagedWidget("modifyViewForm",
				      formWidgetClass,
				      modify_view,
				      args,
				      count);

  count = 0;
  
  XtSetArg(args[count], XtNresizable, FALSE); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  modify_name_label = XtCreateManagedWidget("modifyNameLabel",
					    labelWidgetClass,
					    modify_form,
					    args,
					    count);

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNstring, "No entry name supplied"); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNeditType, XawtextEdit); count++;
  XtSetArg(args[count], XtNresize, XawtextResizeWidth); count++;

  XtSetArg(args[count], XtNfromHoriz, modify_name_label); count++;

  name_edit = XtCreateManagedWidget("modifyEntryLabel",
				    asciiTextWidgetClass,
				    modify_form,
				    args,
				    count);

  get_text_dims("No entry name supplied", name_edit, &height, &width);
  
  
  XtSetArg(args[0], XtNheight, (Dimension) height);
  XtSetArg(args[1], XtNwidth, (Dimension) width);
  
  XtSetValues(name_edit, args, 2);
  

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNfromVert, name_edit); count++;

  XtSetArg(args[count], XtNborderWidth, 0); count++;

  must_form = XtCreateManagedWidget("mustViewForm",
				    formWidgetClass,
				    modify_form,
				    args,
				    count);

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNfromVert, must_form); count++;

  XtSetArg(args[count], XtNborderWidth, 0); count++;

  (void) XtCreateManagedWidget("mayViewForm",
			       formWidgetClass,
			       modify_form,
			       args,
			       count);

  /*
   *	Set scrollbar dimensions
   */

  vscroll = XtNameToWidget(modify_view, "vertical");
  if (vscroll != NULLWidget)
    {
      count = 0;

      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNwidth, (Dimension) 9); count++;

      XtSetValues(vscroll, args, count);
    }

  hscroll = XtNameToWidget(modify_view, "horizontal");
  if (hscroll != NULLWidget)
    {
      count = 0;

      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNheight, (Dimension) 9); count++;

      XtSetValues(hscroll, args, count);
    }

  
  return this_widget;
} /* makeModifyWindow */


/* 
 * makeErrorViewer -
 *
 */
/* ARGSUSED */
Widget makeErrorViewer(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget, view_form, hscroll, vscroll;


  count = 0;

  XtSetArg(args[count], XtNallowHoriz, TRUE); count++;
  XtSetArg(args[count], XtNallowVert, TRUE); count++;

  XtSetArg(args[count], XtNuseRight, TRUE); count++;
  XtSetArg(args[count], XtNuseBottom, TRUE); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNforceBars, TRUE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  this_widget = XtCreateManagedWidget("errorWindow",
				      viewportWidgetClass,
				      parent,
				      args,
				      count);

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNdefaultDistance, 14); count++;

  view_form = XtCreateManagedWidget("errorViewForm",
				    formWidgetClass,
				    this_widget,
				    args,
				    count);

  count = 0;
  
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNlabel, "No Errors"); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainRight); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  (void) XtCreateManagedWidget("errorViewLabel",
			       labelWidgetClass,
			       view_form,
			       args,
			       count);

  /*
   *	Set scrollbar dimensions
   */

  vscroll = XtNameToWidget(this_widget, "vertical");
  if (vscroll != NULLWidget)
    {
      count = 0;

      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNwidth, (Dimension) 9); count++;

      XtSetValues(vscroll, args, count);
    }

  hscroll = XtNameToWidget(this_widget, "horizontal");
  if (hscroll != NULLWidget)
    {
      count = 0;

      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNheight, (Dimension) 9); count++;

      XtSetValues(hscroll, args, count);
    }

  return this_widget;
} /* makeErrorViewer */
